unit UCumFreqUtils;

interface

uses Dialogs, UDMCumFreq;

const                         {tbv graphics}

  PosX1=70;
  PosX2=PosX1+500;
  PosY1=50;
  PosY2=PosY1+300;
  MaxLength = 28;              {tbv pathname under DOS}

var
    {Input}
  CalcMethod, ShortDir,
  AuxDir                 : string;
  CalcDone               : boolean;
    {Graphics}
  Ymax, Ymin, Xmax, Xmin,
  Yrmax, Yrmin, Ycmax, Ycmin,
  Maxim, Nfact, BpointRelX,
  BpointRelY                   : real;
  MaxY, MinY, MaxX, MinX       : longint;
  FactorY, FactorX,
  ScaleY, ScaleX, LX, LY,
  DecimY, DecimX               : integer;
  RelXdata, RelYdata, RelZdata : array of integer;
  RelBpointX, RelBpointY         : integer;
  LegendX, LegendY,
  LegendX1, LegendY1,
  LegendX2, LegendY2,
  LegendX3, LegendY3,
  LegendZ                      : string;
  InverseX, InverseY, Small    : boolean;

    {Graphics}
  procedure MaxMin (var Choice : byte);
  procedure Relative (var Choice : byte);
  procedure Legends (var Choice : byte);

implementation


{MaxMin is part of Graphics}
{--------------------------}
procedure MaxMin (var Choice : byte);
var ii, Data : integer;
    DumData : real;

begin
  Ymax  := -1000000;
  Xmax  := -1000000;
  YrMax := -1000000;
  YcMax := -1000000;
  Ymin  := 10000000;
  Xmin  := 10000000;
  YrMin := 10000000;
  YcMin := 10000000;
  FactorX:=1;

  if Choice=1 then for ii:=0 to DMCumFreq.NrOfData-1 do
  with DMCumFreq do
  begin                                         {Cum. Freq. versus X}
    if Ydata[ii]>Ymax then Ymax := Ydata[ii];
    if Xdata[ii]>Xmax then Xmax := Xdata[ii];
    if Ydata[ii]<Ymin then Ymin := Ydata[ii];
    if Xdata[ii]<Xmin then Xmin := Xdata[ii];
  end;
  if Choice=1 then
  begin
    Xmax:=Xmax+0.1*(Xmax-Xmin);
    Xmin:=Xmin-0.1*(Xmax-Xmin);
  end;

  DumData:=0;
  if (Choice=2) or (Choice=6) then with DMCumFreq do
     DumData:=Xdata[NrOfInt-1];

  if (Choice=2) or (Choice=6) then for ii:=0 to DMCumFreq.NrOfInt-1 do
  with DMCumFreq do
  begin                                            {interval data}
    if Xdata[ii]<Xmin   then Xmin  := Xdata[ii];
    if Xdata[ii]>Xmax   then Xmax  := Xdata[ii];
    if Ydata[ii]>Ymax   then Ymax  := Ydata[ii];   {in reality X value}
    if Yrdata[ii]>YrMax then YrMax := Yrdata[ii];
    if Ycdata[ii]>YcMax then YcMax := Ycdata[ii];
    if Yrdata[ii]<YrMin then YrMin := Yrdata[ii];
    if Ycdata[ii]<Ymax  then Ycmin  := Ycdata[ii];
  end;
  if (Choice=2) or (Choice=6) then
  begin
    DMCumFreq.Xdata[DMCumFreq.NrOfData-1]:=DumData;
    YrMin := 0;
    if YrMax<YcMax then YrMax := YcMax;
    if YrMin>YcMin then YrMin := YcMin;
    YrMax:=1.1*YrMax;
    YcMax:=1.1*YcMax;
    if YrMax>100 then YrMax:=100;
    if YcMax>100 then YcMax:=100;
  end;

  if (Choice=3) then
  begin
    for ii:=0 to DMCumFreq.NrOfData-1 do
    with DMCumFreq do
    begin                                           {Xdata versus cum. frq.}
      if Xdata[ii]<Xmin  then Xmin  := Xdata[ii];
      if Xdata[ii]>Xmax  then Xmax  := Xdata[ii];
      if Ycdata[ii]>Ymax then Ymax := Ycdata[ii];
      if Zdata[ii]<Ymin  then Ymin := Zdata[ii];
    end;
    if Ymax>0 then Ymax:=1.1*Ymax;
    if Ymax<0 then Ymax:=0.9*Ymax;
  end;

  if (Choice=4) then
  begin
    Data:=DMCumFreq.NrOfData-1;
    for ii:=0 to Data do
    with DMCumFreq do
    begin                                             {data for return period}
      if Xdata[ii]<Xmin    then Xmin  := Xdata[ii];
      if Xdata[ii]>Xmax    then Xmax  := Xdata[ii];
      if ii<NrOfData-1 then
      begin
        if Yrdata[ii]>Yrmax  then YrMax  := Yrdata[ii];    {calculated}
        if Ycdata[ii]>Ycmax  then YcMax  := Ycdata[ii];    {upper conf. limit}
      end;
    end;
    if YrMax>Ymax then Ymax:=YrMax;
    if YcMax>Ymax then Ymax:=YcMax;
  end;

  if Choice=5 then for ii:=0 to DMCumFreq.NrOfData-1 do
  with DMCumFreq do
  begin                                         {Cum. Freq. versus Rank}
    XData[ii]:=Ydata[ii];                       {obs cum freq}
    YcData[ii]:=Ydata[ii];
    Ydata[ii]:=YrData[ii];                      {calc cum freq}
    Xmin:=0;
    Ymin:=0;
    Xmax:=100;
    Ymax:=100;
  end;

  InverseX:=false;
  if Xmin<0 then if abs(Xmin)>abs(Xmax) then InverseX:=true;

  if not InverseX then
  begin
    if (Xmin>-0.001) and (Xmax<0.01) then
    begin
      FactorX:=1000;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if (Xmin>-0.001) and (Xmax<0.1) and (Xmax>0.01) then
    begin
      FactorX:=100;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if (Xmin>-0.001) and (Xmax<1.1) and (Xmax>0.1) then
    begin
      FactorX:=10;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
  end; {if not InverseX then}

  if InverseX then
  begin
//    if (Xmax<0) and (Xmin>-0.01) then
    if (abs(Xmin)>0.001) and (abs(Xmax)<0.01) then
    begin
      FactorX:=1000;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
//    if (Xmax<0) and (Xmin>-0.1) and (Xmin<-0.01) then
    if (abs(Xmin)>0.001) and (abs(Xmax)<0.1) and (abs(Xmax)>0.01) then
    begin
      FactorX:=100;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
//    if (Xmax<0) and (Xmin<-1) and (Xmin>-0.1) then
    if (abs(Xmin)>0.001) and (abs(Xmax)<1.1) and (abs(Xmax)>0.1) then
    begin
      FactorX:=10;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
  end; {if InverseX then}

  if Xmax<10 then
  begin
    decimX := 1;
    MinX := round (Xmin-0.5);
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<20 then
  begin
    decimX := 1;
    MinX := 2*round ((Xmin-1)/2);
    MaxX := 2*round ((Xmax+1)/2);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<30 then
  begin
    decimX := 1;
    MinX := 3*round ((Xmin-1.5)/3);
    MaxX := 3*round ((Xmax+1.5)/3);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<50 then
  begin
    decimX := 1;
    MinX := 4*round ((Xmin-2)/4);
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<70 then
  begin
    decimX := 1;
    MinX := 5*round ((Xmin-2.5)/5);
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    decimX := 0;
    MinX := 10*round ((Xmin-5)/10);
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    decimX := 0;
    MinX := 25*round ((Xmin-12.5)/25);
    MaxX := 25*round ((Xmax+12.5)/25);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    decimX := 0;
    MinX := 50*round ((Xmin-25)/50);
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    decimX := 0;
    MinX := 100*round ((Xmin-50)/100);
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else if Xmax<2500 then
  begin
    decimX := 0;
    MinX:=round (Xmin)-100;
    MaxX:=round (Xmax)+100;
    ScaleX := (MaxX-MinX) div 250;
  end
  else if Xmax<5000 then
  begin
    decimX := 0;
    MinX:=round (Xmin)-250;
    MaxX:=round (Xmax)+250;
    ScaleX := (MaxX-MinX) div 500;
  end
  else if Xmax<10000 then
  begin
    decimX := 0;
    MinX:=round (Xmin)-500;
    MaxX:=round (Xmax)+500;
    ScaleX := (MaxX-MinX) div 1000;
  end
  else if Xmax<25000 then
  begin
    decimX := 0;
    MinX:=round (Xmin)-1000;
    MaxX:=round (Xmax)+1000;
    ScaleX := (MaxX-MinX) div 2500;
  end
  else if Xmax<50000 then
  begin
    decimX := 0;
    MinX:=round (Xmin)-2500;
    MaxX:=round (Xmax)+2500;
    ScaleX := (MaxX-MinX) div 5000;
  end
  else
  begin
    decimX := 0;
    MinX:=round (Xmin)-5000;
    MaxX:=round (Xmax)+5000;
    ScaleX := (MaxX-MinX) div 10000;
  end;

  if (Choice=1) then
  begin
    decimY := 0;
    Ymin :=0;
    MinY := 0;
    MaxY := 120;
    ScaleY := 12;
  end;

  if (Choice=2) or (Choice=6) then
  begin
    decimY := 1;
    MinY   := 0;
    MaxY   := 10*round ((YrMax+15)/10);
    ScaleY := MaxY div 10;
  end;

  if (Choice=4) then
  begin
    decimY := 0;
    if Ymax<50 then  decimY:=1;
    Ymin :=0;
    MinY := 0;
    MaxY := round(1.1*Ymax);
    ScaleY := 10;
  end;

  FactorY:=1;

  if (Choice>2) and (Choice<6) then
                        {start of condition Choice=3 or 4 for conf. belt -----}
  begin

    InverseY:=false;
    if Ymin<0 then if abs(Ymin)>abs(Ymax) then InverseY:=true;

    if not InverseY then
    begin
    if (Ymin>0) and (Ymax<0.01) then
    begin
      FactorY:=1000;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin>0) and (Ymax<0.1) and (Ymax>0.01) then
    begin
      FactorY:=100;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin>0) and (Ymax<1) and (Ymax>0.1) then
    begin
      FactorY:=10;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;

  end; {if (Choice>2) and (Choice<6) then}

  if InverseY then
  begin
    if (Ymax<0) and (Ymin>-0.01) then
    begin
      FactorY:=1000;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymax<0) and (Ymin>-0.1) and (Ymin<-0.01) then
    begin
      FactorY:=100;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymax<0) and (Ymin>-1) and (Ymin<-0.1) then
    begin
      FactorY:=10;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
  end; {if InverseY}

  if Ymax<10 then
  begin
    decimY := 1;
    MinY := round (Ymin-0.5);
    MaxY := round (Ymax+0.5);
    ScaleY := MaxY-MinY;
    if ScaleY>10 then ScaleY := (MaxY-MinY) div 2;
  end
  else if Ymax<20 then
  begin
    decimY := 1;
    MinY := 2*round ((Ymin-1)/2);
    MaxY := 2*round ((Ymax+1)/2);
    ScaleY := MaxY-MinY;
  end
  else if Ymax<30 then
  begin
    decimY := 1;
    MinY := 3*round ((Ymin-1.5)/3);
    MaxY := 3*round ((Ymax+1.5)/3);
    ScaleY := MaxY-MinY;
  end
  else if Ymax<50 then
  begin
    decimX := 1;
    MinX := 4*round ((Xmin-2)/4);
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Ymax<70 then
  begin
    decimY := 1;
    MinY := 5*round ((Ymin-2.5)/5);
    MaxY := 5*round ((Ymax+2.5)/5);
    ScaleY := (MaxY-MinY) div 5;
  end
  else if Ymax<100 then
  begin
    decimY := 0;
    MinY := 10*round ((Ymin-5)/10);
    MaxY := 10*round ((Ymax+5)/10);
    ScaleY := (MaxY-MinY) div 10;
  end
  else if Ymax<250 then
  begin
    decimY := 0;
    MinY := 25*round ((Ymin-12.5)/25);
    MaxY := 25*round ((Ymax+12.5)/25);
    ScaleY := (MaxY-MinY) div 25;
  end
  else if Ymax<500 then
  begin
    decimY := 0;
    MinY := 50*round ((Ymin-25)/50);
    MaxY := 50*round ((Ymax+25)/50);
    ScaleY := (MaxY-MinY) div 50;
  end
  else if Ymax<1000 then
  begin
    decimY := 0;
    MinY := 100*round ((Ymin-50)/100);
    MaxY := 100*round ((Ymax+50)/100);
    ScaleY := (MaxY-MinY) div 100;
  end
  else if Ymax<2500 then
  begin
    decimY := 0;
    MinX:=round (Xmin)-100;
    MaxX:=round (Xmax)+100;
    ScaleY := (MaxY-MinY) div 250;
  end
  else if Ymax<5000 then
  begin
    decimY := 0;
    MinX:=round (Xmin)-250;
    MaxX:=round (Xmax)+250;
    ScaleY := (MaxY-MinY) div 500;
  end
  else if Ymax<10000 then
  begin
    decimY := 0;
    MinX:=round (Xmin)-500;
    MaxX:=round (Xmax)+500;
    ScaleY := (MaxY-MinY) div 1000;
  end
  else if Ymax<25000 then
  begin
    decimY := 0;
    MinX:=round (Xmin)-1000;
    MaxX:=round (Xmax)+1000;
    ScaleY := (MaxY-MinY) div 2500;
  end
  else if Ymax<50000 then
  begin
    decimY := 0;
    MinX:=round (Xmin)-2500;
    MaxX:=round (Xmax)+2500;
    ScaleY := (MaxY-MinY) div 5000;
  end
  else
  begin
    decimY := 0;
    MinX:=round (Xmin)-5000;
    MaxX:=round (Xmax)+5000;
    ScaleY := (MaxY-MinY) div 10000;
  end;
  
  end; { end of condition Choice > 2 }
  {------------------------------------}

  if ScaleX>10 then ScaleX:=10;
  if (ScaleY>10) and (Choice>1) then ScaleY:=10;
  if ScaleX<4 then ScaleX:=4;
  if ScaleY<4 then ScaleY:=4;

end;
{end of MaxMin}
{-------------}


{Relative is part of Graphics}
{----------------------------}
procedure Relative (var Choice : byte);
var  ii, DataNr : integer;
     XdataRel,YdataRel,ZdataRel : real;
begin

  if (Choice=2) or (Choice=6) then
      DataNr:=DMCumFreq.NrOfInt else DataNr:=DMCumFreq.NrOfData;

  SetLength (RelXdata,DataNr+1);
  SetLength (RelYdata,DataNr+1);
  SetLength (RelZdata,DataNr+1);

  with DMCumFreq do for ii:=0 to DataNr-1 do
  begin
    XdataRel := LX*(DMCumFreq.Xdata[ii]-MinX)/(MaxX-MinX);
    RelXdata[ii] := PosX1+round(XdataRel);
    YdataRel := LY*(DMCumFreq.Ydata[ii]-MinY)/(MaxY-MinY);
    RelYdata[ii] := PosY2-round(YdataRel)-10;
    ZdataRel := LY*(DMCumFreq.Zdata[ii]-MinY)/(MaxY-MinY);
    RelZdata[ii] := PosY2-round(ZdataRel)-10;
  end;

end;
{---------------}
{end of Relative}



{Legends is part of Graphics}
{---------------------------}
procedure Legends ;
begin

  if Choice=1 then LegendY := 'Cumulative frequency (%)';
  if (Choice=2) or (Choice=6) then LegendY := 'Interval frequency (%)';
  if (Choice=3) then
  begin
    if FactorY=1 then LegendY := 'X-data';
    if FactorY=10 then LegendY := 'X-data * 10';
    if FactorY=100 then LegendY := 'X-data * 100';
    if FactorY=1000 then LegendY := 'X-data * 1000';
  end;
  if Choice=4 then LegendY := 'Return period';
  if Choice=5 then LegendY := 'Cumulative frequency calculated (%)';

  LegendX := '         X-Data';
  if FactorX=10 then LegendX := '       X-data * 10';
  if FactorX=100 then LegendX := '      X-data * 100';
  if FactorX=1000 then LegendX := '     X-data * 1000';

  if Choice=5 then LegendX := 'Cumulative frequency observed (%)';

  LegendY1 := '  o    observed';
  LegendX1 := '-----  calculated';
  LegendZ :=  '- - -  90% conf. limit';
  if Choice=2 then
  begin
    LegendY2 := '  #    observed';
    LegendX2 := '____calculated';
  end;
  if Choice=6 then
  begin
    LegendX2 := ' ';
    LegendY2 := '____observed';
  end;
  if Choice=3 then LegendX3 :=  '----- observed/calculated';

  end;
{end of Legends}
{--------------}

end.
