unit UDMCumFreq;

interface

uses
   SysUtils, Classes, Dialogs, Forms, Controls;

type DataArrayR = array of extended;
     DataArrayI = array of integer;
     LineSet = array of string;
     RemoveSet = array of boolean;
type
  TDMCumFreq = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
  public
    FileName, Title1, Title2: string;
    SerialNr : DataArrayI;
    DataValue: DataArrayR;
    Xdata,Ydata,YrData,Xvalue,
    YcData,Zdata,HlpData    : DataArrayR;
    Threshold,AvAbsDiff,
    XatBP, YatBP            : real;
    FileLine                : LineSet;
    ToBeRemoved             : RemoveSet;
    NrOfData, NrOfLInes,
    TmpNrOfData, DistrType,
    NrOfInt, NrOfVal        : integer;
    NrOfClasses             : string;
    Preference              : string[4];
    MethNr                  : integer;
    Allowed, Disconti, Scarce : boolean;

    procedure ReadInputFile;
    procedure WriteInputFile (const DocName: string);
    procedure ReadOutputLines(const DocName: string; var OutputOk : boolean);
    procedure ReadOutputData(const GraphType : byte);
    procedure program_error(const Warning: string);
    function  Question(const Query: string): boolean;
  private
    { Private declarations }
  end;

var
  DMCumFreq: TDMCumFreq;

implementation

uses UMainForm;

{$R *.dfm}



procedure TDMCumFreq.DataModuleCreate(Sender: TObject);
var InitialDir: string;
begin
  getdir (0,InitialDir);
  FileName:=InitialDir;
end;


procedure TDMCumFreq.ReadInputFile;
var  InFile: textfile;
     AuxTxt: string[3];
     k, Finish : integer;
     A : string[1];
begin
  Assignfile(InFile, FileName);
  {$I-} Reset(InFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + filename + '"could not be opened. It may be ' +
      'in use by another program');
    exit;
  end;
  for k:=1 to 3 do readln(InFile);
  readln (InFile,A,Title1);
  A:='';
  readln (InFile,A,Title2);
  A:='';
  for k:=1 to 4 do readln (InFile);
  readln (Infile,AuxTxt);
  Allowed:=false;
  Finish:=4;
  if Auxtxt='' then Finish:=3;
  for k:=1 to Finish do readln (InFile);
  k:=0;
  Try while not eof(Infile) do
      begin
        k:=k+1;
        SetLength(SerialNr,k+1);
        SetLength(DataValue,k+1);
        SetLength(ToBeRemoved,k+1);
        ToBeRemoved[k-1] := false;
        readln(InFile,SerialNr[k-1],DataValue[k-1]);
        NrOfData:=k;
      end;
  Except on E: exception
      do    Program_error('Real numbers in the inputfile "' + filename +
                          '" are invalid');
  end;
  Mainform.NrOfDataEdit.text:=inttostr(NrOfData);
  Closefile(InFile);
end; {TDMCumFreq.ReadInputFile}



procedure TDMCumFreq.WriteInputFile (const DocName: string);
label 1;
var  InFile: textfile;
     k, m, TmpNrOfData: integer;
     Again : boolean;
begin
  Again := false;
  TmpNrOfData:=NrOfData;
1:Assignfile(InFile, FileName);
  {$I-} Rewrite(InFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + filename + '"could not be opened. It may be ' +
      'in use by another program');
    exit;
  end;
  writeln (InFile,' Input data for CumFreq program');
  writeln (InFile,' Cumulative frequency analysis');
  writeln (InFile);
  writeln (InFile,' ',Title1);
  writeln (InFile,' ',Title2);
  writeln (InFile);
  writeln (InFile,' Filename: ',Filename);
  writeln (InFile,' Number of data: ',NrOfData);
  writeln (InFile,' Threshold: not used');
  if MainForm.OptionComboBox.ItemIndex=0 then
     writeln (Infile,' No Composite distributions allowed')
  else
     writeln (Infile,' Composite distributions are allowed');
  writeln (InFile);
  writeln (InFile, ' ------------------');
  writeln (InFile, ' Serial    Variable');
  writeln (InFile, ' ------------------');
  m:=0;
  setlength (ToBeRemoved,TmpNrOfDaTA+1);
  Try for k:=1 to TmpNrOfData do
      if TobeRemoved[k-1]=false then
      begin
        m:=m+1;
        if DataValue[k-1]>=1 then
           writeln(InFile, m:5,' ',DataValue[k-1]:10:2)
        else
           writeln(InFile, m:5,' ',DataValue[k-1]:10);
      end else
        if not Again then NrOfData:=NrOfData-1;
  Except on E: exception
      do    Program_error('Real numbers in the inputfile "' + filename +
                  '" are invalid');
  end;
  if not Again and (NrOfData<TmpNrOfData) then
  begin
    Closefile(InFile);
    Again := true;
    goto 1;
  end;
  MainForm.NrOfDataEdit.Text:=inttostr(NrOfData);
  Closefile(InFile);
end; {TDMCumFreq.WriteInputFile}



procedure TDMCumFreq.ReadOutputLines(const DocName: string;
                                     var OutputOk : boolean);
var  OutFile: textfile;
     HelpStr:string[5];
     OutLine:string;

begin
  AssignFile(OutFile,DocName);
  {$I-} Reset(OutFile); {$I+}
  if ioresult <> 0 then
  begin
     Showmessage('The file "' + DocName +
                 '" could not be opened.  It may be damaged,'  +
                 '  not created due to inadequate input data,' +
                 '  or in use by another program');
    exit;
  end;
  OutputOk := true;

  MainForm.OutputMemo.Lines.Clear;
  MainForm.OutputMemo.Visible:=false;
  while not eof(OutFile) do
  begin
    readln (OutFile,OutLine);
    MainForm.OutputMemo.Lines.Add(OutLine);
  end;
  Closefile (OutFile);
  MainForm.OutputMemo.Visible:=true;

  FileName := ChangeFileExt (FileName,'.aux');
  if FileExists(FileName) then
  begin
    assignfile (OutFile,DMCumFreq.FileName);
    reset (OutFile);
    readln (OutFile,HelpStr);
    if HelpStr=' Para' then readln (OutFile,MethNr)
    else MethNr:=strtoint(HelpStr);
    closefile (OutFile);
  end else
  begin
    MethNr:=0;
    Showmessage (' If you wish to make use of the calculator, run'+
                 ' the program again');
  end;
  FileName := ChangeFileExt (FileName,'.out');

end; {TCumFreq.ReadOutputLines}


procedure TDMCumFreq.ReadOutputData (const GraphType : byte);
var  OutFile: textfile;
     i, k, NrOfVal : integer;
     Detector : string[4];
     A : string[1];
     Str25 : string[25];
     Str21 : string[21];
     Str9  : string[9];
     Rvar, Xmax, Xmin  : real;
begin
  FileName:=ChangeFileExt(FileName,'.aux');
  AssignFile(OutFile,FileName);
  {$I-} Reset(OutFile); {$I+}
  readln (OutFile,Detector);
  if Detector=' Par' then readln (OutFile,DistrType)
  else DistrType:=strtoint(Detector);
  closefile (OutFile);
  FileName:=ChangeFileExt(FileName,'.out');
  AssignFile(OutFile,FileName);
  {$I-} Reset(OutFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + FileName + '"could not be opened.' +
                ' It may be damaged,  not created due to inadequate' +
                ' input data,  in use by another program,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
    for k:=1 to 3 do readln (OutFile);
    readln (OutFile,A,Title1);
    A:='';
    readln (OutFile,A,Title2);
    readln (OutFile);
    readln (OutFile,Str21,NrOfVal);
    readln (OutFile);
    readln (OutFile);
    Disconti:=false;
    read(OutFile,Str9);
    if Str9=' The sepa' then
    begin
       readln (OutFile,Str21,XatBP);
       Disconti:=true;
    end else readln (OutFile);
    if Str9<>' The sepa' then
    begin
      read(OutFile,Str9);
      if Str9=' The sepa' then
      begin
        readln (OutFile,Str21,XatBP);
        Disconti:=true;
      end else readln (OutFile);
    end;
    Detector := '    ';
    if (GraphType=1) or (GraphType=5) then while not (Detector=' Obs') do
          readln (OutFile,Detector);                     {Cum. Freq. Distr}
    if (GraphType=2) or (GraphType=6) then while not (Detector=' Int') do
          readln (OutFile,Detector);                     {Interval Analysis}
    if GraphType=3 then while not (Detector=' Con') do
          readln (OutFile,Detector);                     {Conf. belts of X}
    if GraphType=4 then while not (Detector=' Ret') do
          readln (OutFile,Detector);                     {Return periods}
    if GraphType=3 then
       for k:=1 to 5 do readln (OutFile)
    else
       for k:=1 to 4 do readln (OutFile);
    NrOfData := 0;
    while not (Detector = ' ---') do
    begin
      readln (OutFile,Detector);
      NrOfData := NrOfData+1;
    end;
    NrOfData:=NrOfData-1;
    Reset (OutFile);
    if (GraphType=1) or (GraphType=5) then while not (Detector=' Obs') do
          readln (OutFile,Detector);
    if (GraphType=2) or (GraphType=6) then while not (Detector=' Int') do
          readln (OutFile,Detector);
    if GraphType=3 then while not (Detector=' Con') do
          readln (OutFile,Detector);
    if GraphType=4 then while not (Detector=' Ret') do
          readln (OutFile,Detector);
    if GraphType=3 then
       for k:=1 to 5 do readln (OutFile)
    else
       for k:=1 to 4 do readln (OutFile);
    SetLength (Xdata,NrOfData+1);
    SetLength (Ydata,NrOfData+1);
    SetLength (Yrdata,NrOfData+1);
    SetLength (Zdata,NrOfData+1);
    SetLength (Ycdata,NrOfData+1);
    NrOfInt:=0;
    i:=0;
    for k:=0 to NrOfData-1 do
    begin
      if (GraphType=1) or (GraphType=5) then
      begin
        readln (OutFile,Xdata[k],Ydata[k],Ydata[k],YrData[k],Zdata[k],Zdata[k],
                        YcData[k]);
                       {Xdata=X,Ydata=Rank,YrData=Calc,Zdata=Lower,YcData=Upper}
        if Disconti and (Xdata[k]<XatBP) then i:=i+1;
        setlength (Xvalue,k+1);
        Xvalue[k]:=Xdata[k];
        NrOfVal:=NrOfData;
      end;
      if (GraphType=2) or (GraphType=6) then
      begin
        readln (OutFile,Xdata[k],Ydata[k],YrData[k],YcData[k]);
                      {Xdata=Lower,Ydata=Upper,Yr=Obs,Yc=Calc}
        if(GraphType=6) then
        begin
          Rvar:=YrData[k];
          YrData[k]:=YcData[k];
          YcData[k]:=Rvar;
        end;
        NrOfInt:=NrOfInt+1;
      end;
      if (GraphType=3) then
        readln (OutFile,Xdata[k],Ydata[k],YrData[k],Zdata[k],YcData[k]);
                 {Xdata=X,Ydata=Rank,YrData=Calc,Zdata=Lower,YcData=Upper}
      if GraphType=4 then
        readln (OutFile,Xdata[k],Ydata[k],Ydata[k],YrData[k],Zdata[k],
                        YcData[k]);
                 {Xdata=X,Ydata=Rank,YrData=Calc,Zdata=lower,YcData=upper}
    end;
    if (GraphType=1) then
    begin
      YatBp:=YrData[i+2];
      readln (OutFile,Str25);
      readln (OutFile,Str25);
      readln (OutFile,Str25,Str25);
      while Pos('%',Str25)>0 do delete(Str25,Pos('%',Str25),1);
      AvAbsDiff:=MainForm.stringtofloat(Str25);
      Scarce:=false;
      k:=NrOfVal;
      for i:=0 to NrOfVal-1 do
          if i>0 then if Xdata[i]=Xdata[i-1] then k:=k-1;
      if k<10 then
         Scarce:=true;
      XMax:=-1000000;
      Xmin:=1000000;
      for i:=0 to NrOfVal-1 do
      begin
        if Xdata[i]>Xmax then Xmax := Xdata[i];
        if Xdata[i]<Xmin then Xmin := Xdata[i];
      end;
      for i:=0 to NrOfVal-2 do if abs(Xdata[i+1]-Xdata[i])>0.3*(Xmax-Xmin) then
          Scarce:=true;
    end;
    if NrOfData>50 then Scarce:=false;
    NrOfData:=NrOfVal;
  Close(OutFile);
end; {TDMCumFreq.ReadOutputData}


procedure TDMCumFreq.program_error(const Warning: string);
begin Showmessage('A program error occurred.' + Warning);
      Application.Terminate;
end; {TDMCumFreq.program_error}


function TDMCumFreq.Question(const Query: string): boolean;
begin Result := MessageDlg(Query, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end; {TDMEnDrain.Question}


end.
