unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, StdCtrls, ComCtrls, StdActns, ActnList, Menus,
  ExtCtrls, ShellApi, Grids, Clipbrd;

type
  TSerialArrayE = array of TEdit;
  TValuesArrayE = array of TEdit;
  TMainForm = class(TBaseForm)
{Menu and general}
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditDelete1: TEditDelete;
    Edit: TMenuItem;
    Copy: TMenuItem;
    Cut: TMenuItem;
    Paste: TMenuItem;
    InputSaveMenu: TMenuItem;
    InputOpenMenu: TMenuItem;
    GraphOpenMenu: TMenuItem;
    FileItem: TMenuItem;
    OutputOpenMenu: TMenuItem;
    ProgramExit: TMenuItem;
    InputOpenDialog: TOpenDialog;
    GraphOpenDialog: TOpenDialog;
    OutputOpenDialog: TOpenDialog;
    InputSaveDialog: TSaveDialog;
    GraphSaveDialog: TSaveDialog;
    PageControl1: TPageControl;
    IntroTabSheet: TTabSheet;
    InputTabSheet: TTabSheet;
    OutputTabSheet: TTabSheet;
    GraphicsTabSheet: TTabSheet;
{Intro and Input}
    IntroMemo: TMemo;
    ContMemo: TMemo;
    DisConMemo: TMemo;
    ConfMemo: TMemo;
    IntervalMemo: TMemo;
    WaitMemo: TMemo;
    FileExit1: TFileExit;
    FileNameEdit: TEdit;
    Title1Edit: TEdit;
    Title2Edit: TEdit;
    NrOfDataEdit: TEdit;
    ThresholdEdit: TEdit;
    NrOfClassesEdit: TEdit;
    InputSaveAction: TAction;
    InputOpenAction: TAction;
    OutputOpenAction: TAction;
    GraphOpenAction: TAction;
    SerialLabel: TLabel;
    ValueLabel: TLabel;
    FileNameLabel: TLabel;
    Title1Label: TLabel;
    Title2Label: TLabel;
    NrOfDataLabel: TLabel;
    OptionLabel: TLabel;
    ThresholdLabel: TLabel;
    NrOfClassesLabel: TLabel;
    OptionComboBox: TComboBox;
    InputOpenButton: TButton;
    InputSaveButton: TButton;
    ClearButton: TButton;
    StringGrid1: TStringGrid;
{Output and Grapics}
    OutputMemo: TMemo;
    PasteHelpMemo: TMemo;
    ChoicesPanel: TPanel;
    HelpGroupBox: TGroupBox;
    GraphicsRadioGroup: TRadioGroup;
    CumulativeRadioButton: TRadioButton;
    IntervalRadioButton: TRadioButton;
    X_ConfidenceRadioButton: TRadioButton;
    ReturnRadioButton: TRadioButton;
    QQRadioButton: TRadioButton;
    SeeGraphButton: TButton;
    SeeOutputButton: TButton;
    ViewGraphButton: TButton;
    CalcButton: TButton;
    GoButton: TButton;
    MakeGraphButton: TButton;
    SaveGraphButton: TButton;
    SaveBlWhButton: TButton;
    ContButton: TButton;
    DisContButton: TButton;
    ConfButton: TButton;
    InterButton: TButton;
    SelectButton: TButton;
    PasteHelpButton: TButton;
    BackButton: TButton;
    ConfBeltButton: TButton;
    GraphImage: TImage;
    PictureImage: TImage;
    FitButton: TButton;
    FitPanel: TPanel;
    FitMemo: TMemo;
    CloseFitButton: TButton;
    OptButton: TButton;
    ListButton: TButton;
    SelectionLabel: TLabel;
    SelectionEdit: TEdit;
    SelectionButton: TButton;
    histoRadioButton: TRadioButton;
    AmpliMemo: TMemo;
    {Start}
    procedure FormCreate(Sender: TObject);
    {Intro}
    procedure IntroTabSheetShow(Sender: TObject);
    procedure ContButtonClick(Sender: TObject);
    procedure DisContButtonClick(Sender: TObject);
    procedure InterButtonClick(Sender: TObject);
    procedure ConfButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    {Input}
    procedure InputTabSheetShow(Sender: TObject);
    procedure InputOpenActionExecute(Sender: TObject);
    procedure NrOfDataEditExit(Sender: TObject);
    procedure OptionComboBoxChange(Sender: TObject);
    procedure NrOfClassesEditClick(Sender: TObject);
    procedure NrOfClassesEditExit(Sender: TObject);
    procedure DistrWarning;
    procedure PasteHelpButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure HintButtonClick(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol,
              ARow: Integer; const Value: String);
    procedure HandlePasteMultiCell(Sender: TObject; ACol,
                     ARow: Integer; const Value: String);
    function StringToFloat(Str : string) : double;
    procedure InputSaveActionExecute(Sender: TObject);
    {Output}
    procedure OutputTabSheetShow(Sender: TObject);
    procedure OutputOpenActionExecute(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure CalcButtonClick(Sender: TObject);
    procedure FitButtonClick(Sender: TObject);
    procedure CloseFitButtonClick(Sender: TObject);
    procedure OptButtonClick(Sender: TObject);
    procedure ListButtonClick(Sender: TObject);
    procedure OutputTabSheetExit(Sender: TObject);
    {graphics}
    procedure GraphicsTabSheetShow(Sender: TObject);
    procedure ViewGraphButtonClick(Sender: TObject);
    procedure MakeGraphButtonClick(Sender: TObject);
    procedure GraphOpenActionExecute(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure SaveGraphButtonClick(Sender: TObject);
    procedure SaveBlWhButtonClick(Sender: TObject);
    procedure ConfBeltButtonClick(Sender: TObject);
    {Close}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SelectionButtonClick(Sender: TObject);
  private
    NoSave,
    GraphOpened, OutputOpened,
    OutputTab, Import, Color  : boolean;
    InitNrOfData, Finish,
    RefNrOfData, RefNr        : integer;
    InitDir, AuxFile          : string;
    TypeOfGraph               : byte;
    function SetAndVerifySaveName : boolean;
    procedure DoCalculations;
    procedure RankList;
    procedure ShowGraphics;
    procedure HideGraphicsButtons;
  public
    { Public declarations }
    InputOpened, ConfBelt, Removed : boolean;
    InitDecSep : char;
    TotNrOfData : integer;
    procedure ShowData (var Finish : integer);
  end;

var
  MainForm: TMainForm;

implementation

uses UDMCumFreq, UFinishForm, UCumFreqUtils, UFreqCalc, UCalcForm,
     UOptForm, UListForm, USelectForm;

{$R *.dfm}


{----------------------------------------------------------------------
 START
 ----------------------------------------------------------------------}


procedure TMainForm.FormCreate(Sender: TObject);
begin
  inherited;
      PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
      getdir (0,InitDir);
      MainForm.InputOpenDialog.InitialDir:=InitDir;
      MainForm.InputSaveDialog.InitialDir:=InitDir;
      MainForm.OutputOpenDialog.InitialDir:=InitDir;
      Title1Edit.Text := '';
      Title2Edit.Text := '';
      PasteHelpMemo.Visible := false;
      PasteHelpButton.Caption := 'Paste help';
      InputOpened := false;
      OutputOpened := false;
      GraphOpened := false;
      FileNameLabel.Visible := false;
      FileNameEdit.Visible := false;
      ConfBelt := true;
      CalcDone:=false;
      StringGrid1.Visible := true;
      Color:=true;
      LX := posX2-posX1;
      LY := posY2-posY1;
      Left := 100;
      if screen.Width > 860 then
            Width := 760
      else if screen.Width < width then
      begin
        Left := 5;
        Width := screen.Width-5;
      end;
end;{TMainForm.FormCreate}


{----------------------------------------------------------------------
 INTRO
 ----------------------------------------------------------------------}


procedure TMainForm.IntroTabSheetShow(Sender: TObject);
begin
  inherited;
  {hier wordt de IntroMemo getoond}
  StatusText ('Click on the Input tab to proceed.');
  InputSaveAction.Enabled := false;
  IntroMemo.Visible := true;
  ContMemo.Visible := false;
  DisConMemo.Visible := false;
  ConfMemo.Visible := false;
  IntervalMemo.Visible := false;
end; {TMainForm.IntroTabSheetShow}


procedure TMainForm.ContButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    ContMemo.Visible := true;
    DisConMemo.Visible := false;
    ConfMemo.Visible := false;
    IntervalMemo.Visible := false;
end; {TMainForm.ContButtonClick}


procedure TMainForm.DisContButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    ContMemo.Visible := false;
    DisConMemo.Visible := true;
    ConfMemo.Visible := false;
    IntervalMemo.Visible := false;
end; {TMainForm.DisContButtonClick}



procedure TMainForm.ConfButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    ContMemo.Visible := false;
    DisConMemo.Visible := false;
    ConfMemo.Visible := true;
    IntervalMemo.Visible := false;
end; {TMainForm.ConfButtonClick}


procedure TMainForm.InterButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := false;
    ContMemo.Visible := false;
    DisConMemo.Visible := false;
    ConfMemo.Visible := false;
    IntervalMemo.Visible := true;
end; {InterButtonClick}


procedure TMainForm.BackButtonClick(Sender: TObject);
begin
  inherited;
    IntroMemo.Visible := true;
    ContMemo.Visible := false;
    DisConMemo.Visible := false;
    ConfMemo.Visible := false;
    IntervalMemo.Visible := false;
end; {BackButtonClick}


{----------------------------------------------------------------------
 INPUT
 ----------------------------------------------------------------------}


procedure TMainForm.InputTabSheetShow(Sender: TObject);
begin
  inherited;
      StatusText('Enter data or use "Open" to see examples under' +
            ' "Data" or to edit existing files. Thereafter use' +
            ' "Save-Run".');
      Import := false;
      InputSaveAction.Enabled := true;
      if not InputOpened then with DMCumFreq do
      begin
        NrOfClasses := '5';
        NrOfClassesEdit.Text:='5';
        Preference := '1';
        FileNameLabel.Visible:=false;
        FileNameEdit.Visible:=false;
        OptionComboBox.ItemIndex := 0;
        InitNrOfData:=15;
        NrOfData:=15;
        Finish := 14;
        StringGrid1.ColCount := 2;
        StringGrid1.RowCount := 12;
        SetLength(DataValue,Finish+1);
      end else
      begin
        if not OutputOpened then
        begin
          DMCumFreq.NrOfData:=RefNrOfData;
          InitNrOfData:=RefNrOfData;
          Finish:=RefNrOfData-1;
        end else
        begin
          if (TypeOfGraph=2) or (TypeOfGraph=6) then
              DMCumFreq.NrOfData:=TotNrOfData;
          InitNrOfData:=DMCumFreq.NrOfData;
          Finish:=DMCumFreq.NrOfData-1;
          RefNr:=DMCumFreq.NrOfData;
        end;
      end;
      StringGrid1.ColWidths[0] := 62;
      StringGrid1.ColWidths[1] := 85;
      DisCon:=false;
      Additional:=false;
      CalcDone:=false;
      ShowData(Finish);
end; {TMainForm.InputTabSheetShow}



procedure TMainForm.ShowData(var Finish : integer);
var NN, k: integer;
begin
      NrOfDataEdit.Text:=IntToStr(DMCumFreq.NrOfData);
      RefNrOfData:=DMCumFreq.NrOfData;
      StringGrid1.RowCount := Finish+1;
      NN:=Finish;
      if RefNr>Finish then NN:=RefNr;
      SetLength(DMCumFreq.ToBeRemoved,NN+1);
      setlength (DMCumFreq.SerialNr,NN+1);
      setlength (DMCumFreq.DataValue,NN+1);
      For k := 0 to Finish do
      begin
        StringGrid1.EditorMode := true;
        DMCumFreq.ToBeRemoved[k] := false;
          StringGrid1.RowHeights[k] := 20;
        if not InputOpened then
        begin
          StringGrid1.Cells[0,k] := IntToStr(k+1);
          StringGrid1.Cells[1,k] := '0';
        end else
        begin
          StringGrid1.Cells[0,k] := IntToStr(DMCumFreq.SerialNr[k]);
          StringGrid1.Cells[1,k] := FloatToStr(DMCumFreq.DataValue[k]);
        end;
      end;

      if not OutputOpened and (DMCumFreq.NrOfData>RefNr) then
      for k := RefNr+1 to DMCumFreq.NrOfData do
      begin
         StringGrid1.Cells[1,k-1]:='';
         StringGrid1.Cells[0,k-1] := IntToStr(k);
      end;

      InitNrOfData:=DMCumFreq.NrOfData;
      DMCumFreq.TmpNrOfData:=InitNrOfData;

end; {TMainForm.ShowData}



procedure TMainForm.StringGrid1SetEditText(Sender: TObject; ACol,
                    ARow: Integer; const Value: String);
{-------------------------------------------------------------}
var MultiPaste:boolean;
begin
  MultiPaste := (POS(FORMAT('%s',[#9]), Value)> 0 );
  MultiPaste := MultiPaste or (POS(FORMAT('%s',[#13]), Value)> 0 );
  if MultiPaste then
  begin
    Try
      HandlePasteMultiCell(Sender, ACol, ARow, Value) ;
      Except on E: Exception do
      begin
        Showmessage ('There are no data to be pasted or the data'+
                     ' are incompatible');
        InputTabsheet.Show;
      end;
    end;
  end;
  InitNrOfData:=DMCumFreq.NrOfData;
  Finish:=InitNrOfData-1;
  Import:=true;
  NrOfDataEditExit(Sender);
  Import:=false;
  InputOpened:=true;
end; {MainForm.StringGrid1SetEditText}



procedure TMainForm.HandlePasteMultiCell(Sender: TObject; ACol,
                    ARow: Integer; const Value: String);
{-------------------------------------------------------------}
// only accepts numbers to be pasted into the grid
  var
   i, m, j, k, startcol, startrow: integer;
   c: char ;
   Result : boolean;

begin
  // MessageDlg(Value, mtInformation, [mbOK], 0);
  m := Length(Value);
  (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
  startcol := ACol;
  startrow := Arow;
  i := 1;
  k := 1;
  while i <= m do begin
  // loop through the characters of the Value string
    c := Value[i];
    j := Integer(c);
    if j = 9 then begin // tab: Move to next column
      ACol := ACol + 1 ;
      if i < m then // empty the cell if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else if j = 13 then begin // CR - is followed by LF
    // Move to next row, jump back to startcolumn
      StringGrid1.RowCount:=k;
      k:=k+1;
      ARow := ARow + 1 ;
      ACol := startcol ;
      i := i + 1 ; // skip the LF
      if i < m then // empty the cell it if not at end
        (Sender as TStringGrid).Cells[ACol,ARow] := '' ;
    end
    else // add the character to the string in the cell if a number
    if c in [DecimalSeparator,'-',#48,#49,#50,#51,#52,#53,#54,#55,#56,#57] then
        (Sender as TStringGrid).Cells[ACol,ARow] :=
          ConCat((Sender as TStringGrid).Cells[ACol,ARow], c);
    i := i + 1 ;
  end;
  StringGrid1.FixedCols:=1;
  StringGrid1.RowCount:=StringGrid1.RowCount+StartRow;
  NrOfDataEdit.Text:=IntToStr(StringGrid1.RowCount);
  DMCumFreq.NrOfData:=StringGrid1.RowCount;
  if DMCumFreq.NrOfData<InitNrOfData then
  begin
    Result := DMCumFreq.Question('The number of data is less than the original'+
              ' number. Do you want to maintain the original number?');
    if Result then
    begin
      DMCumFreq.NrOfData:=InitNrOfData;
      StringGrid1.RowCount:=InitNrOfData;
    end;
  end;
  for i:=0 to DMCumFreq.NrOfData do StringGrid1.Cells[0,i]:=IntToStr(i+1);
  NrOfDataEdit.Text:=IntToStr(DMCumFreq.NrOfData);
  setlength (DMCumFreq.DataValue,DMCumFreq.NrOfData);
  for i:=0 to DMCumFreq.NrOfData-1 do
      DMCumFreq.DataValue[i]:=StringToFloat(StringGrid1.Cells[1,i]);
  setlength (DMCumFreq.ToBeRemoved,DMCumFreq.NrOfData);
  setlength (DMCumFreq.SerialNr,DMCumFreq.NrOfData);
  for i:=0 to DMCumFreq.NrOfData-1 do DMCumFreq.SerialNr[i]:=i+1;
  for i:=0 to DMCumFreq.NrOfData-1 do DMCumFreq.ToBeRemoved[i]:=false;
  if DMCumFreq.NrOfData>15 then StringGrid1.Width:=170 else
     StringGrid1.Width:=155;
end; {MainForm.HandlePasteMultiCell}


{ see also InputOpenActionExecute in the MenuItems at the end}


procedure TMainForm.NrOfDataEditExit(Sender: TObject);
var NumDat, k: integer;
begin
  inherited;
    Try
      NumDat := StrToInt(NrOfDataEdit.Text);
      Except on E: Exception do
      begin
        Showmessage ('The number of data is not a valid integer');
        exit;
      end;
    end;
    if NumDat<6 then
    begin
      Showmessage (' The minimum number of data is 6');
      NrOfDataEdit.Text:='6';
      exit;
    end;
    if not Import and (NumDat>InitNrOfData) then
    begin
       Showmessage (' Add data in the last cells at the end of the column');
       RefNr:=DMCumFreq.NrOfData;
       DMCumFreq.NrOfData := NumDat;
       for k:=1 to InitNrOfData do
       begin
         SetLength(DMCumFreq.SerialNr,k+1);
         SetLength(DMCumFreq.DataValue,k+1);
         DMCumFreq.SerialNr[k-1]:= StrToInt(StringGrid1.Cells[0,k-1]);
         DMCumFreq.DataValue[k-1]:=StringToFloat(StringGrid1.Cells[1,k-1]);
       end;
       if Numdat>InitNrOfData then for k:=InitNrOfData+1 to NumDat do
       begin
         SetLength(DMCumFreq.SerialNr,k+1);
         SetLength(DMCumFreq.DataValue,k+1);
         StringGrid1.Cells[0,k-1]:=inttostr(k);
       END;
       Finish:=DMCumFreq.NrOfData-1;
       InitNrOfData := NumDat;
       ShowData(Finish);
    end;
    if not Import and (NumDat<InitNrOfData) then
    begin
      InitNrOfData:=NumDat;
      Showmessage (' To remove data, empty the relevant data cells ');
    end;
    if NumDat>15 then StringGrid1.Width:=170 else StringGrid1.Width:=155;
    RefNrOfData:=NumDat;

end; {TMainForm.NrOfDataEditExit}



procedure TMainForm.NrOfClassesEditClick(Sender: TObject);
begin
  inherited;
    Showmessage ('For interval analysis (histogram) a number of interval' +
                 ' classes is needed.  It is recommended to use 2, 5, 10' +
                 ' or 20 classes.  Use 10 or 20 only when there are more' +
                 ' than 50 resp. 100 data');
end; {TMainForm.NrOfClassesEditClick }



procedure TMainForm.NrOfClassesEditExit(Sender: TObject);
var NumDat : integer;
begin
  inherited;
    NumDat:=5;
    Try
       NumDat := StrToInt(NrOfClassesEdit.Text);
       Except on E: Exception do
       begin
         Showmessage ('The number of classes is not a valid integer. It'+
                      ' is set to 5');
         NrOfClassesEdit.Text:='5';
       end;
    end;
    DMCumFreq.NrOfClasses := NrOfClassesEdit.Text;
    DMCumFreq.NrOfInt:=NumDat;
end;



procedure TMainForm.OptionComboBoxChange(Sender: TObject);
begin
  inherited;
  DisCon:=false;
  Additional:=false;
  if OptionComboBox.ItemIndex=2 then OptionComboBox.ItemIndex:=0;
  if OptionComboBox.ItemIndex=1 then
  begin
    DisCon:=true;
    DMCumFreq.Preference:='1';
    SelectionEdit.Text:='Best of All Distributions';
    SelectForm.RadioButton1.Checked:=true;
  end else
  begin
    DisCon:=false;
    DMCumFreq.Preference:='1';
    SelectionButton.Visible:=true;
    SelectionLabel.Visible:=true;
    SelectionEdit.Visible:=true;
    SelectionEdit.Text:='Best of All Distributions';
    SelectForm.RadioButton1.Checked:=true;
  end;
end; {TMainForm.OptionComboBoxChange}


procedure TMainForm.PasteHelpButtonClick(Sender: TObject);
begin
  inherited;
  PasteHelpMemo.Visible := not PasteHelpMemo.Visible;
  if PasteHelpMemo.Visible then
  begin
     PasteHelpButton.Caption := 'Close help';
     StringGrid1.Visible := false;
     SerialLabel.Hide;
     ValueLabel.Hide;
     ClearButton.Enabled := false;
     InputSaveButton.Enabled := false;
     InputOpenButton.Enabled := false;
  end
  else
  begin
     PasteHelpButton.Caption := ' Paste help ';
     StringGrid1.Visible := true;
     SerialLabel.Show;
     ValueLabel.Show;
     ClearButton.Enabled := true;
     InputSaveButton.Enabled := true;
     InputOpenButton.Enabled := true;
  end;
end; {TMainForm.PasteHelpButtonClick}



procedure TMainForm.ClearButtonClick(Sender: TObject);
{----------------------------------------------------}
var Result : boolean;
begin
  inherited;
  Result := DMCumFreq.Question('The data will be cleared, are you sure?');
  if Result then
  begin
    FormCreate(Sender);
    RefNr:=15;
    InputTabsheet.Show;
  end;
end; {TMainForm.ClearButtonClick}



procedure TMainForm.HintButtonClick(Sender: TObject);
{----------------------------------------------------}
begin
  inherited;
  showmessage (' The generalized normal distribution is the only one not in'+
               ' included in "Best of fitting of all". Yet is widely'+
               ' applicable.');
end; {TMainForm.HintButtonClick}



function TMainForm.SetAndVerifySaveName;
{--------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSaveDialog.Execute then
      begin DMCumFreq.FileName := InputSaveDialog.Files.Strings[0];
            if FileExists(DMCumFreq.FileName)
            then  Result := DMCumFreq.
                        Question('The file already exists, overwrite?')
            else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.SetAndVerifySaveName}



procedure TMainForm.DistrWarning;
begin
  OptionComboBox.ItemIndex := 0;
  Showmessage ('Please be aware that in some cases this distribution'+
               ' may not be suitable. Compare the efficiency (correlation)'+
               ' coefficients in the output files below the table.');
end;


procedure TMainForm.SelectionButtonClick(Sender: TObject);
begin
  inherited;
  SelectForm.Show;
end;


{ See InputSaveActionExecute in the MenuItems group at the end}


procedure TMainForm.DoCalculations;
begin
  WaitMemo.Visible:=true;
  WaitMemo.Lines.Clear;
  WaitMemo.Lines.Add(' Saving data .....');
  Sleep(500);
  WaitMemo.Lines.Add(' Calculating .....');
  Calculations;
  if NotFit then
  begin
    Showmessage ('No variation between data. Program stops running');
    WaitMemo.Visible:=false;
    exit;
  end;
  NoSave := false;
  Sleep(500);
  WaitMemo.Lines.Add(' Progress 75% ....');
  CumValues;                                {conf. belt of calculated values}
  Sleep(500);
end; {TMainForm.DoCalculations}


 {---------------------------------------------------------------------
 End of Input, start of OUTPUT
 ----------------------------------------------------------------------}


procedure TMainForm.OutputTabSheetShow(Sender: TObject);
begin
  inherited;
    OutputTab:=true;
    if not OutputOpened then
    begin
      ViewGraphButton.Visible := false;
      FitButton.Visible:=false;
      OptButton.Visible:=false;
      CalcButton.Visible := false;
    end else
    begin
      if Method in [21,23,25,26] then OptButton.Visible:=true
      else OptButton.Visible:=false;
    end;
    InputSaveAction.Enabled := false;
    StatusText ('The output file can be inspected. Use "Open output"' +
                ' to see examples under "Data" or to inspect any other' +
                ' output file.');
    if not PictureImage.Visible then ChoicesPanel.Visible:=true;
    PictureImage.Visible:=false;
    HideGraphicsButtons;
end; {TMainForm.OutputTabSheetShow}


{ see also OutputOpenActionExecute in the Menu Items at the end}


procedure TMainForm.ViewGraphButtonClick(Sender: TObject);
begin
  inherited;
  OutputOpened:=true;
  ChoicesPanel.Visible := true;
  GraphOpened := false;
  PictureImage.Visible := false;
  HideGraphicsButtons;
  if Method=61 then X_ConfidenceRadioButton.Enabled:=false;      {Erlang}
  GraphicsTabsheet.Show;
end; {TMainForm.ViewGraphButtonClick}



procedure TMainForm.CalcButtonClick(Sender: TObject);
begin
  inherited;
  CalcForm.Show;
end; {TMainForm.CalcButtonClick}



procedure TMainForm.FitButtonClick(Sender: TObject);
var AuxStr:string;
begin
  if not CalcDone then DMCumFreq.ReadOutputData(1);
  FitMemo.Lines.Clear;
  FitMemo.Lines.Add('CumFreq calculates AvAbsDiff: the average of the'+
  ' absolute values of the differences between observed and'+
  ' calculated cumulative frequencies in %, the latter on the basis'+
  ' of the fitted probability distribution.');
  FitMemo.Lines.Add('');
  AuxStr:=format('%5.2f',[DMCumFreq.AvAbsDiff]);
  FitMemo.Lines.Add('In this case the AvAbsDiff ='+AuxStr+' %');
  FitMemo.Lines.Add('');
  FitMemo.Lines.Add('The AvAbsDiff may be classified as follows:');
  FitMemo.Lines.Add('');
  FitMemo.Lines.Add('            AvAbsDiff < 1%    very good');
  FitMemo.Lines.Add('   1% < AvAbsDiff < 2%    good');
  FitMemo.Lines.Add('   2% < AvAbsDiff < 3%    medium');
  FitMemo.Lines.Add('   3% < AvAbsDiff < 5%    poor');
  FitMemo.Lines.Add('            AvAbsDiff > 5%    very poor');
  FitPanel.Visible:=true;
end; {FitButtonClick}


procedure TMainForm.CloseFitButtonClick(Sender: TObject);
begin
  inherited;
  FitPanel.Visible:=false;
end;


procedure TMainForm.OptButtonClick(Sender: TObject);
begin
  inherited;
  OptForm.Visible:=true;
end;


procedure TMainForm.RankList;
label 1;
var AuxStr :string; AV: string[10]; i, j : integer; AuxAv: real;
    AvStr : array [1..7] of string;
    HamStr : string[5]; LstNr : integer;
begin
    TempFile:=changefileext(DMCumFreq.FileName,'.Lst');
    AssignFile (ListFile,TempFile);
    TempFile:=DMCumFreq.FileName;
    reset (ListFile);
    for i:=1 to 5 do readln(ListFile, AvStr[i]);
    readln (ListFile,Hamstr);
    if Hamstr=' Name' then LstNr:=7 else LstNr:=5;
    reset (ListFile);
    for i:=1 to LstNr do readln(ListFile, AvStr[i]);
    TmpNum:=0;
    while not eof (ListFile) do
    begin
      readln (ListFile);
      TmpNum:=TmpNum+1;
    end;
    reset (ListFile);
    for i:=1 to LstNr do readln(ListFile);
    Number:=TmpNum div 3;
    setlength (ValAv,Number+1);
    setlength (TxtStr,Number+1);
    for i:=1 to Number do
    begin
      readln(ListFile,TxtStr[i]);
      readln(ListFile,AV,ValAv[i]);
      readln(ListFile);
    end;
    reset (ListFile);

  for i:=1 to Number-1 do
  begin
1: for j:=i+1 to Number do
    begin
      if ValAv[j]<ValAv[j-1] then
      begin
        AuxAv      := ValAv[j];
        ValAv[j]   := ValAv[j-1];
        ValAv[j-1] := AuxAv;
        AuxStr    := TxtStr[j];
        TxtStr[j]   := TxtStr[j-1];
        TxtStr[j-1] := AuxStr;
        goto 1;
      end;
    end;
  end;

  closeFile (ListFile);
  TempFile:=changefileext(DMCumFreq.FileName,'.Lst');
  AssignFile (ListFile,TempFile);
  TempFile:=DMCumFreq.FileName;
  rewrite (ListFile);

  for i:=1 to LstNr do writeln (ListFile,AvStr[i]);
  for i:=1 to Number do
  begin
    writeln (ListFile,TxtStr[i]);
    writeln (ListFile,' Average = ',ValAv[i]:6:4);
    writeln (listFile);
  end;

  closeFile (ListFile);

end;


procedure TMainForm.ListButtonClick(Sender: TObject);
var LstStr : string;
begin
  inherited;

  TempFile:=changefileext(DMCumFreq.FileName,'.Lst');
  AssignFile (ListFile,TempFile);
  TempFile:=DMCumFreq.FileName;
  reset (ListFile);

    ListForm.ListMemo.Lines.Clear;
    ListForm.ListMemo.Visible:=false;

    while not eof (ListFile) do
    begin
      readln (ListFile,LstStr);
      ListForm.ListMemo.Lines.Add(LstStr);
    end;

    ListForm.Show;
    ListForm.ListMemo.Visible:=true;

    closefile (ListFile);

end; {ListButtonClick}



procedure TMainForm.OutputTabSheetExit(Sender: TObject);
begin
  inherited;
  CalcForm.Hide;
end;

Procedure TMainForm.HideGraphicsButtons;
begin
  GraphImage.Visible:=false;
  SelectButton.Visible:=false;
  SaveGraphButton.Visible:=false;
  SaveBlWhButton.Visible:=false;
  ConfBeltButton.Visible := false;
  ConfBeltButton.Caption := 'Hide conf. belt';
  ConfBelt := true;
end;


{-----------------------------------------------------------------------
 End of Output, start of Graphics
 -----------------------------------------------------------------------}


procedure TMainForm.GraphicsTabSheetShow(Sender: TObject);
begin
  inherited;
    Statustext ('Graphics presentations of output data can be seen and saved.'+
               ' Use "Make graph" to open an output file and make the graphs.');
               InputSaveAction.Enabled := false;
    if not GraphOpened then
    begin
      SaveGraphButton.Visible := false;
      SaveBlWhButton.Visible:=false;
    end;

    if not OutputOpened then
           ChoicesPanel.Visible := false;
    OutputTab:=false;
end; {TMainForm.GraphicsTabSheetShow}



procedure TMainForm.GraphOpenActionExecute(Sender: TObject);
var FigureFile, NewDir : string;
begin
  inherited;
     if GraphOpenDialog.Execute then
     begin
        FigureFile := MainForm.GraphOpenDialog.Files.Strings[0];
        if FileExists (FigureFile) then
          PictureImage.Picture.LoadFromFile(FigureFile)
        else
        begin
          Showmessage ('File does not exist, please select another one');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No graphics file was selected');
        exit;
      end;
      GraphOpened :=true;
      PictureImage.Visible := true;
      ChoicesPanel.Visible := false;
      OutputMemo.Visible:=false;
      ViewGraphButton.Visible:=false;
      FitButton.Visible:=false;
      OptButton.Visible:=false;
      CalcButton.Visible:=false;
      HideGraphicsButtons;
      NewDir := ExtractFilePath(FigureFile);
      InputOpenDialog.InitialDir:=NewDir;
      InputSaveDialog.InitialDir:=NewDir;
      OutputOpenDialog.InitialDir:=NewDir;
      GraphicsTabsheet.Show;
end; {TMainForm.GraphOpenActionExecute}



procedure TMainForm.MakeGraphButtonClick(Sender: TObject);
begin
  inherited;
  showmessage ('Select folder and output data file tho create the graph');
  OutputOpenActionExecute (Sender);
end; {TMainForm.MakeGraphButtonClick}



procedure TMainForm.SelectButtonClick(Sender: TObject);
begin
  inherited;
    StatusText ('Select type of graph');
    ChoicesPanel.Visible := true;
    HideGraphicsButtons;
end; {TMainForm.SelectButtonClick}



procedure TMainForm.GoButtonClick(Sender: TObject);
begin
  inherited;
    StatusText ('The graph can be saved, or another selection can be made,'+
                ' or another output file can be opened using "Make graph"');
    SelectButton.Visible := true;
    if CumulativeRadioButton.Checked then TypeOfGraph:=1
    else if IntervalRadioButton.Checked then TypeOfGraph:=2
    else if X_ConfidenceRadioButton.Checked then TypeOfGraph:=3
    else if ReturnRadioButton.Checked then TypeOfGraph:=4
    else if QQRadioButton.Checked then TypeOfGraph:=5
    else if HistoRadioButton.Checked then TypeOfGraph:=6
    else
    begin
      Showmessage (' The desired type of graph could not be assessed');
      exit;
    end;
  ShowGraphics;
end; {TMainForm.GoButtonClick}


procedure TMainForm.ShowGraphics;
var i, ii, mm, Start   : integer;
    DumReal, MaxE      : real;
    Xdat1, Xdat2       : real;
    Ydat1, Ydat2       : real;
    YrDat1, YrDat2     : real;
    YcDat1, YcDat2     : real;
    Zdat1, Zdat2       : real;
    XdatRel, YdatRel   : real;
    ZdatRel, DumVal    : real;
    Distance           : real;
    XCo, Yde           : array of real;
    RelXdat1, RelXdat2 : integer;
    RelYdat1, RelYdat2 : integer;
    RelYrDat1, RelYrDat2 : integer;
    RelYcDat1, RelYcDat2 : integer;
    RelZdat1, RelZdat2 : integer;
    RelXdat3           : integer;
    NrOfPlots          : integer;
    NameStr            : string;
    Extra, Added       : boolean;
    myRect             : TRect;
begin
  GraphOpened := true;
  ChoicesPanel.Visible := false;
  MakeGraphButton.Visible := true;
  SaveGraphButton.Visible := true;
  SaveBlWhButton.Visible:=true;
  DMCumFreq.TmpNrOfData:=DMCumFreq.NrOfData;
  if CalcDone then
  begin
    DMCumFreq.ReadOutputData(1);
    CalcDone:=false;
  end;
  DMCumFreq.ReadOutputData(TypeOfGraph);
  if not CalcDone then DefineDistr;
  DMCumFreq.TmpNrOfData:=DMCumFreq.NrOfData;
  ConfBeltButton.Visible:=false;
  if CumulativeRadioButton.Checked then
     if DMCumFreq.NrOfData>250 then ConfBeltButton.Visible:=true;
  MaxMin (TypeOfGraph);
  Relative (TypeOfGraph);
  Legends (TypeOfGraph);
  With GraphImage.Canvas do with DMCumFreq do
  begin
    Font.Size := 12;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,460);
    FillRect (myRect);
    Textout (45,2,Title1);
    Font.Size := 10;
    TextOut (20,PosY2+75,'CumFreqA program at www.waterlog.info/cumfreq.htm');
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    myRect:= Rect(20,19,605,420);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clwhite;        {for the lines}
    if not Color then Pen.Color := clblack;
    Pen.Width := 1;

    Font.Color := clWhite;
    if not Color then Font.Color := clblack;
    Textout (45,22,Title2);
    if TypeOfGraph<5 then Textout (470,PosY2+25,LegendX)
       else Textout (400,PosY2+25,LegendX);
    TextOut (PosX1+12,50,LegendY);
    if (TypeofGraph=1) and Disconti then TextOut (PosX1+200,35,Distrib)
    else TextOut (PosX1+200,50,Distrib);
    if (TypeOfGraph=1) then
    begin
      Font.Color:=clLime;
      if not Color then Font.Color := clblack;
      if Color and Disconti then
         TextOut (PosX1+200,50,'The separation line is shown as - - - -');
      if not Color and Disconti then
         TextOut (PosX1+200,50,'The separation line is shown vertically');
      Font.Color:=clAqua;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,65,LegendY1);
      Font.Color := clWhite;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,80,LegendX1);
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;
      if ConfBelt and (NrOfData<250) then TextOut (PosX1+16,95,LegendZ);
    end;
    if (TypeOfGraph=2) or (TypeOfGraph=6) then
    begin
      TextOut (PosX1+16,65,LegendY2);
      TextOut (PosX1+16,80,LegendX2);
      Font.Color:=clAqua;
      if not Color then Font.Color := clblack;
      if TypeOfGraph=2 then
         TextOut (PosX1+200,85,'- - - - - density function calculated')
      else
         TextOut (PosX1+200,70,'- - - - - density function calculated');
      Font.Color := clWhite;
    end;
    if TypeOfGraph=3 then
    begin
      Font.Color := clWhite;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,65,LegendX3);
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,80,LegendZ);
    end;
    if (TypeOfGraph=4) then
    begin
      Font.Color:=clAqua;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,65,LegendY1);
      Font.Color := clWhite;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,80,LegendX1);
      Font.Color := clYellow;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,95,LegendZ);
    end;
    if TypeOfGraph=5 then
    begin
      Font.Color := clAqua;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,70,'   o   Observed');
      Font.Color := clwhite;
      if not Color then Font.Color := clblack;
      TextOut (PosX1+16,85,' - - - Obs = Calc');
    end;

    if NrOfData>200 then ConfBeltButton.Enabled:=false;
  		                                          {grafische coordinaten van de}
    if (TypeOfGraph=1) or (TypeOfGraph=4) then      {theor. cum. frq. curve}
    begin                                              {+ return period}
      Font.Color := clAqua;
      Pen.Color := clAqua;
      if not Color then Font.Color := clblack;
      if not Color then Pen.Color := clblack;
      Font.Size := 6;
      mm:=0;
      for i:=0 to NrOfData-1 do
      begin
        Xdat1 := FactorX*Xdata[i];
        XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
        RelXdat1 := PosX1+round(XdatRel);
        Ydat1   := FactorY*Ydata[i];
        YdatRel := LY*(YDat1-MinY)/(MaxY-MinY);
        RelYdat1 := PosY2-round(YdatRel);
        Ellipse( RelXdat1-2,RelYdat1-2,RelXdat1+2,RelYdat1+2)
      end;
      NrOfPlots:=NrOfData;
      Table:=false;
      if (TypeOfGraph=1) and Scarce then
      begin
        CalcForm.ReadParam;
        Table:=true;
        CalcFreq;
        setlength(Zdata,21);
        setlength(Ycdata,21);
        for i:=1 to NumDat do
        begin
          StDev := (1/NrOfData)*exp(0.5*ln(YrData[i]*(1-YrData[i])*NrOfData));
          Zdata[i]:=YrData[i]-3.4*StDev*YrData[i];
          YcData[i]:=YrData[i]+3.4*StDev*(1-YrData[i]);
          YrData[i]:=100*YrData[i];
          ZData[i]:=100*ZData[i];
          YcData[i]:=100*YcData[i];
        end;
        NrOfPlots:=NumDat;                                              
      end;
      if not Scarce then NrOfPlots:=NrOfPlots-1;
      Start:=0;
      if Scarce then Start:=1;
      for i:=Start to NrOfPlots-1 do                {de calulated functielijn}
      begin
        Xdat1:=FactorX*Xdata[i];
        XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
        RelXdat1 := PosX1+round(XdatRel);
        Xdat2:=FactorX*Xdata[i+1];
        XdatRel := LX*(Xdat2-MinX)/(MaxX-MinX);
        RelXdat2 := PosX1+round(XdatRel);
        YrDat1  :=FactorY*YrData[i];
        YdatRel := LY*(YrDat1-MinY)/(MaxY-MinY);
        RelYrdat1 := PosY2-round(YdatRel);
        YrDat2  :=FactorY*YrData[i+1];
        YdatRel := LY*(YrDat2-MinY)/(MaxY-MinY);
        RelYrdat2 := PosY2-round(YdatRel);
        Zdat1   := FactorY*Zdata[i];
        ZdatRel := LY*(Zdat1-MinY)/(MaxY-MinY);
        RelZdat1 := PosY2-round(ZdatRel);
        Zdat2   := FactorY*Zdata[i+1];
        ZdatRel := LY*(Zdat2-MinY)/(MaxY-MinY);
        RelZdat2 := PosY2-round(ZdatRel);
        YcDat1  := FactorY*YcData[i];
        YdatRel := LY*(YcDat1-MinY)/(MaxY-MinY);
        RelYcDat1 := PosY2-round(YdatRel);
        YcDat2  := FactorY*YcData[i+1];
        YdatRel := LY*(YcDat2-MinY)/(MaxY-MinY);
        RelYcDat2 := PosY2-round(YdatRel);
        Pen.Color := clWhite;                     {de calulated functielijn}
        if not color then Pen.Color := clblack;
        Pen.Style:= psSolid;
        if TypeOfGraph=1 then
        begin
          moveto (RelXdat1,RelYrDat1);
          lineto (RelXdat2,RelYrDat2);
        end;
        if (TypeOfGraph=4) and (YrDat2>Ymin) then
        if (Yrdat2<=1.01*Ymax) and (Xdat2<=Xmax) then
        begin
          moveto (RelXdat1,RelYrDat1);
          lineto (RelXdat2,RelYrDat2);
        end;
        if ConfBelt and (NrOfPlots<250) then
        begin
          Pen.Style:= psDot;
          Pen.Color := clYellow;                    {de confidence lijnen}
          Brush.Color := $8B0000;
          if not Color then Pen.Color := clblack;
          if not Color then Brush.Color := clwhite;
          if (Zdat2<=Ymax) and (Xdat2<=Xmax) and (Zdat2>0) then
          begin
            moveto (RelXdat1,RelZdat1);
            lineto (RelXdat2,RelZdat2);
          end;
          if TypeOfGraph=1 then
          begin
            moveto (RelXdat1,RelYcDat1);
            lineto (RelXdat2,RelYcDat2);
          end;
          if (TypeOfGraph=4) and (YcDat2>Ymin) then
          if (Ycdat2<=Ymax) and (Xdat2<=Xmax) then
          begin
            moveto (RelXdat1,RelYcDat1);
            lineto (RelXdat2,RelYcDat2);
          end;
        end;
      end; {for i:=0 to NrOfPlots-1 do}

      if (TypeOfGraph=1) and Disconti then
      begin
        BpointRelX:=LX*(DMCumFreq.XatBP-MinX)/(MaxX-MinX);
        RelBpointX := PosX1+round(BpointRelX);
        BpointRelY:=LY*(DMCumFreq.YatBP-MinY)/(MaxY-MinY);
        RelBpointY := PosY2-round(BpointRelY);
        Pen.Style:= psDot;
        if not Color then Pen.Style:=psDash;
        Pen.Color := clLime;
        if not Color then Pen.Color := clblack;
        moveto(RelBpointX,PosY2);
        lineto(RelBpointX,RelBpointY);
      end;
  end; {if TypeOfGraph=1 or TypeOfGraph=4}
  Brush.Color:=$8B0000;
  if not Color then Brush.Color := clWhite;

  if (TypeOfGraph=2) or (TypeOfGraph=6) then with DMCumFreq do
  begin

    Pen.Color := clwhite;
    Pen.Style:=psSolid;
    if not Color then Pen.Color := clblack;
    Font.Color := clwhite;
    if not Color then Font.Color := clblack;
    if Ycdata[0]>YcData[1] then YcData[0]:=0.5*YcData[1];
    Distance:=Xdata[2]-Xdata[1];

    for i:=1 to NrOfInt-2 do
    begin                               {Xdat=lower,Ydat=upper,Yr=Obs,Yc=calc}
      Xdat1:=FactorX*Xdata[i];
      Xdat2:=FactorX*Xdata[i+1];
      XdatRel := LX*(Xdat1+Xdat2-2*MinX)/(2*(MaxX-MinX));
      RelXdat1 := PosX1+round(XdatRel);
      YdatRel := LY*YrData[i]/(MaxY-MinY);
      RelYrDat1 := PosY2-round(YdatRel);
      YdatRel := LY*YcData[i]/(MaxY-MinY);
      if YcData[i]<0.005*MaxY then YdatRel:=LY*0.005*MaxY/(MaxY-MinY);
      if TypeOfGraph=2 then if i>0 then
         TextOut (RelXdat1-2,RelYrDat1-7,'#');     {observed interval frq.}
      XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
      if i=0 then
      begin
        XdatRel := LX*(Xdat1-Minx)/(MaxX-MinX);
        DumVal := YcData[i];
        if YcData[i]>YcData[i+1] then DumVal:=(YcData[i]+YcData[i+1]/2)/2;
        YdatRel:=LY*DumVal/(MaxY-MinY);
      end;
      RelXdat1 := PosX1+round(XdatRel);
      RelYcDat1 := PosY2-round(YdatRel);
      XdatRel := LX*(Xdat2-MinX)/(MaxX-MinX);
      RelXdat2 := PosX1+round(XdatRel);
      YdatRel := LY*Ycdata[i]/(MaxY-MinY);
      RelYdat2 := PosY2-round(YdatRel);
      if (i>0) and (YcData[i]>=0) then
      begin
        moveto (RelXdat1,PosY2);
        lineto (RelXdat1,RelYcdat1);
      end;
      if YcData[i]>0 then
      begin
        moveto (RelXdat1,RelYcdat1);
        lineto (RelXdat2,RelYcdat1);
        moveto (RelXdat2,RelYcdat1);
        lineto (RelXdat2,PosY2);
      end;
    end;

    ii := NrOfInt-1;
    Xdat1:= FactorX*Xdata[ii-1];
    Xdat2 := FactorX*Xdata[ii];
    XdatRel :=LX*(Xdat2-MinX)/(MaxX-MinX);
    RelXdat2 := PosX1+round(XdatRel);
    DumVal:=Xdat2-MinX+0.75*(Xdat2-Xdat1);
    if DumVal>MaxX-MinX then DumVal:=MaxX-MinX;
    XdatRel := LX*DumVal/(MaxX-MinX);
    RelXdat3 := PosX1+round(XdatRel);
    YcDat1 := YcData[ii-1];
    YdatRel := LY*YcDat1/(MaxY-MinY);
    RelYcDat1 := PosY2-round(YdatRel);
    YcDat2 := YcData[ii];
    if YcDat2>YcDat1 then YcDat2 := 0.5*(YcDat1+0.5*YcDat1);
    YdatRel := LY*YcDat2/(MaxY-MinY);
    RelYcDat2 := PosY2-round(YdatRel);
    moveto (RelXdat2,RelYcDat1);
    lineto (RelXdat2,RelYcDat2);
    moveto (RelXdat2,RelYcDat2);              {laatste interval blok}
    lineto (RelXdat3,RelYcDat2);

    Table:=false;
    setlength(Mag,NrOfInt+1);
    Mag[NrOfInt]:=Xvalue[NrOfInt-1];
    Mag[1]:=Xvalue[1];
    CalcForm.ReadParam;
    if Method=73 then BoundLG:=exp(Expon73A*ln(BoundL2));
    if Method=67 then  for ii:=1 to 20 do
       Limit[ii] := Expon67*(Limit[ii]-MagAv67)/StErr67;
    Intervals;
    setlength (Xdata,22);
    setlength (Ycdata,22);
    setlength (Yde,22);
    for i:=1 to 20 do
        Yde[i]:=100*(Border[i+1]-Border[i]);
    DumReal:=Limit[2]-Limit[1];
    for i:=1 to 21 do
    begin
      Yde[i]:=Distance*Yde[i]/DumReal;
      if Yde[i]>0.8*MaxY then Yde[i]:=0.8*MaxY;
      if Yde[i]<=0 then Yde[i]:=0;
    end;

    if (Method>19) and (Method<30) and (Minim<0) then
    if Yde[1]=0 then
    begin
      Yde[1]:=Yde[20];
      Yde[2]:=Yde[19];
      Yde[3]:=Yde[18];
      Yde[4]:=Yde[17];
      Yde[5]:=Yde[16];
      Yde[6]:=Yde[15];
      Yde[7]:=Yde[14];
      Yde[8]:=Yde[13];
      Yde[9]:=Yde[12];
      Yde[10]:=Yde[11];
    end;

    Pen.Color := clAqua;
    if not Color then Pen.Color := clblack;
    Pen.Style:=psDot;
    if FactorX*Limit[1]>0 then for i:=1 to 19 do Limit[i]:=Limit[i]+Minim;
    if FactorX*Limit[1]<Xmin then Limit[1]:=Xmin;
    if FactorX*abs(Limit[20])>abs(Xmax) then Limit[20]:=Xmax;
    For i:=1 to 20 do
    begin
      Limit[i]:=FactorX*Limit[i];
      Limit[i+1]:=FactorX*Limit[i+1];
      if Limit[i+1]>Xmax then Limit[i+1]:=Xmax;
      YdatRel:=LY*(Yde[i]-MinY)/(MaxY-MinY);
      RelYrdat1 := PosY2-round(YdatRel);
      YdatRel:=LY*(Yde[i+1]-MinY)/(MaxY-MinY);
      RelYrdat2 := PosY2-round(YdatRel);
      XdatRel:=LX*(Limit[i]-MinX)/(MaxX-MinX);
      RelXdat1 := PosX1+round(XdatRel);
      XdatRel:=LX*(Limit[i+1]-MinX)/(MaxX-MinX);
      RelXdat2 := PosX1+round(XdatRel);
      moveto (RelXdat1,RelYrdat1);
      lineto (RelXdat2,RelYrdat2);
      Limit[i]:=Limit[i]/FactorX;
      Limit[i+1]:=Limit[i+1]/FactorX;
    end;
    For i:=1 to 19 do Limit[i]:=Limit[i]-Minim;

  end; {if (TypeOfGraph=2) or (TypeOfGraph=6) then}

    if (TypeOfGraph=3) then                  {Confidence X-Values}
    begin
      for i:=0 to NrOfData-2 do
      begin
        Xdat1 :=FactorX*Xdata[i];
        XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
        RelXdat1 := PosX1+round(XdatRel);
        Xdat2 :=FactorX*Xdata[i+1];
        XdatRel := LX*(Xdat2-MinX)/(MaxX-MinX);
        RelXdat2 := PosX1+round(XdatRel);
        ZDat1:=FactorY*ZData[i];
        ZdatRel := LY*(Zdat1-MinY)/(MaxY-MinY);
        RelZdat1 := PosY2-round(ZdatRel);
        ZDat2:=FactorY*ZData[i+1];
        ZdatRel := LY*(ZDat2-MinY)/(MaxY-MinY);
        RelZdat2 := PosY2-round(ZdatRel);
        YcDat1:=FactorY*YcData[i];
        YdatRel := LY*(YcDat1-MinY)/(MaxY-MinY);
        RelYcdat1 := PosY2-round(YdatRel);
        YcDat2:=FactorY*YcData[i+1];
        YdatRel := LY*(YcDat2-MinY)/(MaxY-MinY);
        RelYcdat2 := PosY2-round(YdatRel);
        YrDat1  :=FactorY*YrData[i];
        YdatRel := LY*(YrDat1-MinY)/(MaxY-MinY);
        RelYrdat1 := PosY2-round(YdatRel);
        YrDat2  :=FactorY*YrData[i+1];
        YdatRel := LY*(YrDat2-MinY)/(MaxY-MinY);
        RelYrdat2 := PosY2-round(YdatRel);
        Pen.Color := clWhite;
        if not Color then Pen.Color := clblack;
        Pen.Style := psSolid;
        moveto (RelXdat1,RelYrDat1);                {calculated values}
        lineto (RelXdat2,RelYrDat2);
        Pen.Color := clYellow;
        if not Color then Pen.Color := clblack;
        Pen.Style := psDot;
        if ConfBelt and (NrOfData<260) then
        begin
          moveto (RelXdat1,RelZDat1);                 {lower conf. values}
          lineto (RelXdat2,RelZDat2);
          moveto (RelXdat1,RelYcDat1);                {upper conf. values}
          lineto (RelXdat2,RelYcDat2);
        end;
      end;
    end; {if TypeOfGraph=3}             {grafische coord. obs. interval frq.}

    if (TypeOfGraph=5)  then      {Calculated Cum.Freq versus Observed}
    begin
      Font.Color := clAqua;
      Pen.Color := clAqua;
      if not Color then Font.Color := clblack;
      if not Color then Pen.Color := clblack;
      Font.Size := 6;
      mm:=0;
      for i:=0 to NrOfData-1 do
      begin
        Xdat1 := FactorY*Xdata[i];
        XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
        RelXdat1 := PosX1+round(XdatRel);
        Ydat1   := FactorY*Ydata[i];
        YdatRel := LY*(YDat1-MinY)/(MaxY-MinY);
        RelYdat1 := PosY2-round(YdatRel);
        Ellipse( RelXdat1-2,RelYdat1-2,RelXdat1+2,RelYdat1+2)
      end;

    Brush.Color:=$8B0000;
    if not Color then Brush.Color := clWhite;

        Xdat1:=FactorX*Xdata[0];
        XdatRel := LX*(Xdat1-MinX)/(MaxX-MinX);
        RelXdat1 := PosX1+round(XdatRel);
        Xdat2:=FactorX*Xdata[NrOfData-1];
        XdatRel := LX*(Xdat2-MinX)/(MaxX-MinX);
        RelXdat2 := PosX1+round(XdatRel);
        YcDat1  := FactorY*YcData[0];
        YdatRel := LY*(YcDat1-MinY)/(MaxY-MinY);
        RelYcDat1 := PosY2-round(YdatRel);
        YcDat2  := FactorY*YcData[NrOfData-1];
        YdatRel := LY*(YcDat2-MinY)/(MaxY-MinY);
        RelYcDat2 := PosY2-round(YdatRel);
        Pen.Color := clWhite;                     {de calulated functielijn}
        if not color then Pen.Color := clblack;
          Pen.Style:= psDash;
          moveto (RelXdat1,RelYcDat1);
          lineto (RelXdat2,RelYcDat2);
          Pen.Color := clYellow;                    {de confidence lijnen}
   end; {if TypeOfGraph=5  then}

    Font.Size := 8;
    Pen.Color := clWhite;
    if not Color then Pen.Color := clblack;
    Pen.Style := psSolid;
    Font.Color := clWhite;
    if not Color then Font.Color := clblack;
    moveto (PosX1,PosY2);                            { vertical axis }
    lineto (PosX1,PosY1);
    Start := 0;
    if ScaleY>10 then Start := ScaleY-10;
    for ii:=Start to ScaleY do
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                 IntToStr(decimY) + 'f', [MaxY - DumReal]);
                      {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;

    moveto (PosX1,PosY2);                           { horizontal axis }
    lineto (PosX2,PosY2);
    for ii:=0 to ScaleX do
    begin Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
          Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
          DumReal := ii*(MaxX-MinX)/ScaleX;
          NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                     IntToStr(decimX) + 'f', [MinX+DumReal]);
          Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

  end; {With GraphImage.Canvas do}
  GraphImage.Visible:=true
end; {TMainForm.ShowGraphics}



procedure TMainForm.SaveGraphButtonClick(Sender: TObject);
var Result : boolean;
    FigureFile : string;
begin
  inherited;
      Color:=true;
      ShowGraphics;
      if GraphSaveDialog.Execute then
      begin FigureFile := GraphSaveDialog.Files.Strings[0];
        if FileExists(FigureFile) then
           Result := DMCumFreq.Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          GraphImage.Picture.SaveToFile(FigureFile);
          Showmessage ('The graph was saved in  ' + FigureFile);
        end;
      end
      else Showmessage ('The graph was not saved');
end; {TMainForm.SaveGraphButtonClick}


procedure TMainForm.SaveBlWhButtonClick(Sender: TObject);
var Result : boolean;
    FigureFile : string;
begin
  inherited;
  Color:=false;
  ShowGraphics;
      if GraphSaveDialog.Execute then with DMCumFreq do
      begin FigureFile := GraphSaveDialog.Files.Strings[0];
        if FileExists(FigureFile) then
             Result := Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          GraphImage.Picture.SaveToFile(FigureFile);
          Showmessage ('The graph was saved in  ' + FigureFile);
        end;
      end
      else Showmessage ('The graph was not saved');
  Color:=true;
end;


procedure TMainForm.ConfBeltButtonClick(Sender: TObject);
begin
  inherited;
  if ConfBeltButton.Caption='Hide conf. belt' then
  begin
     Confbelt:=false;
     ConfBeltButton.Caption:='Show conf. belt';
  end else
  begin
     Confbelt:=true;
     ConfBeltButton.Caption:='Hide conf. belt';
  end;
  GoButtonClick (Sender);
end;


{-----------------------------------------------------------------------
 End of Graphics, start of FINISH
 -----------------------------------------------------------------------}


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
     Action := caNone;
     FinishForm.Show;
end; {TMainForm.FormClose}


{-----------------------------------------------------------------------
 End of Finish, start of MENU ITEMS
 -----------------------------------------------------------------------}

procedure TMainForm.InputOpenActionExecute(Sender: TObject);
var NewDir:string;
begin
  inherited;
     if MainForm.InputOpenDialog.Execute then
      begin
        DMCumFreq.Filename := MainForm.InputOpenDialog.Files.Strings[0];
        if FileExists (DMCumFreq.FileName) then
           DMCumFreq.ReadInputFile
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      Title1Edit.Text:=DMCumFreq.Title1;
      Title2Edit.Text:=DMCumFreq.Title2;
      FilenameEdit.Text := DMCumFreq.FileName;
      FilenameEdit.Visible:=true;
      FileNameLabel.Visible:=true;
      Title1Edit.Text:=DMCumFreq.Title1;
      Title2Edit.Text:=DMCumFreq.Title2;
      Finish:=DMCumFreq.NrOfData-1;
      RefNr:=DMCumFreq.NrOfData;
      InputOpened := true;
      NewDir := ExtractFilePath(DMCumFreq.FileName);
      InputOpenDialog.InitialDir:=NewDir;
      InputSaveDialog.InitialDir:=NewDir;
      OutputOpenDialog.InitialDir:=NewDir;
      if not DMCumFreq.Allowed then
         OptionComboBox.ItemIndex:=0
      else
      begin
        OptionComboBox.ItemIndex:=1;
        SelectionButton.Visible:=true;
        SelectionLabel.Visible:=true;
      end;

      ShowData (Finish);
      ChoicesPanel.Visible:=false;
      OutputMemo.Visible:=false;
      FitPanel.Visible:=false;
      CalcButton.Visible:=false;
      ListButton.Visible:=false;
      ViewGraphButton.Visible:=false;
      HideGraphicsButtons;
      ListForm.Hide;
      if RefNr>15 then StringGrid1.Width:=170 else StringGrid1.Width:=155;
      InputTabsheet.Show;
end; {TMainForm.InputOpenActionExecute}



procedure TMainForm.InputSaveActionExecute(Sender: TObject);
var k, n : integer;
    OutputOK : boolean;
    TmpTxt : TextFile;
    NN:array of integer;

begin
  inherited;
    if (SetAndVerifySaveName) and not NoSave then
    begin
      DMCumFreq.Title1 := Title1Edit.Text;
      DMCumFreq.Title2 := Title2Edit.Text;
      DMCumFreq.Threshold:= -1000000;
      setlength (NN, DMCumFreq.NrOfData+1);
      For k := 1 to DMCumFreq.NrOfData do  NN[k]:=0;

      For k := 1 to DMCumFreq.NrOfData do
      begin
        setlength (DMCumFreq.SerialNr,k+1);
        DMCumFreq.SerialNr[k-1]:=k;
        if StringGrid1.Cells[1,k-1]<>'' then
        begin
          Try
            DMCumFreq.DataValue[k-1]:= StringToFloat(StringGrid1.Cells[1,k-1]);
            Except on E: Exception do
            begin
              Showmessage ('Not all data values in the inputfile are real');
              exit;
            end;
          end;
        end else
        begin
          DMCumFreq.ToBeRemoved[k-1]:=true;
          NN[k]:=1;
          Removed:=true;
        end;
      end;
    end else
    begin
      Showmessage ('The input data were not saved');
      exit;
    end;

    n:=0;
    For k := 1 to DMCumFreq.NrOfData do
    if DMCumFreq.DataValue[k-1]=0 then n:=n+1;

    if n>0.5*DMCumFreq.NrOfData then
    begin
      showmessage ('There are too many zero input data. Input is invalid.');
      exit;
    end;

    if not FileExists (DMCumFreq.FileName) then
    begin
      assignfile (TmpTxt,DMCumFreq.FileName);
      rewrite (TmpTxt);
      closefile (TmpTxt);
    end;

    TempFile:=changefileext(DMCumFreq.FileName,'.Lst');
    if fileexists (TempFile) then deletefile (TempFile);
    TempFile:=DMCumFreq.FileName;

//Removing data
      n:=0;
      if Removed then for k := 0 to DMCumFreq.NrOfData-1 do with DMCumFreq do
      begin
        if NN[k+1]=0 then
        begin
          DataValue[n]:= StringToFloat(StringGrid1.Cells[1,k]);
          n:=n+1;
        end;
      end;

      NrOfDataEdit.Text:=inttostr(DMCumFreq.NrOfData);
      StringGrid1.rowcount:=N;
      if Removed then for k:=0 to N-1 do with DMCumFreq do
      begin
        stringgrid1.Cells[1,k+1]:=floattostr(DataValue[k]);
      end;

    chdir(InitDir);
    DMCumFreq.WriteInputFile(DMCumFreq.FileName);

    Discon:=false;
    if Optioncombobox.ItemIndex=1 then Discon:=true;
    DoCalculations;
    if NotFit then exit;
    TotNrOfData:=DMCumFreq.NrOfData;
    for k:=0 to DMCumFreq.NrOfData-1 do
        DMCumFreq.Xvalue[k]:=DMCumFreq.Xvalue[k+1];
    chdir (InitDir);
    WaitMemo.Lines.Add(' Filing results ..');
    Sleep(500);
    WaitMemo.Visible:=false;
    AuxFile := ChangeFileExt(DMCumFreq.FileName,'.inp');
    DMCumFreq.FileName := ChangeFileExt(DMCumFreq.FileName,'.out');
    DMCumFreq.ReadOutputLines (DMCumFreq.FileName,OutputOK);
    if not OutputOk then
    begin
      InputTabsheet.Show;
      exit;
    end;

    if SelectForm.RadioButton1.Checked then
       RankList;
    ShowMessage ('The input is saved in ' + AuxFile +
                 '   Calculations were done and the output is saved in  ' +
                  DMCumFreq.FileName);
    OutputOpened := true;
    ViewGraphButton.Visible := true;
    CalcButton.Visible := true;
    GraphImage.Visible:=false;
    if DMCumFreq.NrOfData>500 then FitButton.Visible:=true
    else FitButton.Visible:=false;
    if SelectForm.RadioButton1.Checked then
       ListButton.Visible:=true
    else
       ListButton.Visible:=false;
    ListForm.Hide;
    OutputTabsheet.Show
end; {TMainForm.InputSaveActionExecute}



function TMainForm.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      if DecimalSeparator = ',' then
        DecimalSeparator := '.';
      Result := StrToFloat(Str);
    end;
  end;
end; {TMainForm.StringToFloat}



procedure TMainForm.OutputOpenActionExecute(Sender: TObject);
var OutputOK : boolean;
    NewDir : string;
begin
  inherited;
     if OutputOpenDialog.Execute then
     begin
        DMCumFreq.Filename := MainForm.OutputOpenDialog.Files.Strings[0];
        if FileExists (DMCumFreq.Filename) then
          DMCumFreq.ReadOutputLines (DMCumFreq.FileName,OutputOK)
        else
          Showmessage ('File does not exist, please select another one,');
     end
     else
     begin
       ShowMessage('No output file was selected');
       exit;
     end;
     StatusText ('The output file can be imported into spreadsheets');
     OutputOpened := true;
     NewDir := ExtractFilePath(DMCumFreq.FileName);
     InputOpenDialog.InitialDir:=NewDir;
     InputSaveDialog.InitialDir:=NewDir;
     OutputOpenDialog.InitialDir:=NewDir;
     ViewGraphButton.Visible := true;
     if DMCumFreq.MethNr>0 then CalcButton.Visible := true;
     OutputMemo.Visible:=true;
     ChoicesPanel.Visible:=true;
     PictureImage.Visible := false;
     CalcDone:=false;
     HideGraphicsButtons;
     CalcForm.Hide;
     ListForm.Hide;
     FitPanel.Visible:=false;
     DMCumFreq.ReadOutputData(1);
     Method:=DMCumFreq.DistrType;
     if DMCumfreq.NrOfData>250 then FitButton.Visible:=true
     else FitButton.Visible:=false;
     TempFile:=changefileext (DMCumFreq.FileName,'.Lst');
     if fileexists (TempFile) then ListButton.visible:=true
     else ListButton.visible:=false;
     TempFile:=DMCumFreq.FileName;
     if Method in [21,23,24,25,26] then OptButton.Visible:=true
     else OptButton.Visible:=false;
     if OutputTab then OutputTabsheet.Show
     else
     begin
       StatusText ('Select type of graph');
       GraphicsTabsheet.Show;
     end;
end; {TMainForm.OutputOpenActionExecute}


end.


