unit UFreqCalc;

interface

uses Dialogs, SysUtils, Math, UMainForm, UDMCumFreq, UcumFreqUtils;

var {Calculations}

InFile, OutFile, ListFile          : textfile;
FileToOpen, FullName,
InpName, TempFile, Distrib         : string;
DumStr, Remark, OriginPath         : string;
Title1, Title2                     : string[72];
Extens, Key                        : string[4];
Mag,    AuxMag                     : array of extended;
Frq,    FrqCalc                    : array of extended;
Ser                                : array of integer;
Border,  Limit                     : array [1..25] of real;
Num                                : array [1..25] of real;
AAA                                : array [1..2000] of real;
Inflex,  Inter,   Slope,   StErrS,
FrqAv,   MagAv,   MagAv67, MagAvS,
Expon1,  Expon2,  Expon3,  Expon68, 
Expon7A, Expon7B, Expon8A, Expon8B, Bur,
Expon9A, Expon9B, Expon26, Expon67, Dag,
Expon51, Expon52, Expon55, Expon60, Expon61,
Expon65, Expon66, Expon72A,Expon72B,
Expon73A, Expon73B, Expon36,Expon69: real;
Expon70A,Expon70B,Expon71A,Expon71B: real;
MagRedSumSq,      StErr,   StDev   : real;
SlopeA,  SlopeB,  InterA,  InterB  : real;
Aslope,  Bslope,  Ainter,  Binter  : real;
ExponA,  ExponB,  StErr67          : real;
Mean,    Median,  Bpoint,  Minim   : real;
MagAv0,  StDev0,  MaxVal           : real;
MagAv1,  MagAv2,  Threshold        : real;
StErr1,  StErr2,  StDev1,  StDev2  : real;
MagAv3,  StErr3,  StDev3           : real;
MagAv4,  StErr4,  StDev4           : real;
MagAv5,  StErr5,  StDev5, Bound33  : real;
MagAv6,  StErr6,  StDev6, Substr   : real;
SumResSq69, Slope69,  Inter69      : real;  // for Rayleigh
SumResSq61, Slope61,  Inter61      : real;  // for Erlang
Bpoint7,    Bpoint8,    Bpoint9,    Bpoint10    : real;
Bpoint11,   Bpoint12,   Bpoint13,   Bpoint14    : real;
Bpoint15,   Bpoint16,   Bpoint17,   Bpoint18    : real;
Bpoint70,   Bpoint71,   Bpoint72,   Bpoint73    : real;
Bpoint80,   Bpoint81,   Bpoint82,   Fac         : real;
Bpoint83,   Bpoint84,   Bpoint85,   AA2         : real;
Method,  Phase,   NumDat,  TmpNum  : integer;
BB1,     BB2,     BoundL,  BE1     : real;
BB1G,    BB2G,    BoundLG, AA1     : real;
BoundL1, BoundL2, Subtr, Slope36   : real;
AA1B, AA1D, AA1G, BE1B, BE1D, BE1G : real;
SumResSq56, Slope56, Inter56       : real;
Number,  Steps,   Note,    Decim   : integer;
DeciAv,  DeciErr, DeciMin          : integer;
DecimS,  DecimI                    : integer;
Discon,  Detected, NegVal, DumEsc  : boolean;
NotFit, Progress, Additional, Bounded : boolean;
WarnType2, WarnType3, CalcDone,
Listing, Table, Norm               : boolean;
TTT                                : byte;

var {CalcValues}

VaLow,  ValUp, ValAv               : array of real;
Summation                          : array [1..801] of real;
Sums                               : array [1..300] of array[1..300] of real;
Tmp1File, Tmp2File                 : textfile;
Line                               : string;
Serial                             : string[4];
Start,   Choice,  SerNr            : integer;
Mode,    MagAve,  Mode4,   LnAve   : real;
LnStd,   LnStE,   SqAve            : real;
SqStD,   SqStE,   RtStD,   RtStE   : real;
Xdat1,   NotReq,  Ydat1,   YrDat1  : real;
Zdat,    Zdat1,   YcDat,   YcDat1  : real;
YrDat,   Average, Standard         : real;
Average1, Average3, Average4,
Average5, Average6                 : real;
Xmaxi,   Xmini                     : real;
Result1, Result2, Result3          : real;
Residu, ResiduAb                   : extended;
Bound58, Bound59, Bound67          : real;
SumResSq20, SumResSq21, SumResSq22,
SumResSq23, SumResSq24, SumResSq25,
SumResSq26, Bound35                : real;
SumResSq31, Slope31,    Inter31    : real;      {Burr}
SumResSq32, Slope32,    Inter32    : real;      {Dagum}
SumResSq34, Slope34,    Inter34    : real;      {Gompertz}
Inter7A,    Inter7B,    Inter8A,    Inter8B     : real;
Inter9A,    Inter9B,    Inter10A,   Inter10B    : real;
Inter11A,   Inter11B,   Inter12A,   Inter12B    : real;
Inter13A,   Inter13B,   Inter14A,   Inter14B    : real;
Inter15A,   Inter15B,   Inter16A,   Inter16B    : real;
Inter17A,   Inter17B,   Inter18A,   Inter18B    : real;
Inter70A,   Inter70B,   Slope70A,   Slope70B    : real;
Inter71A,   Inter71B,   Slope71A,   Slope71B    : real;
Inter72A,   Inter72B,   Slope72A,   Slope72B    : real;
Inter73A,   Inter73B,   Slope73A,   Slope73B    : real;
Inter80A,   Inter80B,   Slope80A,   Slope80B    : real;
Inter81A,   Inter81B,   Slope81A,   Slope81B    : real;
Inter82A,   Inter82B,   Slope82A,   Slope82B    : real;
Inter83A,   Inter83B,   Slope83A,   Slope83B    : real;
Inter84A,   Inter84B,   Slope84A,   Slope84B    : real;
Inter85A,   Inter85B,   Slope85A,   Slope85B    : real;

TxtStr : array of String;

procedure WriteTmp;
procedure WriteOut;
procedure Intervals;
procedure CalcFreq;
procedure Rank;
procedure Functions;
procedure Regres1;
procedure Regres2;
procedure Regres3;
procedure Ratio1;
procedure Ratio2;
procedure NormDistr;
procedure Calculations;
procedure CumValues;
procedure CalcValues;
procedure WriteOutValues;
procedure ReadAllData;
procedure ReadOutputDataFirst;
procedure MaxMinum;
procedure Normal (YY : real; var XX : real);
procedure DefineDistr;

implementation


{-----------------}
procedure WriteTmp;

var TmpFile : textfile;

begin
  assignFile (TmpFile,'Temp.tmp');
  {$I-}rewrite(TmpFile);{$I+}
  writeln (TmpFile,NumDat:4);
  writeln (TmpFile,Method:3);
  writeln (TmpFile, Minim);
  if (Method>61) and (Method<64) then
  begin
    Slope:=1;
    Inter:=1;
  end;

  if (Method<6) or (Method>50) then if (Method<>67) and (Method<>68)
  and (Method<>61) and (Method<>69) and (Method<>73) then
  begin
    writeln (TmpFile,Slope);
    writeln (TmpFile,Inter);
  end;

  if (Method=6)  then
    writeln (TmpFile,Slope);

  if Method=20 then
  begin
    writeln (TmpFile,MagAv0);
    writeln (TmpFile,StDev0);
  end;

  if Method=21 then
  begin
    writeln (TmpFile,MagAv1);
    writeln (TmpFile,StDev1);
  end;

  if Method=22 then
  begin
    writeln (TmpFile,MagAv2);
    writeln (TmpFile,StDev2);
  end;

  if Method=23 then
  begin
    writeln (TmpFile,MagAv3);
    writeln (TmpFile,StDev3);
  end;

  if Method=24 then
  begin
    writeln (TmpFile,MagAv4);
    writeln (TmpFile,StDev4);
  end;

  if Method=25 then
  begin
    writeln (TmpFile,MagAv5);
    writeln (TmpFile,StDev5);
  end;

  if Method=26 then
  begin
    writeln (TmpFile,Average6);
    writeln (TmpFile,StDev6);
  end;

  if Method=61 then
  begin
    writeln (TmpFile,Slope61);
    writeln (TmpFile,Inter61);
  end;

  if Method=69 then
  begin
    writeln (TmpFile,Expon69);
    writeln (TmpFile,Slope69);
  end;

  close (TmpFile);

end;
{end of WriteTmp}
{---------------}



procedure WriteOut;
{-----------------}

var
Plot,Calc,PrevLower,
Lower, Upper, Obs,
InterTmp, SlopeTmp,
RPr,RPc,RPl,RPu,
Spare, PrevUpper   : real;
jj,kk,ii           : integer;
DumEsc             : boolean;

begin
  AssignFile (OutFile,'TmpFile.Tmp');
  rewrite(OutFile);
  writeln (OutFile,' RESULTS OF CumFreq PROGRAM');
  writeln (OutFile,' Cumulative frequency analysis');
  writeln (OutFile);
  writeln (OutFile,' ',Title1);
  writeln (OutFile,' ',Title2);
  FullName := ChangeFileExt (DMCumFreq.FileName,'.inp');
  writeln (OutFile,' Name of input file used: ',FullName);
  writeln (OutFile,' Number of data used: ',DMCumFreq.NrOfData);
  if Key<>'1' then
     writeln (OutFile,' Probability distribution preferred by user.');
  writeln (OutFile);

  if Method=0 then
  begin
    writeln (OutFile,' The frequency distibution cannot be found :');
    exit;
  end;
  if Method=3 then
  begin
     writeln (OutFile,' The generalized cumulative frequency function is ');
     writeln (OutFile,' a-symptotic exponential (Poisson-type):');
     Distrib:='Generalized exponential';
  end;
  if Method=4 then
  begin
    writeln (OutFile,
         'The cumulative frequency function is double exponential (Gumbel):');
    Distrib:='Gumbel distribution';
  end;
  if Method=5 then
  begin
     writeln (OutFile,' Gumbel mirrored cumulative frequency function :');
    Distrib:='Mirrored Gumbel distribution';
  end;
  if Method=6 then
  begin
     writeln (OutFile,' The cumulative frequency function is ');
     writeln (OutFile,' a-symptotic exponential (Poisson-type):');
     Distrib:='Simple exponential (Poisson)';
  end;
  if Method=31 then
  begin
    writeln (OutFile,' Cumulative Burr frequency function');
    Distrib:='Burr distribution';
  end;
  if Method=32 then
  begin
    writeln (OutFile,' Cumulative Dagum frequency function');
    Distrib:='Dagum distribution';
  end;
  if Method=34 then
  begin
    writeln (OutFile,' Cumulative generalized Gompertz frequency function');
    Distrib:='Generalized Gompertz distribution';
  end;
  if Method=36 then
  begin
    writeln (OutFile,' Kumaraswamy frequency function');
    Distrib:='Kumaraswamy distribution';
  end;
  if Method=51 then
  begin
    writeln (OutFile,' Cumulative frequency function of the generalized'+
                      ' Gumbel type :');
    Distrib:='Generalized Gumbel distribution';
  end;
  if Method=52 then
  begin
    writeln (OutFile,' Cumulative frequency function of the generalized'+
                      ' Gumbel mirrored type :');
    Distrib:='Generalized mirrored Gumbel distribution';
  end;
  if Method=53 then
  begin
    writeln (OutFile,' The cumulative frequency function is logistic :');
    Distrib:='Logistic distribution';
  end;
  if Method=54 then
  begin
    writeln (OutFile,' The cumulative frequency function is log-logistic :');
    Distrib:='Log-logistic distribution';
  end;
  if Method=55 then
  begin
    write   (OutFile,' The cumulative frequency function is generalized');
    writeln (OutFile,' logistic :');
    Distrib:='Generalized logistic distribution';
  end;
  if Method=70 then
  begin
    writeln (OutFile,' The frequency function is composite logistic'+
                     ' generalized:');
    writeln (OutFile,' The separation point is : P = ',
                       format('%8.3e',[Bpoint]));
    Distrib:='Composite generalized logistic distribution';
  end;
  if Method=71 then
  begin
    writeln (OutFile,' The cumulative frequency function is composite Gumbel'+
                     ' generalized:');
    writeln (OutFile,' The separation point is P = : ',
                       format('%8.3e',[Bpoint]));
    Distrib:='Composite generalized Gumbel distribution';
  end;
  if Method=72 then
  begin
    writeln (OutFile,' The cumulative frequency function is composite Poisson'+
                     ' generalized:');
    writeln (OutFile,' The separation point is : P = ',
                       format('%8.3e',[Bpoint]));
    Distrib:='Composite generalized Poisson distribution';
  end;
  if Method=56 then
  begin
    writeln (OutFile,' Cumulative Fisk frequency function (adjusted)');
    Distrib:='Fisk distribution';
  end;
  if Method=57 then
  begin
    writeln (OutFile,' Cumulative frequency function of the Weibull type :');
    Distrib:='Weibull distribution';
  end;
  if Method=58 then
  begin
    writeln (OutFile,' Cumulative frequency function of the Frechet type'+
                      ' (Fisher-Tippett 2):');
    Distrib:='Frechet distribution';
  end;
  if Method=35 then
  begin
    writeln (OutFile,' Cumulative frequency of the mirrored Frechet type'+
                      ' (Fisher-Tippett 2):');
    Distrib:='Mirrored Frechet distribution';
  end;
  if Method=33 then
  begin
     writeln (OutFile,' Cumulative frequency of mirrorred Fisher-Tippett'+
                      ' type III :');
    Distrib:='Mirrored Fisher-Tippett III distribution';
  end;
  if Method=59 then
  begin
     writeln (OutFile,' Cumulative frequency function of the Fisher-Tippett'+
                      ' type III :');
    Distrib:='Fisher-Tippett type 3 distribution';
  end;
  if Method=60 then
  begin
    writeln (OutFile,' Cumulative frequency of the mirrorred'+
                      ' Weibull type :');
    Distrib:='Mirrored Weibull distribution';
  end;
  if Method=61 then
  begin
    writeln (OutFile,' Cumulative frequency of the Gamma (Erlang) type');
    Distrib:='Gamma (Erlang) distribution';
  end;
  if Method=62 then
  begin
    writeln (OutFile, ' Cumulative Student distribution with 1 d.f.');
    writeln (OutFile, ' A helpvariable is used: Y = (X-Av.X)/St.DevX.');
    Distrib:='Student distribution with 1 d.f.';
  end;
  if Method=63 then
  begin
    writeln (OutFile, ' Cumulative Student distribution with 2 d.f.');
    writeln (OutFile, ' A helpvariable is used: Y = (X-Av.X)/St.DevX.');
    Distrib:='Student distribution with 2 d.f.';
  end;
  if Method=64 then
  begin
    writeln (OutFile, ' Cumulative Cauchy distribution');
    Distrib:='Cauchy distribution';
  end;
  if Method=65 then
  begin
    writeln (OutFile, ' Cumulative generalized Cauchy distribution');
    Distrib:='Generalized Cauchy distribution';
  end;
  if Method=66 then
  begin
    writeln (OutFile,' Cumulative frequency function of the generalized'+
                      ' mirrored Poisson type :');
    Distrib:='Generalized mirrored Poisson distribution';
  end;
  if Method=67 then
  begin
    writeln (OutFile,' Cumulative frequency of the generalized'+
                      ' extreme value (GEV) type :');
    Distrib:='Generalized extreme value (GEV) distribution';
  end;
  if Method=68 then
  begin
    writeln (OutFile,' Cumulative frequency of the composite Laplace'+
                      ' distribution :');
    Distrib:='Composite Laplace distribution';
  end;
  if Method=69 then
  begin
    writeln (OutFile,' Cumulative frequency function of the Rayleigh type :');
    Distrib:='Generalized Rayleigh distribution';
  end;
  if Method=73 then
  begin
    writeln (OutFile,' Cumulative frequency of the generalized Laplace'+
                      ' distribution :');
    Distrib:='Generalized Laplace distribution';
  end;
  if Method=7 then
  begin
    writeln (OutFile,' The cumulative frequency function composite Gumbel'+
                     ' mirrored :');
    writeln (OutFile,' The separation point is : P = ', Bpoint7+Minim:6:3);
    Distrib:='Composite mirrored Gumbel distribution';
  end;
  if Method=8 then
  begin
    writeln (OutFile,' The cumulative frequency function is composite Logistic :');
    writeln (OutFile,' The separation point is : P = ', Bpoint8+Minim:6:3);
    Distrib:='Composite logistic distribution';
  end;
  if Method=9 then
  begin
    writeln (OutFile,' The cumulative frequency function is composite Gumbel :');
    writeln (OutFile,' The separation point is : P = ', Bpoint9+Minim:6:3);
    Distrib:='Composite Gumbel distribution';
  end;
  if Method=10 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Gumbel mirrored (<P) + Logistic (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint10+Minim:6:3);
    Distrib:='Composite Gumbel mirrored + logistic distribution';
  end;
  if Method=11 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Gumbel mirrored (<P) and Gumbel standard (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint11+Minim:6:3);
    Distrib:='Mirrored Gumbel + standard Gumbel distribution';
  end;
  if Method=12 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,' Gumbel (<P) and logistic (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint12+Minim:6:3);
    Distrib:='Composite Gumbel + logistic distribution';
  end;
  if Method=13 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Gumbel standard (<P) and Gumbel mirrored (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint13+Minim:6:3);
    Distrib:='Standard Gumbel + mirrored Gumbel distribution';
  end;
  if Method=14 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Logistic (<P) + Gumbel mirrored (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint14+Minim:6:3);
    Distrib:='Composite logistic + mirrored Gumbel distribution';
  end;
  if Method=15 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Logistic (<P) + Gumbel (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint15+Minim:6:3);
    Distrib:='Composite logistic + Gumbel distribution';
  end;
  if Method=16 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'      Gumbel (<P) + Poisson (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint16+Minim:6:3);
    Distrib:='Composite Gumbel + Poisson distribution';
  end;
  if Method=17 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Gumbel mirored (<P) + Poisson (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint17+Minim:6:3);
    Distrib:='Composite Gumbel mirrored + Poisson distribution';
  end;
  if Method=18 then
  begin
    writeln (OutFile,' The cumulative frequency function is composed of :');
    writeln (OutFile,'     Logistic (<P) + Poisson (>P) :');
    writeln (OutFile,' The separation point is : P = ', Bpoint18+Minim:6:3);
    Distrib:='Composite logistic + Poisson distribution';
  end;

  if Method=20 then
  begin
    writeln (OutFile,' The cumulative frequency function is normal.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Normal distribution (standard)';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
      format('%8.3e',[-Minim]));
      MagAv:=MagAv+Minim;
    end;
  end;

  if Method=21 then
  begin
    writeln (OutFile,' The probability distribution is optimized normal.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Normal distribution optimized';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      write   (OutFile,' The standard error of X+C : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end else
    begin
      write   (OutFile,' The standard error of X: ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end;
  end;

  if Method=22 then
  begin
    writeln (OutFile,' The cumulative frequency function is log-normal.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Log-normal distribution';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      writeln (OutFile,' The mean value of Ln (X+C) is : ',
               format('%8.3e',[Average]));
      writeln (OutFile,' The standard error of Ln(X+C) : ',
               format('%8.3e',[StErr]));
    end else
    begin
      writeln (OutFile,' The mean value of Ln (X) is : ',
               format('%8.3e',[Average]));
      writeln (OutFile,' The standard error of Ln(X) : ',
               format('%8.3e',[StDev]));
    end;
  end;

  if Method=23 then
  begin
    writeln (OutFile,' The cumulative distribution is log-normal optimized.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Log-normal distribution optimized';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      writeln (OutFile,' The mean value of Ln (X+C)    : ',
               format('%8.3e',[Average]));
      write   (OutFile,' The standard error of Ln(X+C) : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end else
    begin
      writeln (OutFile,' The mean value of Ln (X)    : ',
               format('%8.3e',[Average]));
      write   (OutFile,' The standard error of Ln(X) : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end;
  end;

  if Method=24 then
  begin
    writeln (OutFile,' The cumulative frequency function is root-normal.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Root-normal distribution';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      writeln (OutFile,' The mean value of sqrt(X+C)     : ',
               format('%8.3e',[Average]));
      write   (OutFile,' The standard error of sqrt(X+C) : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end else
    begin
      writeln (OutFile,' The mean value of sqrt(X)     : ',
               format('%8.3e',[Average]));
      write   (OutFile,' The standard error of sqrt(X) : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end;
  end;

  if Method=25 then
  begin
    writeln (OutFile,' The cumulative frequency function is square-normal.');
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Square-normal distribution';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      writeln (OutFile,' The mean value of (X+C)sq     : ',
               format('%8.3e',[Average]));
      write   (OutFile,' The standard error of (X+C)sq : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end else
    begin
      write   (OutFile,' The mean value of Xsq     : ',
               format('%8.3e',[Average]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[MagAv]));
      write   (OutFile,' The standard error of Xsq : ',
               format('%8.3e',[StErr]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev]));
    end;
  end;

  if Method=26 then
  begin
    writeln (OutFile,' The frequency function is generalized normal.');
    writeln (OutFile,' The X-data were temporarily transformed into X^E');
    writeln (OutFile,' The exponent E is : ',
             format('%8.3e',[Expon26]));
    writeln (OutFile,' The numerical method of Hastings is applied.');
    Distrib:='Generalized normal distribution';
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]));
      MagAv:=MagAv+Minim;
      writeln (OutFile,' The average value of (X+C)^E  : ',
                         format('%8.3e',[Average6]));
      write   (OutFile,' The standard error of (X+C)^E : ',
               format('%8.3e',[StErr6]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev6]));
    end else
    begin
      writeln (OutFile,' The average value of X^E  : ',
                         format('%8.3e',[Average6]));
      write   (OutFile,' The standard error of X^E : ',
                         format('%8.3e',[StErr6]));
      writeln (OutFile,' is optimized as : ',
               format('%8.3e',[StDev6]));
    end;
  end;

  writeln (OutFile);

  if Method=3 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1-exp[-{A*(X+C)^E+B}]');
    end else
      writeln (OutFile,'     Freq = 1-exp{-(A*X^E+B)}');
  end;
  if Method=4 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-exp{-(A*(X+C)+B)}]');
    end else
      writeln (OutFile,'     Freq = exp[-exp{-(A*X+B)}]');
  end;
  if Method=5 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
   writeln (OutFile,'     Freq = 1-exp[-exp{-(A*(X+C)+B)}]');
    end else
      writeln (OutFile,'     Freq = 1-exp[-exp{-(A*X+B)}]');
  end;
  if Method=6 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1-exp[-A*(X+C)]');
    end else
      writeln (OutFile,'     Freq = 1-exp{-A*X}');
  end;
  if Method=31 then           {Burr}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1-[B/(X^A+B+C)]^E');
    end else
      writeln (OutFile,'     Freq = 1-[B/(X^A+B)]^E');
    write (Outfile,'        B = ',format('%8.3e',[Inter31]) );
    write (OutFile,'        A = ',format('%8.3e',[AA1B]) );
    writeln (OutFile,'      E = ',format('%8.3e',[Slope31]) );
  end;
  if Method=32 then        {Dagum}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'    Freq = exp(E*Z+D) where Z = ln[B/{X^(A+C)+B}]+D');
    end else
      writeln (OutFile,'    Freq = exp(E*Z+D) where Z = ln[B/(X^A+B)]');
        write (Outfile,'    B = ',format('%8.3e',[Inter32]) );
        write (OutFile,'    A = ',format('%8.3e',[AA1D]) );
        write (OutFile,'    D = ',format('%8.3e',[Dag]) );
      writeln (OutFile,'    E = ',format('%8.3e',[Slope32]));
  end;
  if (Method=34) then
  begin
    if NegVal then
    begin
      if Small then
      begin
        writeln (OutFile,' An additional term C is used : C = ',
                 format('%8.3e',[-Minim]) );
        writeln (OutFile,'     Freq = 1-exp[A*{Exp(B*Z^E) - 1}]'+
                         '  where Z = X-C');
      end else
        writeln (OutFile,'     Freq = 1-exp[A*{Exp{B*X^E) - 1}]');
    end;
    if not NegVal then
    begin
      if Small then
        writeln (OutFile,'     Freq = 1-exp[A*{Exp(B*Z^E) - 1}]',
                         '    where Z = X+1')
      else
        writeln (OutFile,'     Freq = 1-exp[A*{Exp(B*X^E) - 1}]');
    end;
    write   (Outfile,'        A = ',format('%8.3e',[Slope34]) );
    write   (OutFile,'      B = ',format('%8.3e',[BE1G]) );
    writeln (OutFile,'      E = ',format('%8.3e',[AA1G]) );
  end;
  if Method=36 then  {Kumaraswamy}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1 - [1 - {(X+C)/M)}^A)]^B');
    end else
      writeln (OutFile,'     Freq = 1 - [1 - (X/M)^A]^B]');
    write   (Outfile,'      M = ',format('%8.3e',[MaxVal]) );
    write   (OutFile,'      A = ',format('%8.3e',[Expon36]) );
    writeln (OutFile,'      B = ',format('%8.3e',[Slope36]) );
  end;
  if Method=51 then                                               {Gen. Gumbel}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-exp{-(A*(X+C)^E+B)}]');
    end else
      writeln (OutFile,'     Freq = exp[-exp{-(A*X^E+B)}]');
  end;
  if Method=52 then                                         {Gen. Gumbel Mirr.}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1-exp[-exp{-(A*(X+C)^E+B)}]');
    end else
      writeln (OutFile,'     Freq = 1-exp[-exp{-(A*X^E+B)}]');
  end;
  if Method=53 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1/[1+exp{A*(X+C)+B)}]');
    end else
      writeln (OutFile,'     Freq = 1/{1+exp(A*X+B)}');
  end;
  if Method=54 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1/{1+exp(A*Ln(X+C)+B)}');
    end else
      writeln (OutFile,'     Freq = 1/{1+exp(A*LnX+B)}');
  end;
  if Method=55 then                                             {Gen. logistic}
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]));
      writeln (OutFile,'     Freq = 1/{1+exp(A*Y^E+B)}');
    end else
      writeln (OutFile,'     Freq = 1/{1+exp(A*X^E+B)}');
  end;
  if Method=70 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*Y^Es+Bs)}');
    end else
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));
    if NegVal then
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*Y^Eg+Bg)}')
    else
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=71 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*Y^Es+Bs)}]');
    end else
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*X^Es+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));
    if NegVal then
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*Y^Eg+Bg)}]')
    else
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*X^Eg+Bg)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=72 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = 1-exp[-{As*(X+C)^Es+Bs}]');
    end else
      writeln (OutFile,' X < P :  Freq = 1-exp{-(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));
    if NegVal then
      writeln (OutFile,' X > P :  Freq = 1-exp[-{Ag*(X+C)^Eg+Bg}]')
    else
      writeln (OutFile,' X > P :  Freq = 1-exp{-(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=80 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*Y^Es+Bs)}');
    end else
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*Y^Eg+Bg)}]')
    else
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*X^Eg+Bg)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=81 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*Y^Es+Bs)}');
    end else
      writeln (OutFile,' X < P : Freq = 1/{1+exp(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P :  Freq = 1-exp[-{Ag*(X+C)^Eg+Bg}]')
    else
      writeln (OutFile,' X > P :  Freq = 1-exp{-(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=82 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*Y^Es+Bs)}]');
    end else
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*X^Es+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*Y^Eg+Bg)}')
    else
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=83 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*Y^Es+Bs)}]');
    end else
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*X^Es+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P :  Freq = 1-exp[-{Ag*(X+C)^Eg+Bg}]')
    else
      writeln (OutFile,' X > P :  Freq = 1-exp{-(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=84 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = 1-exp[-{As*(X+C)^Es+Bs}]');
    end else
      writeln (OutFile,' X < P :  Freq = 1-exp{-(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*Y^Eg+Bg)}')
    else
      writeln (OutFile,' X > P : Freq = 1/{1+exp(Ag*X^Eg+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=85 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = 1-exp[-{As*(X+C)^Es+Bs}]');
    end else
      writeln (OutFile,' X < P :  Freq = 1-exp{-(As*X^Es+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    writeln (OutFile,'          The value of exponent Es is: ',
                                    format('%8.3e',[ExponA]));

    if NegVal then
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*Y^Eg+Bg)}]')
    else
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*X^Eg+Bg)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
    writeln (OutFile,'          The value of exponent Eg is: ',
                                    format('%8.3e',[ExponB]));
  end;

  if Method=56 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1-{B/(X+C+B)}^A');
    end else
      writeln (OutFile,'     Freq = 1-{B/(X+B)}^A');
  end;
  if Method=57 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
                         format('%8.3e',[-Minim]));
      writeln (OutFile,'     Freq = exp[-{(X+T)/C}^A)}');
    end else
      writeln (OutFile,'     Freq = exp[-(X/C)^A]');
  end;
  if Method=58 then                                                   {Frechet}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-{(X+T-C)/exp(-B/A)}^A]');
    end else
      writeln (OutFile,'     Freq = exp[-{(X-C)/exp(-B/A)}^A]');
  end;
  if Method=35 then                                             {Frechet mirr.}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1 - exp[-{(X+T-C)/exp(-B/A)}^A]');
    end else
      writeln (OutFile,'     Freq = 1 - exp[-{(X-C)/exp(-B/A)}^A]');
  end;
  if Method=59 then                                              {Fisher III}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-{(C-X-T)/exp(-B/A)}^A]');
    end else
      writeln (OutFile,'     Freq = exp[-{(C-X)/exp(-B/A)}^A]');
  end;
  if Method=33 then                                              {Fisher III}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1 - exp[-{(C-X-T)/exp(-B/A)}^A]');
    end else
      writeln (OutFile,'     Freq = 1 - exp[-{(C-X)/exp(-B/A)}^A]');
  end;
  if Method=60 then                                              {mirr. Weibull}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-{(X+T)^E/C}^A)]');
    end else
      writeln (OutFile,'     Freq = exp{-(X^E/C)^A)}');;
  end;
  if Method=61 then                                              {Erlang}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Fc = 1 - Sum(1/n!).[ {(X+C)/A}^n.exp{-(X+C)/A} ]');
    end else
      writeln (OutFile,'     Fc = 1 - Sum [ (1/n!).{(X/A)^n}.exp(-X/A) ]');;
    writeln (OutFile,'     Summation from n=0 to n=B');
  end;
  if Method=62 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 0.5 + arctan(Y+T)/pi');
    end else
      writeln (OutFile,'     Freq = 0.5 + arctan(Y)/pi');
  end;
  if Method=63 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 0.5[1+{(Y+T)/sqrt(2+(Y+T)^2)}]');
    end else
      writeln (OutFile,'     Freq = 0.5[1+{Y/sqrt(2+Y^2)}]');
  end;
  if Method=64 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = (1/pi)*arctan{A*(X+T)-B}+0.5');
      Slope:=1/Slope;
    end else
      writeln (OutFile,'     Freq = (1/pi)*arctan(A*X+B)+0.5');
  end;
  if Method=65 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term T is used : T = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = (1/pi)*arctan{A*(X+T)^E+B}+0.5');
      Slope:=1/Slope;
    end else
      writeln (OutFile,'     Freq = (1/pi)*arctan(A*X^E+B)+0.5');
  end;
  if Method=66 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-{A*(X+C)^E+B}]');
    end else
      writeln (OutFile,'     Freq = exp{-(A*X^E+B)}');
  end;
  if Method=67 then                                          {GEV}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = exp[-{1+K(X+C-A)/B}^(-1/K)]');
    end else
    begin
      writeln (OutFile,'     Freq = exp[-{1+K(X-A)/B}^(-1/K)]');
      writeln (OutFile,'     K = ',format('%8.3e',[Expon67]) ,
      '  A = ',format('%8.3e',[MagAv67]),
      '  B = ',format('%8.3e',[StErr67]) );
    end;
  end;
  if Method=68 then   {Laplace}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,' X<B Freq = 0.5*exp{A1*(X+C-B)}');
      writeln (OutFile,' X>B Freq = 1-0.5*exp{A2*(B-X-C)}');
      writeln (OutFile,'        B =  ',format('%8.3e',[BoundL1]),
               '  A1 =  ',format('%8.3e',[1/BB1]),
               '  A2 =  ',format('%8.3e',[1/BB2]) );
    end else
    begin
      writeln (OutFile,' X<B Freq = 0.5*exp{A1*(X-B)}');
      writeln (OutFile,' X>B Freq = 1-0.5*exp{A2*(B-X)}');
      writeln (OutFile,'        B =  ',format('%8.3e',[BoundL1]),
               '  A1 =  ',format('%8.3e',[1/BB1]),
               '  A2 =  ',format('%8.3e',[1/BB2]) );
    end;
  end;
  if Method=69 then                                      {gen. Rayleigh}
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,'     Freq = 1 - exp((X+C)^E/S)');
    end else
      writeln (OutFile,'     Freq = 1 - exp(X^E/S)');
  end;
  if Method=73 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
               format('%8.3e',[-Minim]) );
      writeln (OutFile,' X<B Freq = 0.5*exp[A1*{(X+C)^E1-B}]');
      writeln (OutFile,' X>B Freq = 1-0.5*exp[A2*{B-(X+C)^E2}]');
      writeln (OutFile,' B =  ',format('%8.3e',[BoundLG]),
               '  A1 =  ',format('%8.3e',[1/BB1G]),
               '  A2 =  ',format('%8.3e',[1/BB2G]));
      writeln (OutFile,' The exponents are: E1 =  ',
               format('%8.3e',[Expon73A]),'  and E2 =  ',
               format('%8.3e',[Expon73B]) );
    end else
    begin
      writeln (OutFile,' X<B Freq = 0.5*exp{A1*(X^E1-B)}');
      writeln (OutFile,' X>B Freq = 1-0.5*exp{A2*(B-X^E2)}');
      writeln (OutFile,' B =  ',format('%8.3e',[BoundLG]),
               '  A1 =  ',format('%8.3e',[1/BB1G]),
               '  A2 =  ',format('%8.3e',[1/BB2G]));
      writeln (OutFile,' The exponents are: E1 =  ',
               format('%8.3e',[Expon73A]),'  and E2 =  ',
               format('%8.3e',[Expon73B]) );
    end;
  end;

  if ((Method>0) and (Method<7)) or ((Method>50) and (Method<61))
  or (method=35) or (method=33) or (Method>63) then if Method<>73 then
  begin
    if Method=3 then writeln (OutFile,'     The exponent E = ',
                                                format('%8.3e',[Expon3]));
    if Method=51 then writeln (OutFile,'     The exponent E = ',
                                                 format('%8.3e',[Expon51]));
    if Method=52 then writeln (OutFile,'     The exponent E = ',
                                                 format('%8.3e',[Expon52]));
    if Method=55 then writeln (OutFile,'     The exponent E = ',
                                                 format('%8.3e',[Expon55]));
    if Method=57 then
    begin
      Plot := exp(-Inter/Slope);
      writeln (OutFile,'     C    = exp(-B/A) = ',format('%8.3e',[Plot]) );
    end;
    if Method=58 then
    begin
      Bound58:=Bound58 + Minim;
      writeln (OutFile,'     C    = ',format('%8.3e',[Bound58]) );
      if WarnType2 then writeln (OutFile, ' Warning, there are values smaller'+
                                          ' than the lower bound C');
    end;
    if Method=35 then
    begin
      Bound35:=Bound35 + Minim;
      writeln (OutFile,'     C    = ',format('%8.3e',[Bound35]) );
      if WarnType2 then writeln (OutFile, ' Warning, there are values smaller'+
                                          ' than the lower bound C');
    end;
    if Method=33 then
    begin
      Bound33:=Bound33 + Minim;
      writeln (OutFile,'     C    = ',format('%8.3e',[Bound33]) );
      if WarnType3 then writeln (OutFile, ' Warning, there are values larger'+
                                          ' than the upper bound C');
    end;
    if Method=59 then
    begin
      Bound59:=Bound59 + Minim;
      writeln (OutFile,'     C    = ',format('%8.3e',[Bound59]) );
      if WarnType3 then writeln (OutFile, ' Warning, there are values larger'+
                                          ' than the upper bound C');
    end;

    if Method=65 then writeln (OutFile,'     The exponent E = ',
                                                 format('%8.3e',[Expon65]));
    if Method=66 then writeln (OutFile,'     The exponent E = ',
                                                 format('%8.3e',[Expon66]));
    if Method=67 then
    begin
      if Bounded then
      begin
         writeln(OutFile,' The K-value is not optimal: ');
         writeln(OutFile,' There are data beyond the bound.');
      end;
    end;

    if Method=69 then
    begin
      writeln (OutFile,'     The exponent E = ',format('%8.3f',[Expon69]),
      ' The value of divider S = ',format('%8.3f',[Slope69]));
    end;

    if (Method<70) and (Method<>61) and (Method<>67) and (Method<>68)
        and (Method<>69) then
             writeln (Outfile,'     A    = ',format('%8.3e',[Slope]));
    if (Method<70) and (Method<>6) and (Method<>61) and (Method<>67)
    and (Method<>68) and (Method<>69) then
       writeln (OutFile,'     B    = ',format('%8.3e',[Inter]) );

  end; {if ((Method>0) and (Method<6)) or ((Method>50) and (Method<61))
        or (Method>63) then}

  if Method=4 then
  begin
    writeln (OutFile,'   Mode   =  ',format('%8.5e',[-Inter/Slope]));
    writeln (OutFile,' The standard error of X is optimized as ', StDev:7:2);
    writeln (OutFile);
  end else
    writeln (OutFile);

  if Method=7 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'      X < P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'      X < P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
    begin
      writeln (OutFile,'      X > P :  Freq = 1-exp[-exp{-(Ag*Y+Bg)}]');
    end else
      writeln (OutFile,'      X > P :  Freq = 1-exp[-exp{-(Ag*X+Bg)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=8 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'      X < P :  Freq = 1/{1+exp(As*(Y+Bs)}');
    end else
      writeln (OutFile,'      X < P :  Freq = 1/{1+exp(As*X+Bs)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'      X > P :  Freq = 1/[1+exp{Ag*Y+Bg)}]')
    else
      writeln (OutFile,'      X > P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=9 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,' X < P :  Freq = exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*Y+Bg)}]')
    else
      writeln (OutFile,' X > P :  Freq = exp[-exp{-(Ag*X+Bg)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=10 then
  begin
    writeln (OutFile);
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1/{1+exp(Ag*Y+Bg)}')
    else
      writeln (OutFile,'     X > P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=11 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = exp[-exp{-(Ag*Y+B)}]')
    else
      writeln (OutFile,'     X > P :  Freq = exp[-exp{-(Ag*X+B)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=12 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1/[1+exp{Ag*Y+Bg}]')
    else
      writeln (OutFile,'     X > P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=13 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]')
    else
      writeln (OutFile,'     X > P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=14 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1/[1+exp{Ag*Y+Bg}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]')
    else
      writeln (OutFile,'     X > P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=15 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1/[1+exp{Ag*Y+Bg}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = exp[-exp{-(As*Y+Bs)}]')
    else
      writeln (OutFile,'     X > P :  Freq = exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=16 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1-exp[-{Ag*Y)+Bg}]')
    else
      writeln (OutFile,'     X > P :  Freq = 1-exp{-(Ag*X+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=17 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' The variable X is replaced by Y=X+C,'+
                       ' with C = ',format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*Y+Bs)}]');
    end else
      writeln (OutFile,'     X < P :  Freq = 1-exp[-exp{-(As*X+Bs)}]');
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1-exp[-{Ag*Y)+Bg}]')
    else
      writeln (OutFile,'     X > P :  Freq = 1-exp{-(Ag*X+Bg)}');
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  if Method=18 then
  begin
    if NegVal then
    begin
      writeln (OutFile,' An additional term C is used : C = ',
                         format('%8.3e',[-Minim]) );
      writeln (OutFile,'     X < P :  Freq = 1/[1+exp{Ag*(X+C)+Bg}]');
    end else
    begin
      writeln (OutFile,'     X < P :  Freq = 1/{1+exp(Ag*X+Bg)}');
    end;
    write   (Outfile,'          As = ',format('%8.3e',[SlopeA]) );
    writeln (OutFile,'        Bs = ',format('%8.3e',[InterA]) );
    if NegVal then
      writeln (OutFile,'     X > P :  Freq = 1-exp[-{Ag*(X+C)+Bg}]')
    else
    write   (Outfile,'          Ag = ',format('%8.3e',[SlopeB]) );
    writeln (OutFile,'        Bg = ',format('%8.3e',[InterB]) );
  end;

  decim:=3;
  if Limit[Steps+1]>10 then Decim:=2;
  if Limit[Steps+1]>100 then Decim:=1;
  if Limit[Steps+1]>1000 then Decim:=0;
  InterTmp:=Inter;
  SlopeTmp:=Slope;
  Regres1;            //only to determine MagAv in case of discontinuity
  Inter:=InterTmp;
  Slope:=SlopeTmp;
  if NegVal then for kk:=1 to NumDat do Mag[kk]:=Mag[kk]+Minim-0.0001;
  Median  := Mag[NumDat div 2];
  MagAv   := MagAv+Minim-0.0001;

  write   (OutFile,' Average X:',MagAv:7:decim);
  writeln (OutFile,'     Median X:',Median:7:decim,
                   '     St.Dev. X:',StErr:7:decim+1);
  writeln (OutFile);
  writeln (OutFile);

  writeln (OutFile,' Interval analysis');
  writeln (OutFile,' --------------------------------------');
  writeln (OutFile,'   Class limits of X    Class frequency');
  writeln (OutFile,'    Lower    Upper      Obs. (%)  Calc.');
  writeln (OutFile,' --------------------------------------');

  for kk:=1 to Steps+2 do Limit[kk]:=Limit[kk]+Minim-0.0001;
  Plot:=Limit[1]-0.5*(Limit[2]-Limit[1]);
  Inflex:=100*Border[1];
  Obs:=0;
  Spare:=0;
  if Inflex<0 then
  begin
    Spare:=Inflex;
    Inflex:=0;
  end;
  writeln (OutFile,Plot:8:decim,Limit[1]:10:decim,Obs:10:1,Inflex:10:1);
  for ii:=1 to Steps do
  begin
    Plot := 100*Num[ii]/NumDat;
    if Border[ii]>1 then Border[ii]:=1;
    if Border[ii+1]>1 then Border[ii+1]:=1;
    if Spare<0 then
    begin
      Calc   := 100*(Border[ii+1]-Border[ii])+Spare;
      Spare  :=0;
    end else
       Calc   := 100*(Border[ii+1]-Border[ii]);
    Inflex := Border[ii];
    writeln (OutFile,Limit[ii]:8:decim,Limit[ii+1]:10:decim,
             Plot:10:1,Calc:10:1);
  end;
  Inflex:=100*(1-Border[Steps+1]);
  if Inflex<0 then Inflex:=0;
  Plot:=Limit[Steps+1]+1.5*(Limit[Steps]-Limit[Steps-1]);
  For ii:=1 to Steps do Obs:=Obs+Num[ii];
  Obs:=100*(NumDat-Obs)/NumDat;
  writeln (OutFile,Limit[Steps+1]:8:decim,Plot:10:decim,Obs:10:1,Inflex:10:1);
  writeln (OutFile,' --------------------------------------');

  writeln (OutFile);
  writeln (OutFile);
  writeln (OutFile,' Observed and calculated cumulative frequencies');
  writeln (OutFile,' ------------------------------------------------------------------');
  writeln (OutFile,'   X-value   Serial    Cumulative frequency (%)       90%conf limit');
  writeln (OutFile,'   Ranked     No.      Rank      Calc.    St.Dev     Lower    Upper');
  writeln (OutFile,' ------------------------------------------------------------------');
  decim:=0;
  if Mag[NumDat]<1 then decim:=4;
  if (Mag[NumDat]>=1) and (Mag[NumDat]<10) then decim:=3;
  if (Mag[NumDat]>=10) and (Mag[NumDat]<100) then decim:=2;
  if (Mag[NumDat]>=100) and (Mag[NumDat]<500) then decim:=1;
  if Mag[Numdat]>=500 then decim:=0;
  Lower:=0.001;
  Upper:=0.999;

  for jj:=1 to NumDat do
  begin
    write (OutFile,(Mag[jj]):8:decim);
    setlength (Ser,jj+1);
    write (OutFile,'      ',Ser[jj]);
    if Ser[jj]<10 then write (OutFile,'  ')
    else if Ser[jj]<100 then write (OutFile,' ');
    Plot  := 100*Frq[jj];
    if Plot>99.99 then Plot:=99.99;
    Calc  := 100*FrqCalc[jj];
    if Calc<=0 then Calc:=0.5*Plot;
    if Calc>99.99 then Calc:=99.99;
    StDev := (100/NumDat)*exp(0.5*ln((Calc/100)*(1-(Calc/100))*NumDat));
    PrevLower:=Lower;
    Lower := Calc - 3.4*StDev*Calc/100;
    if Lower<=0 then Lower := 0.0001;
    if Lower<PrevLower then Lower:=PrevLower;
    if Lower>99.99 then Lower := 99.99;
    PrevUpper:=Upper;
    Upper := Calc + 3.4*StDev*(100-Calc)/100;
    if Upper>99.99 then Upper:=99.99;
    if Upper<PrevUpper then Upper:=PrevUpper;
    if Upper<=1.00001*Calc then
       Upper:=99.99;
    writeln (OutFile,
             Plot:10:2,Calc:10:2,StDev:10:2,Lower:10:2,Upper:10:2);
  end;
  writeln (OutFile,' ------------------------------------------------------------------');

  Result1:=0;
  for kk:=1 to NumDat do
  begin
    Residu := abs(FrqCalc[kk]-Frq[kk]);
    Result1 := Result1+Residu;
  end;
  writeln (OutFile,' Average of absolute differences between calculated and');
  writeln (OutFile,' observed frequencies :',100*Result1/NumDat:10:2,'%');
  DMCumFreq.AvAbsDiff:=100*Result1/NumDat;
  Result1:=0;
  Result2:=0;
  Result3:=0;
  for kk:=1 to NumDat do Result2:=Result2+Frq[kk];
  Result2:=Result2/NumDat;                             {av. frq. obs.}
  for kk:=1 to NumDat do
  begin
    Residu := sqr(FrqCalc[kk]-Frq[kk]);                {square of difference}
    Result1 := Result1+Residu;
    Result3 := Result3+ sqr(Frq[kk]-Result2);          {square of deviation}
  end;
  Result2:=1-Result1/Result3;
  writeln (OutFile,' Efficiency coefficient (R^2) of calculated and observed');
  writeln (OutFile,' cumulative frequency :',Result2:11:4);
  writeln (OutFile);
  writeln (OutFile);
  writeln (OutFile,' Return period = 1/(1-Cum.Frq), time units as used for'+
                   ' the data ');
  writeln (OutFile,' ------------------------------------------------------'+
                   '--------');
  writeln (OutFile,'   X-value    Serial      Return period        90% conf'+
                   ' limit');
  writeln (OutFile,'   Ranked      No.       Rank       Calc.      Lower    '+
                   'Upper');
  writeln (OutFile,' -------------------------------------------------------'+
                   '-------');

  Result2:=0;
  for jj:=1 to NumDat do
  begin
    write (OutFile,Mag[jj]:8:decim);
    write (OutFile,'      ',Ser[jj]);
    if Ser[jj]<10 then write (OutFile,'  ')
    else if Ser[jj]<100 then write (OutFile,' ');
    Plot  := Frq[jj];
    Calc  := FrqCalc[jj];
    if Calc<=0 then Calc:=0.5*Plot;
    if Calc>0.9999 then Calc:=0.9999;
    StDev := (1/NumDat)*exp(0.5*ln(Calc*(1-Calc)*NumDat));
    RPr := 1/(1-Plot);
    RPc := 1/(1-Calc);
    Result2:=Result2+RPr;                                 {sum observed}
    Lower := Calc - 3.4*StDev*Calc;
    if Lower<=0 then Lower := 0.001;
    Upper := Calc + 3.4*StDev*(1-Calc);
    if Upper>0.9999 then Upper := 0.9999;
    RPl := 1/(1-Lower);
    RPu := 1/(1-Upper);
    Result1 := RPu - RPl;
    RPl := RPc - 0.33*Result1;
    RPu := RPc + 0.67*Result1;
    if (Calc<0.6) then
      writeln (OutFile,RPr:11:2,Rpc:11:2,RPl:11:2,RPu:11:2)
    else
    begin
      if (Calc<0.99) and (Upper<0.99) then
         writeln (OutFile,RPr:11:1,Rpc:11:1,RPl:11:1,RPu:11:1)
      else
         writeln (OutFile,RPr:11:0,RPc:11:0,RPl:11:0,RPu:11:0);
    end;
  end;
  writeln (OutFile,' --------------------------------------------------------------');

  Result2:=Result2/NumDat;                       {av. ret. per. obs., RPr}
  Result1:=0;
  Result3:=0;
  for kk:=1 to NumDat do
  begin
    Plot  := Frq[kk];
    Calc  := FrqCalc[kk];
    RPr := 1/(1-Plot);                               {RP observed}
    if Calc>0.99999 then Calc:=0.99999;
    RPc := 1/(1-Calc);                               {RP calculated}
    Residu := abs(RPr-RPc);                          {abs. difference}
    Result1 := Result1+Residu;                       {sum of abs. diff.}
    Result3 := Result3 + RPr                         {sum of obs. freq}
  end;
  writeln (OutFile,' Average of absolute differences between calculated and');
  writeln (OutFile,' observed return periods :',Result1/NumDat:10:2);
  closefile (OutFile);

end;
{end of WriteOut}
{---------------}



{Intervals is part of Functions}
{------------------------------}
procedure Intervals;

var ii,kk, jj, mm : integer;
    Step, AuxVar, MagRed, MagTrf, MagTrSq : real;
    Term1, Term2, Term3, Term4, Term5, TermSum, TmpR : real;
    MagAve, StDevi : real;

begin

  if Table then
  begin
    Steps := StrToInt(DMCumFreq.NrOfClasses);
    Step := (Mag[NumDat]-Mag[1])/Steps;
  Limit[1]:=Mag[1];
  end else
  begin
    Steps := 20;
    if DMCumFreq.Xvalue[0]<0.0001+Minim then DMCumFreq.Xvalue[0]:=0.0001+Minim;
    Step := (DMCumFreq.Xvalue[DmCumFreq.NrOfData-1]-DMCumFreq.Xvalue[0])/Steps;
    Limit[1]:=DMCumFreq.Xvalue[0];
  end;
  for ii:=1 to Steps+1 do
  begin
    Limit[ii+1]:=Limit[ii]+Step;
    Num[ii]:=0;
  end;
   if Limit[1]=0 then Limit[1]:=Limit[1]+0.0001;
  Limit[Steps+1]:=Limit[Steps+1]+0.0002;

  if Limit[1]<0 then for ii:=1 to Steps+1 do Limit[ii]:=Limit[ii]-Minim;

  for ii:=1 to Steps do  if Table then
  begin
      for kk:=1 to NumDat do
      begin
        if abs(Mag[kk]-Limit[ii+1])<0.0001 then Mag[kk]:=Limit[ii+1];
        if (Mag[kk]<Limit[ii+1]) and (Mag[kk]>=Limit[ii]) then
            Num[ii] := Num[ii] + 1;
      end;
  end else
  begin
      for kk:=0 to DMCumFreq.NrOfData-1 do
      begin
        if abs(DMCumFreq.Xvalue[kk]-Limit[ii+1])<0.0001 then
           DMCumFreq.Xvalue[kk]:=Limit[ii+1];
        if (DMCumFreq.Xvalue[kk]<Limit[ii+1])
            and (DMCumFreq.Xvalue[kk]>=Limit[ii]) then
            Num[ii] := Num[ii] + 1;
      end;
  end;


  for ii:=1 to Steps+1 do
  begin

    if Method=3 then
    begin
      TmpR := exp(Expon3*ln(Limit[ii]));
      Border[ii] := 1-exp(-Slope*TmpR-Inter);
    end;
    if Method=4 then
    begin
      Border[ii] := exp(-exp(-Slope*Limit[ii]-Inter));
    end;
    if Method=5 then
    begin
      Border[ii] := 1 - exp(-exp(-Slope*Limit[ii]-Inter));
    end;
    if Method=6 then
    begin
      TmpR := exp(ln(Limit[ii]));
      Border[ii] := 1-exp(-Slope*TmpR);
    end;
    if Method=7 then
    begin
      if Limit[ii]>Bpoint7 then
      begin
        Border[ii] := 1 - exp(-exp(-SlopeB*Limit[ii]-InterB));
      end else
      begin
        Border[ii] := 1 - exp(-exp(-SlopeA*Limit[ii]-InterA));
      end;
    end;
    if Method=8 then
    begin
      if Limit[ii]>Bpoint8 then
      begin
        TmpR := 1+exp(SlopeB*Limit[ii]+InterB);
      end else
      begin
        TmpR := 1+exp(SlopeA*Limit[ii]+InterA);
      end;
      Border[ii]:= 1/TmpR;
    end;
    if Method=9 then
    begin
      if Limit[ii]>Bpoint9 then
         TmpR      := SlopeB*Limit[ii]+InterB
      else
         TmpR      := SlopeA*Limit[ii]+InterA;
      Border[ii]:= exp(-exp(-TmpR));
    end;
    if Method=10 then
    begin
      if Limit[ii]>Bpoint10 then
      begin
        TmpR := 1+exp(SlopeB*Limit[ii]+InterB);
        Border[ii]:= 1/TmpR;                                     {Logistic}
      end else
        Border[ii] := 1 - exp(-exp(-SlopeA*Limit[ii]-InterA));   {Gumbel Mirr}
    end;
    if Method=11 then
    begin
      if Limit[ii]>Bpoint11 then
         Border[ii] := exp(-exp(-SlopeB*Limit[ii]-InterB))       {Gumbel Stand}
      else
        Border[ii] := 1 - exp(-exp(-SlopeA*Limit[ii]-InterA));   {Gumbel Mirr}
    end;
    if Method=12 then
    begin
      if Limit[ii]>Bpoint12 then
      begin
        TmpR := 1+exp(SlopeB*Limit[ii]+InterB);                  {Logistic}
        Border[ii] := 1/TmpR;
      end else
      begin
        TmpR := SlopeA*Limit[ii]+InterA;                         {Gumbel Stand}
        Border[ii] := exp(-exp(-TmpR));
      end;
    end;
    if Method=13 then
    begin
      if Limit[ii]>Bpoint13 then
         Border[ii] := 1 - exp(-exp(-SlopeB*Limit[ii]-InterB))  {Gumbel Mirr}
      else
      begin
        TmpR := SlopeA*Limit[ii]+InterA;
        Border[ii] := exp(-exp(-TmpR));                         {Gumbel Stand}
      end;
    end;
    if Method=14 then
    begin
      if Limit[ii]>Bpoint14 then
         Border[ii] := 1 - exp(-exp(-SlopeB*Limit[ii]-InterB))  {Gumbel Mirr}
      else
      begin
        TmpR := 1+exp(SlopeA*Limit[ii]+InterA);
        Border[ii] := 1/TmpR;                                    {Logistic}
      end;
    end;
    if Method=15 then
    begin
      if Limit[ii]>Bpoint15 then
      begin
        TmpR := SlopeB*Limit[ii]+InterB;
        Border[ii] := exp(-exp(-TmpR));                         {Gumbel Std}
      end else
      begin
        TmpR := 1+exp(SlopeA*Limit[ii]+InterA);
        Border[ii] := 1/TmpR;                                   {Logistic}
      end;
    end;
    if Method=16 then
    begin
      if Limit[ii]>Bpoint16 then
         Border[ii] := 1 - exp(-SlopeB*Limit[ii]-InterB)       {Poisson}
      else
      begin
        TmpR := SlopeA*Limit[ii]+InterA;
        Border[ii] := exp(-exp(-TmpR));                         {Gumbel Stand}
      end;
    end;

    if Method=17 then
    begin
      if Limit[ii]>Bpoint17 then
         Border[ii] := 1 - exp(-SlopeB*Limit[ii]-InterB)         {Poisson}
      else
        Border[ii] := 1 - exp(-exp(-SlopeA*Limit[ii]-InterA));   {Gumbel Mirr}
    end;

    if Method=18 then
    begin
      if Limit[ii]>Bpoint18 then
         Border[ii] := 1 - exp(-SlopeB*Limit[ii]-InterB)         {Poisson}
      else
      begin
        TmpR := 1+exp(SlopeA*Limit[ii]+InterA);
        Border[ii] := 1/TmpR;                                   {Logistic}
      end;  
    end;

    if Method=20 then                             {normal simple}
    begin
      AuxVar    := Limit[ii];
      MagRed    := (AuxVar-MagAv0)/StDev0;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if TermSum<0 then Border[ii]:=1;
      if Border[ii]<0 then Border[ii]:=0;
    end;

    if Method=21 then                           {normal optimized}
    begin
      AuxVar    := Limit[ii];
      MagRed    := (AuxVar-MagAv1)/StDev1;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=22 then                           {log normal simple}
    begin
      AuxVar    := ln(Limit[ii]);
      MagRed    := (AuxVar-MagAv2)/StDev2;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=23 then                            {log. normal optimized}
    begin
      AuxVar    := ln(Limit[ii]);
      MagRed    := (AuxVar-MagAv3)/StDev3;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=24 then                             {root normal}
    begin
      AuxVar    := sqrt(Limit[ii]);
      MagRed    := (AuxVar-MagAv4)/StDev4;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=25 then                              {square normal}
    begin
      AuxVar    := Limit[ii]*Limit[ii];
      MagRed    := (AuxVar-MagAv5)/StDev5;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=26 then                              {gen. normal}
    begin
      AuxVar    := exp(Expon26*ln(Limit[ii]));
      MagRed    := (AuxVar-Average6)/StDev6;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      Border[ii] := 1-AuxVar*TermSum;
      if (TermSum<0) or (Border[ii]<0) then
         Border[ii]:=0;
    end;

    if Method=31 then    {Burr}
    begin
      TmpR:=ln(Inter31/(exp(AA1B*ln(Limit[ii]))+Inter31));
      Border[ii] := 1-exp(Slope31*TmpR);
    end;
    if Method=32 then    {Dagum}
    begin
      TmpR:=ln(Inter32/(exp(AA1D*ln(Limit[ii]))+Inter32));
      Border[ii] := exp(Slope32*TmpR+Dag);
    end;
    if Method=34 then     {Gompertz}
    begin
      AA2:=Limit[ii];
      if Small then AA2:=(Limit[ii]+1);
      TmpR:=AA1G*ln(AA2);
      TmpR:=exp(BE1G*TmpR)-1;
      Border[ii] := 1 - exp(Slope34*TmpR);
    end;
    if Method=36 then           {kumaraswamy}
    begin
      TmpR      := 1 - exp(Expon36*ln(Limit[ii]/MaxVal));
      Border[ii] :=1 - exp(Slope36*ln(TmpR));
    end;
    if Method=51 then
    begin
       TmpR := exp(Expon51*ln(Limit[ii]));
       Border[ii] := exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=52 then
    begin
      TmpR := exp(Expon52*ln(Limit[ii]));
      Border[ii] := 1 - exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=53 then                                                {Logistic}
    begin
      TmpR      := 1+exp(Slope*Limit[ii]+Inter);
      Border[ii]:= 1/TmpR;
    end;
    if Method=54 then
    begin
      TmpR      := 1+exp(Slope*ln(Limit[ii])+Inter);
      Border[ii]:= 1/TmpR;
    end;
    if Method=55 then                                    {generalized logistic}
    begin
      TmpR      := 1+exp(Slope*exp(Expon55*ln(Limit[ii]))+Inter);
      Border[ii]:= 1/TmpR;
    end;
    if Method=70 then
    begin
      if Limit[ii]>Bpoint70 then
      begin
        TmpR      := exp(ExponB*ln(Limit[ii]));
        TmpR      := 1+exp(SlopeB*TmpR+InterB);
      end else
      begin
        TmpR      := exp(Expona*ln(Limit[ii]));
        TmpR      := 1+exp(SlopeB*TmpR+InterB);
      end;
      Border[ii]:= 1/TmpR;
    end;
    if Method=71 then
    begin
      if Limit[ii]>Bpoint71 then
      begin
         AuxVar    := exp(ExponB*ln(Limit[ii]));
         TmpR      := SlopeB*AuxVar+InterB
      end else
      begin
         AuxVar    := exp(ExponA*ln(Limit[ii]));
         TmpR      := SlopeA*AuxVar+InterA;
      end;
      Border[ii]:= exp(-exp(-TmpR));
    end;
    if Method=72 then
    begin
      if Limit[ii]>Bpoint72 then
      begin
        TmpR := exp(ExponB*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeB*TmpR-InterB);
      end else
      begin
        TmpR := exp(ExponA*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeA*TmpR-InterA);
      end;
    end;

    if Method=80 then
    begin
      if Limit[ii]>Bpoint80 then
      begin
         AuxVar     := exp(ExponB*ln(Limit[ii]));
         TmpR       := SlopeB*AuxVar+InterB;
         Border[ii] := exp(-exp(-TmpR));
      end else
      begin
        TmpR       := 1+exp(SlopeA*exp(ExponA*ln(Limit[ii]))+InterA);
        Border[ii] := 1/TmpR;
      end;
    end;

    if Method=81 then
    begin
      if Limit[ii]>Bpoint81 then
      begin
        TmpR       := exp(ExponB*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeB*TmpR-InterB);
      end else
      begin
        TmpR       := 1+exp(SlopeA*exp(ExponA*ln(Limit[ii]))+InterA);
        Border[ii] := 1/TmpR;
      end;
    end;

    if Method=82 then
    begin
      if Limit[ii]>Bpoint82 then
      begin
        TmpR      := 1+exp(SlopeB*exp(ExponB*ln(Limit[ii]))+InterB);
        Border[ii]:= 1/TmpR;
      end else
      begin
        AuxVar     := exp(ExponA*ln(Limit[ii]));
        TmpR       := SlopeA*AuxVar+InterA;
        Border[ii] := exp(-exp(-TmpR));
      end;
    end;

    if Method=83 then
    begin
      if Limit[ii]>Bpoint83 then
      begin
        TmpR := exp(ExponB*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeB*TmpR-InterB);
      end else
      begin
        AuxVar     := exp(ExponA*ln(Limit[ii]));
        TmpR       := SlopeA*AuxVar+InterA;
        Border[ii] := exp(-exp(-TmpR));
      end;
    end;

    if Method=84 then
    begin
      if Limit[ii]>Bpoint84 then
      begin
        TmpR      := 1+exp(SlopeB*exp(ExponB*ln(Limit[ii]))+InterB);
        Border[ii]:= 1/TmpR;
      end else
      begin
        TmpR := exp(ExponA*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeA*TmpR-InterA);
      end;
    end;

    if Method=85 then
    begin
      if Limit[ii]>Bpoint85 then
      begin
         AuxVar     := exp(ExponB*ln(Limit[ii]));
         TmpR       := SlopeB*AuxVar+InterB;
         Border[ii] := exp(-exp(-TmpR));
      end else
      begin
        TmpR := exp(ExponA*ln(Limit[ii]));
        Border[ii] := 1-exp(-SlopeA*TmpR-InterA);
      end;
    end;

    if Method=56 then
       Border[ii]:= 1-1/(1+exp(Slope*ln(Limit[ii]/Inter)));

    if Method=57 then
    begin
      TmpR :=exp(-Inter/Slope);               {labda}
      TmpR :=Slope*ln(Limit[ii]/TmpR);        {k ln (x/labda) = ln(-ln(1-F))}
      TmpR := exp(TmpR);                      {-ln(1-F)}
      Border[ii]:=1-exp(-TmpR);
    end;
    if Method=58 then                                 {F-T type 2, Frechet}
    begin
      TmpR := (Limit[ii]-Bound58)/Exp(-Inter/Slope);
      if TmpR<=0 then TmpR:=0.001;
      TmpR := exp(Slope*ln(TmpR));
      Border[ii]:= exp(-TmpR);
    end;
    if Method=35 then                              {F-T type 2, Frechet mirr.}
    begin
      TmpR := (Limit[ii]-Bound35)/Exp(-Inter/Slope);
      if TmpR<=0 then TmpR:=0.001;
      TmpR := exp(Slope*ln(TmpR));
      Border[ii]:= 1-exp(-TmpR);
    end;
    if Method=33 then                                 {F-T type 3 mirr.}
    begin
      TmpR := (Bound33-Limit[ii])/Exp(-Inter/Slope);
      if TmpR<=0 then TmpR:=0.001;
      TmpR := exp(Slope*ln(TmpR));
      Border[ii]:= 1 - exp(-TmpR);
    end;
    if Method=59 then                                 {F-T type 3}
    begin
      TmpR := (Bound59-Limit[ii])/Exp(-Inter/Slope);
      if TmpR<=0 then TmpR:=0.001;
      TmpR := exp(Slope*ln(TmpR));
      Border[ii]:= exp(-TmpR);
    end;
    if Method=60 then
    begin
      TmpR :=exp(-Inter/Slope);               {labda}
      TmpR :=Slope*ln(Limit[ii]/TmpR);        {k ln (x/labda) = ln(-ln(1-F))}
      TmpR := exp(TmpR);                      {-ln(1-F)}
      Border[ii]:=exp(-TmpR);
    end;
    if Method=61 then
    begin
       TmpR:=0;
       jj:=round(Inter61);
       for mm:=0 to jj-1 do
       begin
         if mm=0 then Nfact:=1
         else Nfact:= Nfact * mm;
         TmpR:=TmpR +
             (1/Nfact)*(exp(-Limit[ii]/Slope61)*exp(mm*(ln(Limit[ii]/Slope61))));
       end;
       Border[ii]    := 1- TmpR;
    end;
    if Method=62 then                             {Student with 1 d.f.}
    begin
      Term1 := (Limit[ii]-MagAvS)/StErrS;             {Y}
      Border[ii] := 0.5+arctan(Term1)/pi;
    end;
    if Method=63 then                             {Student with 2 d.f.}
    begin
      Term1:= sqrt(2+sqr((Limit[ii]-MagAvS)/StErrS));
      Term1:= ((Limit[ii]-MagAvS)/StErrS)/Term1;
      Border[ii]:=0.5*(1+Term1);
    end;
    if Method=64 then                             {Cauchy}
    begin
      Term1 := Slope*Limit[ii]+Inter;
      Border[ii] := (1/pi)*arctan(Term1)+0.5;
    end;
    if Method=65 then                             {Cauchy generalized}
    begin
      TmpR := exp(Expon65*ln(Limit[ii]));
      Term1 := Slope*TmpR+Inter;
      Border[ii] := (1/pi)*arctan(Term1)+0.5;
    end;
    if Method=66 then
    begin
      TmpR := exp(Expon66*ln(Limit[ii]));
      Border[ii] := exp(-Slope*TmpR-Inter);
    end;
    if Method=67 then
    begin
      TmpR := Expon67*(Limit[ii]-MagAv67)/StErr67;
      if 1+TmpR>0 then
      TmpR := (-1/Expon67)*ln(1+TmpR)
      else TmpR:=0;
      TmpR :=exp(TmpR);                              {GEV}
      Border[ii]:=exp(-TmpR);
    end;
    if Method=68 then                                 {Laplace}
    begin
      if Limit[ii]<BoundL1 then
        Border[ii] :=0.5*exp((Limit[ii]-BoundL1)/BB1)
      else
        Border[ii]:=1-0.5*exp(-(Limit[ii]-BoundL1)/BB2);
    end;
    if Method=69 then                                 {Rayleigh}
    begin
      TmpR:=exp(Expon69*ln(Limit[ii]));
      Border[ii]:=1-exp(-TmpR/Slope69);
    end;
    if Method=73 then                                 {Laplace generalized}
    begin
      if exp(Expon73A*ln(Limit[ii]))<=BoundLG then
      begin
        TmpR := exp(Expon73A*ln(Limit[ii]));
        Border[ii] :=0.5*exp((TmpR-BoundLG)/BB1G);
      end;
      if exp(Expon73A*ln(Limit[ii]))>BoundLG then
      begin
        TmpR := exp(Expon73B*ln(Limit[ii]));
        Border[ii]:=1-0.5*exp(-(TmpR-BoundLG)/BB2G);
      end;
    end;

  end;
end;
{end of Intervals}
{----------------}


{CalcFreq is part of Functions}
{-----------------------------}
procedure CalcFreq;

var  kk, km, mm : integer;
     TmpR, TermL : real;

begin

  if Table then
  begin
    NumDat:=20;
    setlength (Mag,21);
    setlength (FrqCalc,21);
    setlength (DMCumFreq.Xdata,21);
    for kk:=1 to NumDat do
    begin
      if Xmin>0.1*Xmax then Xmin:=0;
      if Xmin<0 then Xmin:=0;
      Mag[kk]:=kk*(Xmax-Xmin)/20;
      DMCumFreq.Xdata[kk]:=Mag[kk];
    end;
  end;

  if (Key='1') and (Method>19) and (Method<27) then
  begin
   Norm:=true;
   NormDistr;
  end;
  if (Method<20) or (Method>50) or (Method in [31,32,33,34,35]) then
  for kk:=1 to NumDat do
  begin
    if Method=3 then
    begin
      TmpR := exp(Expon3*ln(Mag[kk]));
      FrqCalc[kk] := 1-exp(-(Slope*TmpR+Inter));
    end;
    if Method=4 then
       FrqCalc[kk] := exp(-exp(-Slope*Mag[kk]-Inter));
    if Method=5 then
       FrqCalc[kk] := 1-exp(-exp(-Slope*Mag[kk]-Inter));
    if Method=6 then
    begin
      TmpR := exp(ln(Mag[kk]));
      FrqCalc[kk] := 1-exp(-(Slope*TmpR));
    end;
    if Method=7 then
    begin
      if kk>Number then
      begin
        TmpR := SlopeB*Mag[kk] + InterB;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;
      end else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;
      end;
    end;
    if Method=8 then
    begin
      if kk>Number then
         TmpR := 1+exp(SlopeB*Mag[kk]+InterB)
      else
         TmpR := 1+exp(SlopeA*Mag[kk]+InterA);
      FrqCalc[kk] := 1/TmpR;
    end;
    if Method=9 then
    begin
      if kk>Number then
        TmpR := SlopeB*Mag[kk]+InterB
      else
        TmpR := SlopeA*Mag[kk]+InterA;
      FrqCalc[kk] := exp(-exp(-TmpR));
    end;
    if Method=10 then
    begin
      if kk>Number then
      begin
        TmpR := 1+exp(SlopeB*Mag[kk]+InterB);
        FrqCalc[kk] := 1/TmpR;                           {Logistic}
       end else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;                           {Mirror}
     end;
    end;
    if Method=11 then
    begin
      if kk>Number then
      begin
        TmpR := SlopeB*Mag[kk] + InterB;
        FrqCalc[kk] := exp(-exp(-TmpR));                 {Gumbel}
      end else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;                           {Mirror}
      end;
    end;
    if Method=12 then
    begin
      if kk>Number then
      begin
        TmpR        := 1+exp(SlopeB*Mag[kk]+InterB);    {Logistic}
        FrqCalc[kk] := 1/TmpR;
      end else
      begin
        TmpR        := SlopeA*Mag[kk] + InterA;
        FrqCalc[kk] := exp(-exp(-TmpR))                  {Gumbel}
      end;
    end;
    if Method=13 then
    begin
      if kk>Number then
      begin
        TmpR := SlopeB*Mag[kk] + InterB;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;                           {Mirror}
      end else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        FrqCalc[kk] := exp(-exp(-TmpR))                  {Gumbel}
      end;
    end;
    if Method=14 then
    begin
      if kk>Number then
      begin
        TmpR := SlopeB*Mag[kk] + InterB;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;                           {Mirror}
      end else
      begin
        TmpR := 1+exp(SlopeA*Mag[kk]+InterA);
        FrqCalc[kk] := 1/TmpR;                           {Logistic}
      end;
    end;
    if Method=15 then
    begin
      if kk>Number then
      begin
        TmpR := SlopeB*Mag[kk] + Interb;
        FrqCalc[kk] := exp(-exp(-TmpR))                  {Gumbel}
      end else
      begin
        TmpR        := 1+exp(SlopeA*Mag[kk]+InterA);
        FrqCalc[kk] := 1/TmpR;                           {Logistic}
      end;
    end;
    if Method=16 then
    begin
      if kk>Number then
         FrqCalc[kk] := 1 - exp(-SlopeB*Mag[kk]-InterB)  {Poisson}
      else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        FrqCalc[kk] := exp(-exp(-TmpR))                  {Gumbel}
      end;
    end;

    if Method=17 then
    begin
      if kk>Number then
         FrqCalc[kk] := 1 - exp(-SlopeB*Mag[kk]-InterB)  {Poisson}
      else
      begin
        TmpR := SlopeA*Mag[kk] + InterA;
        TmpR := exp(-TmpR);
        TmpR := exp(-TmpR);
        FrqCalc[kk] := 1-TmpR;                           {Mirror}
      end;
    end;

    if Method=18 then
    begin
      if kk>Number then
         FrqCalc[kk] := 1 - exp(-SlopeB*Mag[kk]-InterB)  {Poisson}
      else
      begin
        TmpR        := 1+exp(SlopeA*Mag[kk]+InterA);
        FrqCalc[kk] := 1/TmpR;                           {Logistic}
      end;
    end;

    if Method=31 then    {Burr}
    begin
      TmpR:=ln(Inter31/(exp(AA1B*ln(Mag[kk]))+Inter31));
      FrqCalc[kk] := 1-exp(Slope31*TmpR+Bur);
    end;
    if Method=32 then     {Dagum}
    begin
      TmpR:=ln(Inter32/(exp(AA1D*ln(Mag[kk]))+Inter32));
      FrqCalc[kk] := exp(Slope32*TmpR+Dag);
    end;
    if Method=34 then      {Gompertz}
    begin
      AA2:=Mag[kk];
      if Small then AA2:=(Mag[kk]+1);
      TmpR:=AA1G*ln(AA2);
      TmpR:=exp(BE1G*TmpR)-1;
      FrqCalc[kk] := 1 - exp(Slope34*TmpR);
      if FrqCalc[kk]<0.001 then FrqCalc[kk]:=0.001;
    end;
    if Method=36 then                    {Kumaraswamy}
    begin
      TmpR      := 1-exp(Expon36*ln(Mag[kk]/MaxVal));
      FrqCalc[kk] :=1 - exp(Slope36*ln(TmpR));
    end;
    if Method=51 then                                             {Gen. Gumbel}
    begin
      TmpR := exp(Expon51*ln(Mag[kk]));
      FrqCalc[kk] := exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=52 then
    begin
      TmpR := exp(Expon52*ln(Mag[kk]));
      FrqCalc[kk] := 1-exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=53 then                                               {Logistic}
    begin
      TmpR        := 1+exp(Slope*Mag[kk]+Inter);
      FrqCalc[kk] := 1/TmpR;
    end;
    if Method=54 then
    begin
      TmpR        := 1+exp(Slope*ln(Mag[kk])+Inter);
      FrqCalc[kk] := 1/TmpR;
    end;
    if Method=55 then                                    {generalized logistic}
    begin
      TmpR        := 1+exp(Slope*exp(Expon55*ln(Mag[kk]))+Inter);
      FrqCalc[kk] := 1/TmpR;
    end;

    if Method=70 then                           {Composite generalized logistic}
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := 1+exp(SlopeB*TmpR+InterB);
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := 1+exp(SlopeA*TmpR+InterA);
      end;
      FrqCalc[kk] := 1/TmpR;
    end;

    if Method=71 then                            {Composite generalized Gumbel}
    begin
      if kk>Number then
      begin
        TmpR:=exp(ExponB*ln(Mag[kk]));
        TmpR := SlopeB*TmpR+interB;
      end else
      begin
        TmpR:=exp(ExponA*ln(Mag[kk]));
        TmpR := SlopeA*TmpR+interA;
      end;
      FrqCalc[kk] := exp(-exp(-TmpR));
    end;

    if Method=72 then                           {Composite generalized Poisson}
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := -SlopeB*TmpR - InterB;
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := -SlopeA*TmpR - InterA;
      end;
      FrqCalc[kk] := 1 - exp(TmpR);
    end;

    if Method=80 then
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := SlopeB*TmpR+InterB;
        FrqCalc[kk] := exp(-exp(-TmpR));
      end else
      begin
        TmpR        := exp(ExponA*ln(Mag[kk]));
        TmpR        := 1+exp(SlopeA*TmpR+InterA);
        FrqCalc[kk] := 1/TmpR;
      end;
    end;

    if Method=81 then
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := -SlopeB*TmpR - InterB;
        FrqCalc[kk] := 1 - exp(TmpR);
      end else
      begin
        TmpR := 1+exp(SlopeA*exp(ExponA*ln(Mag[kk]))+InterA);
        FrqCalc[kk] := 1/TmpR;
      end;
    end;

    if Method=82 then
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := 1+exp(SlopeB*TmpR+InterB);
        FrqCalc[kk] := 1/TmpR;
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := SlopeA*TmpR+InterA;
        FrqCalc[kk] := exp(-exp(-TmpR));
      end;
    end;

    if Method=83 then
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := -SlopeB*TmpR - InterB;
        FrqCalc[kk] := 1 - exp(TmpR);
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := SlopeA*TmpR+InterA;
        FrqCalc[kk] := exp(-exp(-TmpR));
      end;
    end;

    if Method=84 then
    begin
      if kk>Number then
      begin
        TmpR := 1+exp(SlopeB*exp(ExponB*ln(Mag[kk]))+InterB);
        FrqCalc[kk] := 1/TmpR;
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := -SlopeA*TmpR - InterA;
        FrqCalc[kk] := 1 - exp(TmpR);
      end;
    end;

    if Method=85 then
    begin
      if kk>Number then
      begin
        TmpR := exp(ExponB*ln(Mag[kk]));
        TmpR := SlopeB*TmpR+InterB;
        FrqCalc[kk] := exp(-exp(-TmpR));
      end else
      begin
        TmpR := exp(ExponA*ln(Mag[kk]));
        TmpR := -SlopeA*TmpR - InterA;
        FrqCalc[kk] := 1 - exp(TmpR);
      end;
    end;

    if Method=56 then
       FrqCalc[kk] := 1-1/(1+exp(Slope*(ln(Mag[kk]/Inter))));

    if Method=57 then                           {Weibull}
    begin
      TmpR:=exp(-Inter/Slope);                  {labda}
      TmpR:=Slope*ln(Mag[kk]/TmpR);             {k ln (x/labda) =ln(-ln(1-F)}
      TmpR:=exp(TmpR);                          {-ln(1-F)}
      FrqCalc[kk] := 1-exp(-TmpR);
    end;

    if Method=58 then                                {F-T type 2, Frechet}
    begin
    begin
      TmpR := -Inter/Slope;
      TmpR := (Mag[kk]-Bound58)/Exp(TmpR);
      WarnType2:=false;
      if TmpR<=0 then
      begin
         TmpR := 0.0001;
         WarnType2:=true;
      end;
      TmpR := exp(Slope*ln(TmpR));
      FrqCalc[kk]:= exp(-TmpR);
    end;
    end;

    if Method=35 then                             {F-T type 2, Frechet mirr.}
    begin
      TmpR := -Inter/Slope;
      TmpR := (Mag[kk]-Bound35)/Exp(TmpR);
      WarnType2:=false;
      if TmpR<=0 then
      begin
         TmpR := 0.0001;
         WarnType2:=true;
      end;
      TmpR := exp(Slope*ln(TmpR));
      FrqCalc[kk]:= 1-exp(-TmpR);
    end;

    if Method=33 then                                {F-T type 3 mirr.}
    begin
      TmpR := (Bound33-Mag[kk])/Exp(-Inter/Slope);
      WarnType3:=false;
      if TmpR<=0 then
      begin
         TmpR := 0.0001;
         WarnType3:=true;
      end;
      TmpR := exp(Slope*ln(TmpR));
      FrqCalc[kk]:= 1 - exp(-TmpR);
    end;

    if Method=59 then                                {F-T type 3}
    begin
      TmpR := (Bound59-Mag[kk])/Exp(-Inter/Slope);
      WarnType3:=false;
      if TmpR<=0 then
      begin
         TmpR := 0.0001;
         WarnType3:=true;
      end;
      TmpR := exp(Slope*ln(TmpR));
      FrqCalc[kk]:= exp(-TmpR);
    end;

    if Method=60 then                                     {mirr Weibull}
    begin
      TmpR:=exp(-Inter/Slope);                  {labda}
      TmpR:=Slope*ln(Mag[kk]/TmpR);             {k ln (x/labda) =ln(-ln(1-F)}
      TmpR:=exp(TmpR);                          {-ln(F)}
      FrqCalc[kk] := exp(-TmpR);
    end;

    if Method=61 then
    begin
       TmpR:=0;
       Nfact:=1;
       km:=round(Inter61);
       for mm:=0 to km-1 do
       begin
         if mm=0 then Nfact:=1
         else Nfact:= Nfact * mm;
         TmpR:=TmpR +
             (1/Nfact)*(exp(-Mag[kk]/Slope61)*exp(mm*(ln(Mag[kk]/Slope61))));
       end;
       FrqCalc[kk]    := 1- TmpR;
    end;

    if Method=62 then                                {Student's with 1 d.f}
    begin
      TermL := (Mag[kk]-MagAvS)/StErrS;                {Y, redX}
      FrqCalc[kk] := 0.5+arctan(TermL)/pi;
    end;

    if Method=63 then                                {Student's with 2 d.f}
    begin
      TermL:= sqrt(2+sqr((Mag[kk]-MagAvS)/StErrS));
      TermL:= ((Mag[kk]-MagAvS)/StErrS)/TermL;
      FrqCalc[kk]:=0.5*(1+TermL);
    end;
    if Method=64 then                             {Cauchy}
    begin
      TermL:= Slope*Mag[kk]+Inter;
      FrqCalc[kk] := (1/pi)*arctan(TermL)+0.5;
    end;

    if Method=65 then                             {Cauchy generalized}
    begin
      TmpR := exp(Expon65*ln(Mag[kk]));
      TermL:= Slope*TmpR+Inter;
      FrqCalc[kk] := (1/pi)*arctan(TermL)+0.5;
    end;

    if Method=66 then                           {gen. expon. mirrored}
    begin
      TmpR := exp(Expon66*ln(Mag[kk]));
      FrqCalc[kk] := exp(-(Slope*TmpR+Inter));
    end;

    if Method=67 then                           {GEV}
    begin
      TmpR := Expon67*(Mag[kk]-MagAv67)/StErr67;
      if (1+TmpR)>0 then
         TmpR:=(-1/Expon67)*ln(1+TmpR)
      else
         TmpR:=0;
      TmpR:=exp(TmpR);
      FrqCalc[kk] := exp(-(TmpR));
    end;
    if Method=68 then                           {Laplace}
    begin
      if Mag[kk]<BoundL1 then
        FrqCalc[kk] :=0.5*exp((Mag[kk]-BoundL1)/BB1)
      else
        FrqCalc[kk]:=1-0.5*exp(-(Mag[kk]-BoundL1)/BB2);
    end;

    if Method=69 then                           {RayLeigh}
    begin
      TmpR:=exp(Expon69*ln(Mag[kk]));
      FrqCalc[kk]:=1-exp(-TmpR/Slope69);
    end;
    if Method=73 then                           {Laplace generalized}
    begin
      if exp(Expon73A*ln(Mag[kk]))<=BoundLG then
      begin
        TmpR := exp(Expon73A*ln(Mag[kk]));
        FrqCalc[kk] :=0.5*exp((TmpR-BoundLG)/BB1G);
      end;
      if exp(Expon73A*ln(Mag[kk]))>BoundLG then
      begin
        TmpR := exp(Expon73B*ln(Mag[kk]));
        FrqCalc[kk]:=1-0.5*exp(-(TmpR-BoundLG)/BB2G);
      end;
    end;

    if FrqCalc[kk]<0 then FrqCalc[kk] := 0.001;
    if FrqCalc[kk]>1 then FrqCalc[kk] := 0.999;
    if (kk>1) and (FrqCalc[kk]<FrqCalc[kk-1]) then
       FrqCalc[kk]:=FrqCalc[kk-1];
    if (kk>1) and (FrqCalc[kk]<FrqCalc[kk-1]) then
       FrqCalc[kk]:=FrqCalc[kk-1]+0.5*(1-FrqCalc[kk-1]);

  end;                                         { end of NumDat loop }

  if Table then
  begin
   setlength (DMCumFreq.Yrdata,21);
   for kk:=1 to 20 do DMCumFreq.Yrdata[kk]:=FrqCalc[kk];
  end;

end;
{end of CalcFreq}
{---------------}



{-------------}
procedure Rank;

label 1,2;

var
SerLet    : string[6];
AuxR      : real;
AuxI      : integer;
ii,jj     : integer;
skip       :integer;
magnitude : real;
A         : string[1];

begin
  NegVal:=false;
  assignFile (InFile,DMCumFreq.FileName);
  reset (InFile);
  for ii:=1 to 3 do readln (InFile);
  readln (InFile,A,Title1);
  readln (InFile,A,Title2);
  for ii:=1 to 4 do readln (InFile);
  Serlet:='';
  while not (Serlet=' Seria') do readln (InFile,Serlet);
  readln (InFile,Serlet);
  jj := 0;
  SerLet := ' Start';
  while not (SerLet='') do
  begin
    jj:=jj+1;
    readln(InFile,SerLet);
  end;
  NumDat := jj-1;
  reset (InFile);
  Serlet:='';
  while not (Serlet=' Seria') do readln (InFile,Serlet);
  readln (InFile,Serlet);
  DMCumFreq.NrOfData:=0;
  for ii:=1 to NumDat do
  begin
    readln (InFile,SerLet);
    DMCUmFreq.NrOfData:=DMCUmFreq.NrOfData+1;
  end;
  reset (InFile);
  Serlet:='';
  while not (Serlet=' Seria') do readln (InFile,Serlet);
  readln (InFile,Serlet);
  jj:=0;
  setlength (Ser,NumDat+1);
  setlength (Mag, NumDat+1);
  setlength (Frq, NumDat+1);
  Threshold:=-1000000;
  for ii:=1 to NumDat do
  begin
    readln (InFile,Skip,Magnitude);
    if Magnitude>Threshold then
    begin
      jj:=jj+1;
      Ser[jj]:=Skip;
      Mag[jj]:=Magnitude;
      if Mag[jj]=0 then Mag[jj]:=0.001;
    end;
  end;

  for ii:=1 to DMCumFreq.NrOfData-1 do
  begin
1: for jj:=ii+1 to DMCumFreq.NrOfData do
    begin
      if Mag[jj]<Mag[jj-1] then
      begin
        AuxR      := Mag[jj];
        Mag[jj]   := Mag[jj-1];
        Mag[jj-1] := AuxR;
        AuxI      := Ser[jj];
        Ser[jj]   := Ser[jj-1];
        Ser[jj-1] := AuxI;
        goto 1;
      end;
    end;
  end;
  Minim:=1000000;
  setlength (DMCumFreq.Xvalue,DMCumFreq.NrOfData+1);
  for ii:=1 to DMCumFreq.NrOfData do
  begin
    Frq[ii] := ii/(DMCumFreq.NrOfData+1);
    if Mag[ii]<Minim then Minim:=Mag[ii];
    DMCumFreq.Xvalue[ii]:=Mag[ii];
  end;
  if Minim>0 then Minim:=0.0001;
  if Minim<0 then
  begin
    for ii:=1 to DMCumFreq.NrOfData do Mag[ii]:=Mag[ii]-Minim+0.0001;
    if Minim=0 then Minim:=-0.0001;
  end;
  if not NegVal and (Minim>0.25*Mag[DMCumFreq.NrOfData]) then
  begin
    NegVal:=true;
    showmessage ('The first values are high. The distribution will be '+
                 ' temporarily shifted to the left.');
    Minim:=0.75*Mag[1];
    for ii:=1 to DMCUmFreq.NrOfData do Mag[ii]:=Mag[ii]-Minim;
  end;
  NumDat:=DMCUmFreq.NrOfData;
  close (InFile);

end;
{end of Rank}
{-----------}


{NormDistr is part of Functions and CalcFreq}
{-------------------------------------------}
procedure NormDistr;

var
  AuxVar, MagRed, MagTrf, MagTrSq    : real;
  MagSum, MagSumSq, MinResidu, Step  : real;
  Term1, Term2, Term3, Term4, Term5,
  TermSum                            : real;
  ResiduSq, SumResSq                 : extended;
  Sum         : array [1..201] of real;
  StDeviation : array [1..301] of real;
  jj, kk, mm, nn, KM, II, JF, MF, NF : integer;
  Total : array [1..300] of array [1..201] of real;
  Total1 : array [1..201] of real;

begin

  if Method=20 then                        {Normal Distr.}
  begin
    MagSum   := 0;
    MagSumSq := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar   := Mag[kk];
      MagSum   := MagSum   + AuxVar;
      MagSumSq := MagSumSq + AuxVar*AuxVar;
    end;
    MagAv0      := MagSum/NumDat;
    MagRedSumSq := MagSumSq - MagSum*MagSum/NumDat;
    StDev0      := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StDev0<=0 then exit;
      SumResSq := 0;
      ResiduAb := 0;
      for kk:=1 to NumDat do
      begin
        AuxVar    := Mag[kk];
        MagRed    := (AuxVar-MagAv0)/StDev0;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+Term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
    SumResSq20:=ResiduAb;
    if not Norm then
    begin
      MainForm.WaitMemo.Lines.Add(' 90 done');
      if Key='1' then
      begin
        writeln(ListFile,' Normal distribution standard');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=21 then if not Norm then                 {Normal Distr. optimized}
  begin
    MagSum   := 0;
    MagSumSq := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar   := Mag[kk];
      MagSum   := MagSum   + AuxVar;
      MagSumSq := MagSumSq + AuxVar*AuxVar;
    end;
    MagAv1      := MagSum/NumDat;
    Average1    := MagSum/NumDat;
    MagRedSumSq := MagSumSq - MagSum*MagSum/NumDat;
    StErr       := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StErr<=0 then exit;
    StErr1      := StErr;
    for jj:=1 to 201 do
    begin
      SumResSq := 0;
      StDev1   := (99+jj)*StErr1/200;
      for kk:=1 to NumDat do
      begin
        AuxVar    := Mag[kk];
        MagRed    := (AuxVar-Average1)/StDev1;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+Term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
      Total1[jj]:= SumResSq;
    end; {for jj:=1 to 201 do}
    SumResSq21 := Total1[1];
    for jj:=2 to 201 do
    begin
        if Total1[jj]<SumResSq21 then
        begin
          Stdev1 := (99+jj)*StErr1/200;
          SumResSq21 := Total1[jj];
        end;
    end;  {for jj:=1 to 201 do}
  end;  {if Method=21 then if not Norm then}

  if Method=21 then                          {Final values Normal Distr. opt}
  begin
    ResiduAb    := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := Mag[kk];
      MagRed    := (AuxVar-Average1)/StDev1;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      FrqCalc[kk] := 1-AuxVar*TermSum;
      if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
        end;
    end;
    if not Norm then
    begin
      SumResSq21:=ResiduAb;
      MainForm.WaitMemo.Lines.Add(' 91 done');
      if Key='1' then
      begin
        writeln(ListFile,' Normal distribution optimized');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=22 then                                {Log-Normal Distr.}
  begin
    MagSum    := 0;
    MagSumSq  := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := ln(Mag[kk]);
      MagSum    := MagSum   + AuxVar;
      MagSumSq  := MagSumSq + AuxVar*AuxVar;
    end;
    MagAv2     := MagSum/NumDat;
    MagRedSumSq  := MagSumSq - MagSum*MagSum/NumDat;
    StDev2 := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StDev2<=0 then exit;
      SumResSq := 0;
      ResiduAb := 0;
      for kk:=1 to NumDat do
      begin
        AuxVar    := ln(Mag[kk]);
        MagRed    := (AuxVar-MagAv2)/StDev2;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
    if not Norm then
    begin
      SumResSq22:=ResiduAb;
      MainForm.WaitMemo.Lines.Add(' 92 done');
      if Key='1' then
      begin
        writeln(ListFile,' Log-normal distribution standard');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=23 then if not Norm then             {Log-Normal Distr. optimized}
  begin
    MagSum    := 0;
    MagSumSq  := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := ln(Mag[kk]);
      MagSum    := MagSum   + AuxVar;
      MagSumSq  := MagSumSq + AuxVar*AuxVar;
    end;
    Average3     := MagSum/NumDat;
    MagRedSumSq  := MagSumSq - MagSum*MagSum/NumDat;
    StErr3 := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StErr3<=0 then exit;
    for mm:=1 to 201 do
    for jj:=1 to 201 do
    begin
      SumResSq := 0;
      Mean     := (99+mm)*Average3/200;
      StDev3   := (99+jj)*StErr3/200;
      for kk:=1 to NumDat do
      begin
        AuxVar    := ln(Mag[kk]);
        MagRed    := (AuxVar-Mean)/StDev3;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
      Total[mm,jj]:= SumResSq;
    end;
    SumResSq23 := Total[1,1];
    for mm:=2 to 201 do
    for jj:=2 to 201 do
        if Total[mm,jj]<SumResSq23 then
        begin
          MagAv3 := (99+mm)*Average3/200;
          Stdev3 := (99+jj)*StErr3/200;
          SumResSq23 := Total[mm,jj]
        end;
  end;

  if Method=23 then                        {Final values Log-Normal Distr. opt}
  begin
    ResiduAb    := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := Ln(Mag[kk]);
      MagRed    := (AuxVar-MagAv3)/StDev3;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      FrqCalc[kk] := 1-AuxVar*TermSum;
      if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
        end;
    end;
    if not Norm then
    begin
      SumResSq23:=ResiduAb;
      MainForm.WaitMemo.Lines.Add(' 93 done');
      if Key='1' then
      begin
        writeln(ListFile,' Log-normal distribution optimized');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=24 then if not Norm then                     {Root-Normal Distr.}
  begin
    MagSum   := 0;
    MagSumSq := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar   := sqrt(Mag[kk]);
      MagSum   := MagSum   + AuxVar;
      MagSumSq := MagSumSq + AuxVar*AuxVar;
    end;
    Average4    := MagSum/NumDat;
    MagRedSumSq := MagSumSq - MagSum*MagSum/NumDat;
    StErr4      := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StErr4<=0 then exit;
    for jj:=1 to 201 do
    begin
      SumResSq := 0;
      StDev4   := (99+jj)*StErr4/200;
      for kk:=1 to NumDat do
      begin
        AuxVar    := sqrt(Mag[kk]);
        MagRed    := (AuxVar-Average4)/StDev4;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+Term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        SumResSq:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
      Total1[jj]:= SumResSq;
    end;
    SumResSq24 := Total1[1];
    for jj:=2 to 201 do
        if Total1[jj]<SumResSq24 then
        begin
          Stdev4 := (99+jj)*StErr4/200;
          SumResSq24 := Total1[jj];
        end;
  end;

  if Method=24 then                       {Final values Root-Normal Distr. opt}
  begin
    ResiduAb    := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := sqrt(Mag[kk]);
      MagRed    := (AuxVar-Average4)/StDev4;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      FrqCalc[kk] := 1-AuxVar*TermSum;
      if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
        end;
    end;
    SumResSq24:=ResiduAb;
    if not Norm then
    begin
      MainForm.WaitMemo.Lines.Add(' 94 done');
      if Key='1' then
      begin
        writeln(ListFile,' Root-normal distribution optimized');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=25 then if not Norm then                   {Square-Normal Distr.}
  begin
    MagSum   := 0;
    MagSumSq := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar   := Mag[kk]*Mag[kk];
      MagSum   := MagSum   + AuxVar;
      MagSumSq := MagSumSq + AuxVar*AuxVar;
    end;
    Average5     := MagSum/NumDat;
    MagRedSumSq  := MagSumSq - MagSum*MagSum/NumDat;
    StErr5 := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    if StErr5<=0 then exit;
    for jj:=1 to 201 do
    begin
      SumResSq := 0;
      StDev5   := (99+jj)*StErr5/200;
      for kk:=1 to NumDat do
      begin
        AuxVar    := Mag[kk]*Mag[kk];
        MagRed    := (AuxVar-Average5)/StDev5;
        MagTrf    := 1/(1+0.23165*MagRed);
        MagTrSq   := MagTrf*MagTrf;
        Term1     := 0.31938*MagTrf;
        Term2     :=-0.35656*MagTrSq;
        Term3     := 1.78148*MagTrf*MagTrSq;
        Term4     :=-1.82126*MagTrSq*MagTrSq;
        Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
        TermSum   := Term1+Term2+Term3+Term4+Term5;
        AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
        FrqCalc[kk] := 1-AuxVar*TermSum;
        if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        SumResSq:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
          ResiduSq  := Residu*Residu;
          SumResSq  := SumResSq + ResiduSq;
        end;
      end;
       Total1[jj]:= SumResSq;
    end;
    SumResSq25 := Total1[1];
    for jj:=2 to 201 do
        if Total1[jj]<SumResSq25 then
        begin
          Stdev5 := (99+jj)*StErr5/200;
          SumResSq25 := Total1[jj]
        end;
  end;

  if Method=25 then                     {Final values Square-Normal Distr. opt}
  begin
    ResiduAb    := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := Mag[kk]*Mag[kk];
      MagRed    := (AuxVar-Average5)/StDev5;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      FrqCalc[kk] := 1-AuxVar*TermSum;
      if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
        if not DMCumFreq.Scarce then
        begin
          Residu    := Frq[kk] - FrqCalc[kk];
          ResiduAb  := ResiduAb + abs(Residu);
        end;
    end;
    if not Norm then
    begin
      SumResSq25:=ResiduAb;
      MainForm.WaitMemo.Lines.Add(' 95 done');
      if Key='1' then
      begin
        writeln(ListFile,' Square normal distribution optimized');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

  if Method=26 then if not Norm then
  begin                           {Finding exponent, Generalized Normal Distr.}
    Step:=0.19;
    MinResidu:=1000000;
    JF:=100;                      {Delphi wants this}
    MF:=100;
    NF:=100;
    for mm:=1 to 280 do
    begin
      Step:=Step+0.01;
      MagSum   := 0;
      MagSumSq := 0;
      for kk:=1 to NumDat do
      begin
        AuxVar   := exp(Step*ln(Mag[kk]));
        MagSum   := MagSum   + AuxVar;
        MagSumSq := MagSumSq + AuxVar*AuxVar;
      end;
      Average6    := MagSum/NumDat;
      MagRedSumSq := MagSumSq - MagSum*MagSum/NumDat;
      StErr6      := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
      if StErr6<=0 then exit;

      for jj:=1 to 201 do
      begin
        SumResSq := 0;
        StDev    := (99+jj)*StErr6/200;
        for kk:=1 to NumDat do
        begin
          AuxVar    := exp(Step*ln(Mag[kk]));
          MagRed    := (AuxVar-Average6)/StDev;
          MagTrf    := 1/(1+0.23165*MagRed);
          MagTrSq   := MagTrf*MagTrf;
          Term1     := 0.31938*MagTrf;
          Term2     :=-0.35656*MagTrSq;
          Term3     := 1.78148*MagTrf*MagTrSq;
          Term4     :=-1.82126*MagTrSq*MagTrSq;
          Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
          TermSum   := Term1+Term2+Term3+Term4+Term5;
          AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
          FrqCalc[kk] := 1-AuxVar*TermSum;
          if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
          if not DMCumFreq.Scarce then
          begin
            Residu    := Frq[kk] - FrqCalc[kk];
            if abs(Residu)>1 then Residu:=1;
            ResiduSq  := Residu*Residu;
            SumResSq  := SumResSq + ResiduSq;
          end;
          if SumResSq<MinResidu then
          begin
            MinResidu:=SumResSq;
            JF := jj;
            MF := mm;
          end;
        end;
      end;  {for jj:=1 to 201 do}
    end; {for mm:=1 to 280 do}

    Expon26:=0.01*MF+0.19;
    if (Expon26<0.21) or (Expon26>2.98) then Expon26:=1;
    if (Expon26>0.95) and (Expon26<1.05) then Expon26:=1;
    MagSum:=0;
    MagSumSq := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar   := exp(Expon26*ln(Mag[kk]));
      MagSum   := MagSum   + AuxVar;
      MagSumSq := MagSumSq + AuxVar*AuxVar;
    end;
    Average6    := MagSum/NumDat;
    MagRedSumSq := MagSumSq - MagSum*MagSum/NumDat;
    StErr6      := exp(0.5*ln(MagRedSumSq/(NumDat-1)));
    Stdev6      := (99+JF)*StErr6/200;
  end;

  if Method=26 then                            {Final values Gen. Normal Distr.}
  begin
    ResiduAb    := 0;
    for kk:=1 to NumDat do
    begin
      AuxVar    := exp(Expon26*ln(Mag[kk]));
      MagRed    := (AuxVar-Average6)/StDev6;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      FrqCalc[kk] := 1-AuxVar*TermSum;
      if (TermSum<0) or (FrqCalc[kk]<0) then FrqCalc[kk]:=0;
      if not DMCumFreq.Scarce then
      begin
        Residu    := Frq[kk] - FrqCalc[kk];
        if abs(Residu)>1 then Residu:=1;
        ResiduAb  := ResiduAb + abs(Residu);
      end;
    end;
    if not Norm then
    begin
      SumResSq26:=ResiduAb;
      if (Key='1') and (Expon26=1) then
         SumResSq26:=1000;
      MainForm.WaitMemo.Lines.Add(' 96 done');
      if (Key='1') and (Expon26<>1) then
      begin
        writeln(ListFile,' Generalized normal distribution');
        writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
        writeln (ListFile);
      end;
    end;
  end;

end;
{end of NormDistr}
{----------------}


{Ratio1 is part of Functions}
{---------------------------}
procedure Ratio1;

var
FrqSum : real;
Magsum : extended;
kk : integer;

begin

  FrqSum      := 0;
  MagSum      := 0;

  for kk:=1 to NumDat do
  begin
    FrqSum    := FrqSum   + Frq[kk];
    MagSum    := MagSum   + Mag[kk];
  end;
  FrqAv       := FrqSum/NumDat;
  MagAv       := MagSum/NumDat;
  if MagAv=Mag[TmpNum] then
     Slope:=100
  else
     Slope := (FrqAv-Frq[TmpNum])/(MagAv-Mag[TmpNum]);
  Inter := FrqAv - Slope*MagAv;

end;
{end of Ratio1}
{-------------}


{Ratio2 is part of Functions}
{---------------------------}
procedure Ratio2;

var
FrqSum : real;
MagSum : extended;
kk : integer;

begin

  FrqSum := 0;
  MagSum := 0;

  for kk:=TmpNum+1 to NumDat do
  begin
    FrqSum   := FrqSum + Frq[kk];
    MagSum   := MagSum + Mag[kk];
  end;
  if NumDat<>TmpNum then
  begin
     FrqAv := FrqSum/(NumDat-TmpNum);
     MagAv := MagSum/(NumDat-TmpNum);
  end else
  begin
    FrqAv:=1000;
    MagAv:=1000;
  end;
  Slope := (FrqAv-Frq[TmpNum])/(MagAv-Mag[TmpNum]);
  Inter := FrqAv - Slope*MagAv;

end;
{end of Ratio2}
{-------------}



{Regres1 is part of Functions}
{----------------------------}
procedure Regres1;

var
FrqMagPr, FrqSum : real;
MagSum, MagSumsq : extended;
kk               : integer;

begin

  NotFit     := false;
  FrqSum     := 0;
  MagSum     := 0;
  FrqMagPr   := 0;
  MagSumSq   := 0;

  for kk:=1 to NumDat do
  begin
    FrqSum   := FrqSum   + Frq[kk];
    MagSum   := MagSum   + Mag[kk];
  end;

  FrqAv       := FrqSum/NumDat;
  MagAv       := MagSum/NumDat;

  for kk:=1 to NumDat do
  begin
    MagSumSq := MagSumSq + sqr(Mag[kk]-MagAv);
    FrqMagPr := FrqMagPr + (Frq[kk]-FrqAv)*(Mag[kk]-MagAV);
  end;

  if MagSumSq<=0 then
  begin
    NotFit:=true;
    exit;
  end;

  if MagSumSq<>0 then Slope := FrqMagPr/MagSumSq else Slope:=100;
  Inter := FrqAv - Slope*MagAv;
  if MagSumSq>0 then StErr := exp(0.5*ln(MagSumSq/(NumDat-1))) else StErr:=100;

end;
{end of Regres1}
{--------------}


{Regres2 is part of Functions}
{----------------------------}
procedure Regres2;

var
FrqMagPr, FrqSum : real;
MagSum, MagSumsq : extended;
kk               : integer;

begin

  NotFit     := false;
  FrqSum     := 0;
  MagSum     := 0;
  FrqMagPr   := 0;
  MagSumSq   := 0;

  for kk:=1 to TmpNum do
  begin
    FrqSum   := FrqSum   + Frq[kk];
    MagSum   := MagSum   + Mag[kk];
  end;

  FrqAv       := FrqSum/TmpNum;
  MagAv       := MagSum/TmpNum;

  for kk:=1 to TmpNum do
  begin
    MagSumSq := MagSumSq + sqr(Mag[kk]-MagAv);
    FrqMagPr := FrqMagPr + (Frq[kk]-FrqAv)*(Mag[kk]-MagAV);
  end;

  if MagSumSq<=0 then
  begin
    NotFit:=true;
    exit;
  end;

  if MagSumSq<>0 then Slope := FrqMagPr/MagSumSq else Slope:=100;
  Inter := FrqAv - Slope*MagAv;
  if MagSumSq>0 then StErr := exp(0.5*ln(MagSumSq/(NumDat-1))) else StErr:=100;

end;
{end of Regres2}
{--------------}


{Regres3 is part of Functions}
{----------------------------}
procedure Regres3;

var
FrqMagPr, FrqSum : real;
MagSum, MagSumSq : extended;
kk,mm            : integer;

begin

  NotFit     := false;
  FrqSum     := 0;
  MagSum     := 0;
  FrqMagPr   := 0;
  MagSumSq   := 0;

  for kk:=TmpNum+1 to Numdat do
  begin
    FrqSum   := FrqSum   + Frq[kk];
    MagSum   := MagSum   + Mag[kk];
  end;

  mm:=NumDat-TmpNum-1;
  FrqAv       := FrqSum/mm;
  MagAv       := MagSum/mm;

  for kk:=TmpNum+1 to Numdat do
  begin
    MagSumSq := MagSumSq + sqr(Mag[kk]-MagAv);
    FrqMagPr := FrqMagPr + (Frq[kk]-FrqAv)*(Mag[kk]-MagAV);
  end;

  if MagSumSq<=0 then
  begin
    NotFit:=true;
    exit;
  end;

  if MagSumSq<>0 then Slope := FrqMagPr/MagSumSq else Slope:=100;
  Inter := FrqAv - Slope*MagAv;
  if MagSumSq>0 then StErr := exp(0.5*ln(MagSumSq/(NumDat-1))) else StErr:=100;

end;
{end of Regres3}
{--------------}


{Functions is part of Main Program}
{---------------------------------}
procedure Functions;

var
TmpFrq                                          : array of real;
TmpMag                                          : array of extended;
SumSq                                           : array [1..2000] of real;
Beta                                            : array [1..2000] of real;
Slope1,     Slope2,     Slope3,     Slope4      : real;
Slope5,     Slope6,     BB,         AuxR        : real;
Slope7A,    Slope7B,    Slope8A,    Slope8B     : real;
Slope9A,    Slope9B,    Slope10A,   Slope10B    : real;
Slope11A,   Slope11B,   Slope12A,   Slope12B    : real;
Slope13A,   Slope13B,   Slope14A,   Slope14B    : real;
Slope15A,   Slope15B,   Slope16A,   Slope16B    : real;
Slope17A,   Slope17B,   Slope18A,   Slope18B    : real;
Inter1,     Inter2,     Inter3,     Inter4      : real;
Inter5                                          : real;
Power,      Step,       MaxX        : real;
MinResidu,  Step1,      HlpVar                  : real;
ResiduSq,   FrqRg                               : extended;
SumResSq1,  SumResSq2,  SumResSq3,  SumResSq4   : real;
SumResSq5,  LowSq,      LowAb,      LowSqCont   : real;
SumResSq51, Slope51,    Inter51,    Factor      : real;
SumResSq52, Slope52,    Inter52                 : real;
SumResSq53, Slope53,    Inter53                 : real;
SumResSq54, Slope54,    Inter54                 : real;
SumResSq55, Slope55,    Inter55                 : real;
SumResSq57, Slope57,    Inter57                 : real;
SumResSq58, Slope58,    Inter58                 : real;
SumResSq33, Slope33,    Inter33                 : real;
SumResSq35, Slope35,    Inter35                 : real;
SumResSq36                                      : real;      {Kumarawamy}
SumResSq59, Slope59,    Inter59                 : real;
SumResSq60, Slope60,    Inter60                 : real;
SumResSq62, SumResSq63, SumResSq6,  SumResSq67  : real;  //for Student's
SumResSq68, SumResSqA,  SumResSqB               : real;  //for Laplace
SumResSq64, Slope64,    Inter64                 : real;  //for Cauchy
SumResSq65, Slope65,    Inter65                 : real;  //for Cauchy general
SumResSq66, Slope66,    Inter66                 : real;  //for exponential mirr}
SumResSq70, SumResSq70A, SumResSq70B            : real;
SumResSq71, SumResSq71A, SumResSq71B            : real;
SumResSq72, SumResSq72A, SumResSq72B            : real;
SumResSq73, SumResSq73A, SumResSq73B            : real;
SumResSq80, SumResSq80A, SumResSq80B            : real;
SumResSq81, SumResSq81A, SumResSq81B            : real;
SumResSq82, SumResSq82A, SumResSq82B            : real;
SumResSq83, SumResSq83A, SumResSq83B            : real;
SumResSq84, SumResSq84A, SumResSq84B            : real;
SumResSq85, SumResSq85A, SumResSq85B            : real;
SumResSq7,  SumResSq8,  SumResSq9               : real;
SumResSq10, SumResSq11, SumResSq12, SumResSq13  : real;
SumResSq7A, SumRessq7B                          : real;
SumResSq8A, SumRessq8B, SumResSq9A, SumRessq9B  : real;
SumResSq10A,SumRessq10B,SumResSq11A,SumRessq11B : real;
SumResSq12A,SumRessq12B,SumResSq13A,SumRessq13B : real;
SumResSq14, SumResSq14A,SumRessq14B             : real;
SumResSq15, SumResSq15A,SumRessq15B             : real;
SumResSq16, SumResSq16A,SumRessq16B             : real;
SumResSq17, SumResSq17A,SumRessq17B             : real;
SumResSq18, SumResSq18A,SumRessq18B             : real;
Number7,    Number8,    Number9,    Number10    : integer;
Number11,   Number12,   Number13,   Number14    : integer;
Number15,   Number16,   Number17,   Number18    : integer;
Number70,   Number71,   Number72,   Number73    : integer;
Number80,   Number81,   Number82                : integer;
Number83,   Number84,   Number85                : integer;
ii, jj, ij, kk, nn, mm, km, NM, MethCont        : integer;
Summing, ExponAA, ExponBB, SlopAA, SlopBB,
InteAA, InteBB                                : array[1..12] of real;
delta, gamma                                  : array[1..81] of real;
QQstr:string;

label 40, 41, 42, 43, 44, 45, 46, 51, 52, 53, 54, 55, 56, 57, 58, 59,
      60, 61, 62, 64 ,65, 66, 67, 68 ,69 ,70 ,71 ,72 ,73 ,75 ,
      86, 87, 93, 94, 95, 96, 99;

begin

//The following zero settings are not really required, but the compiler
//otherwise warns that they may not have been initialised

  SumResSq2:=0;
  SumResSq3:=0;
  SumResSq36:=0;
  SumResSq51:=0;
  SumResSq52:=0;
  SumResSq55:=0;
  SumResSq56:=0;
  SumResSq58:=0;
  SumResSq33:=0;
  SumResSq35:=0;
  SumResSq59:=0;
  SumResSq60:=0;
  SumResSq65:=0;
  SumResSq69 := 0;
  SumResSq73 := 0;
  Slope1:=0;
  Slope2:=0;
  Inter1:=0;
  Inter2:=0;
  Slope3:=0;
  Inter3:=0;
  Slope33:=0;
  Inter33:=0;
  Slope51:=0;
  Inter51:=0;
  Slope52:=0;
  Inter52:=0;
  Slope55:=0;
  Inter56:=0;
  Slope56:=0;
  Inter55:=0;
  Slope58:=0;
  Slope59:=0;
  Slope70A:=0;
  Inter70A:=0;
  Slope70B:=0;
  Inter70B:=0;
  Slope71A:=0;
  Inter71A:=0;
  Slope71B:=0;
  Inter71B:=0;
  Slope72A:=0;
  Inter72A:=0;
  Slope72B:=0;
  Inter72B:=0;
  Slope80A:=0;
  Inter80A:=0;
  Slope80B:=0;
  Inter80B:=0;
  Slope81A:=0;
  Inter81A:=0;
  Slope81B:=0;
  Inter81B:=0;
  Slope82A:=0;
  Inter82A:=0;
  Slope82B:=0;
  Inter82B:=0;
  Norm:=false;

//Checking data
  RegRes1;
  if NotFit then exit;
  Key:=DMCumFreq.Preference;

  setlength (AuxMag,NumDat+1);
  setlength (TmpMag, NumDat+1);
  setlength (TmpFrq, NumDat+2);
  setlength (FrqCalc, NumDat+1);
  if Key='1' then
  begin
    TempFile:=changefileext(DMCumFreq.FileName,'.Lst');
    AssignFile (ListFile,TempFile);
    rewrite (ListFile);
    writeln (ListFile,' List of AVERAGES of absolute values of the differences'+
                      ' between');
    writeln (ListFile,' observed and calcuated cumulative frequency values'+
                      ' (in %).');
    writeln (ListFile);
    writeln (ListFile,' The lower the average, the better the distribution'+
                      ' fit. Averages are ranked.');
    writeln (ListFile);
    TempFile:=extractfilename(DMCumFreq.FileName);
    TempFile:=changefileext(TempFile,'.Lst');
    writeln (ListFile,' Name of this file : ',TempFile);
    writeln (ListFile);
  end;


  if Key='1' then                       {Find best fitting distribution of all}
  begin

43: Method := 3;                        {a-symptotic exponential, Poisson type}
    for kk:=1 to NumDat do              {generalized}
    begin
      TmpMag[kk] := Mag[kk];
      TmpFrq[kk] := Frq[kk];
      Frq[kk] := -ln(1-Frq[kk]);
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      SumResSq3 := 0;
      Step:=Step+0.01;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      Slope3    := Slope;
      Inter3    := FrqAv-Slope*MagAv;
      for kk:=1 to NumDat do
      begin
        Power     := -Slope3*Mag[kk] - Inter3;
        if Power<8 then FrqRg := 1 - exp(Power) else  FrqRg   := 8;
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSq3 := SumResSq3 + ResiduSq;
      end;
      Summation[mm] := SumResSq3;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    SumResSq3 := 0;
    Expon3:=0.01*KM+0.19;
    if (Expon3<0.21) or (Expon3>2.98) then Expon3:=1;
    if (Expon3>0.95) and (Expon3<1.05) then Expon3:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon3*ln(TmpMag[ii]));
    Regres1;
    Slope3    := Slope;
    Inter3    := FrqAv-Slope*MagAv;
    ResiduAb:=0;
    for kk:=1 to NumDat do
    begin
      Frq[kk]   := TmpFrq[kk];                   {reset original frequency}
      Power     := -Slope3*Mag[kk] - Inter3;
      Mag[kk]   := TmpMag[kk];                   {reset original magnitude}
      if Power<8 then FrqRg := 1 - exp(Power) else  FrqRg   := 8;
      if FrqRg<=0 then FrqRG:=0.001;
      if FrqRg>0.999 then FrqRg:=0.999;
      Residu    := Frq[kk] - FrqRg;
      ResiduAb  := ResiduAb + abs(Residu);
      ResiduSq  := Residu*Residu;
      SumResSq3 := SumResSq3 + ResiduSq;
    end;
    SumResSq3:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 3 done');
    if (Key='1') and (Expon3<>1) then
    begin
      writeln(ListFile,' Generalized exponential (Poisson-type) distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if (Key='1') and (Expon3=1) then
       SumResSq3:=1000;

    if Key='3' then                           {exponential (Poisson) preferred}
    begin
      Slope:=Slope3;
      Inter:=Inter3;
      exit;
    end;

44: Method := 4;                                            {Gumbel}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(-ln(Frq[ii]));         {transforming frequencies}
    end;
    Regres1;
    SumResSq4 := 0;
    Slope4    := Slope;
    Inter4    := FrqAv-Slope*MagAv;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope4*Mag[ii]+Inter4;
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := exp(-exp(-Power));
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq4  := SumResSq4 + ResiduSq;
    end;
    SumResSq4:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 4 done');
    if Key='1' then
    begin
      writeln(ListFile,' Gumbel distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];
      Frq[ii] := TmpFrq[ii];          {resetting original freq values}
    end;
    StDev := 1.28/Slope4;
    if Key='4' then                               {Gumbel preferred}
    begin
      Slope:=Slope4;
      Inter:=Inter4;
      exit;
    end;

45: Method := 5;                                   {Gumbel mirrored}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(-ln(1-Frq[ii]));       {transforming frequencies}
    end;
    Regres1;
    SumResSq5 := 0;
    Slope5    := Slope;
    Inter5    := FrqAv-Slope*MagAv;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope5*Mag[ii]+Inter5;
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := 1-exp(-exp(-Power));
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq5  := SumResSq5 + ResiduSq;
    end;
    SumResSq5:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 5 done');
    if Key='1' then
    begin
      writeln(ListFile,' Mirrored Gumbel distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];
      Frq[ii] := TmpFrq[ii];          {resetting original freq values}
    end;
    StDev := 1.28/Slope5;
    if Key='5' then                              {Gumbel mirrored preferred}
    begin
      Slope:=Slope5;
      Inter:=Inter5;
      exit;
    end;

46: Method := 6;                        {a-symptotic exponential, Poisson type}
    for kk:=1 to NumDat do
    begin
      TmpMag[kk] := Mag[kk];
      TmpFrq[kk] := Frq[kk];
      Frq[kk] := -ln(1-Frq[kk]);
    end;
    SumResSq6 := 0;
    for ii:=1 to NumDat do Mag[ii] := exp(ln(TmpMag[ii]));
    Ratio1;                   {Gives MagAv and StErr of transferred data}
    Slope6    := Slope;
    ResiduAb  := 0;
    for kk:=1 to NumDat do
    begin
      Power     := -Slope6*Mag[kk];
      if Power<8 then FrqRg := 1 - exp(Power) else  FrqRg   := 8;
      Residu    := TmpFrq[kk] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq  := Residu*Residu;
      SumResSq6 := SumResSq6 + ResiduSq;
    end;
    SumResSq6:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' please wait ...');
    if Key='1' then
    begin
      writeln(ListFile,' Exponential distribution (Poisson type)');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];
      Frq[ii] := TmpFrq[ii];          {resetting original freq values}
    end;
    Slope:=Slope6;
    if Key='6' then exit;

41: Method := 31;                                 { Burr}
    MaxX:=0;
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                        {saving data values}
      if TmpMag[ii]>MaxX then MaxX:=TmpMag[ii];
      TmpFrq[ii]:=Frq[ii];
      Frq[ii]:=ln(1-TmpFrq[ii]);
    end;
    Step:=0.001;
    if (MaxX>0.5) and (MaxX<1) then Step:=0.002;
    if (MaxX>1) and (MaxX<=5) then Step:=0.01;
    if (MaxX>5) and (MaxX<=10) then Step:=0.02;
    if (MaxX>10) and (MaxX<=50) then Step:=0.1;
    if (MaxX>50) and (MaxX<=100) then Step:=0.2;
    if (MaxX>100) and (MaxX<=500) then Step:=1;
    if (MaxX>500) and (MaxX<=1000) then Step:=2;
    if (MaxX>1000) and (MaxX<=5000) then Step:=10;
    if (MaxX>5000) then Step:=20;
    kk:=0;
    Beta[1]:=Step;
    ii:=1;
    while Beta[ii]<MaxX do
    begin
      ii:=ii+1;
      Beta[ii]:=Beta[ii-1]+Step;
      kk:=kk+1;
    end;
    IJ := kk;
    MinResidu:=1000000;

    FOR kk:=1 to 330 do
    BEGIN

    Power:=0.2+kk*0.01;

    for ii:=1 to IJ do
    begin
      if ii=1 then Beta[ii]:=Step else Beta[ii]:=Beta[ii-1]+Step;
      AAA[ii]:=exp(Power*ln(Beta[ii]));
    end;
    for jj:=1 to IJ do
    begin
      SumResSq31:=0;
      for ii:=1 to Numdat do                        {transforming data values}
          Mag[ii]:=ln(AAA[jj]/(exp(Power*ln(TmpMag[ii]))+AAA[jj]));
      Regres1;
      Bur:=Inter;
      for ii:=1 to NumDat do
      begin
        FrqRg      := 1-exp(Slope*Mag[ii]+Bur);
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq31 := SumResSq31+ResiduSq;
        SumSq[jj] := SumResSq31;
      end;
    end;
    for jj:=1 to IJ do
      if SumSq[jj]<MinResidu then
      begin
        MinResidu:=SumSq[jj];
        MM:=jj;
        NN:=kk;
      end;

      if (Key='31') and (kk=100) and (NumDat>500) then
          MainForm.WaitMemo.Lines.Add(' Burr is busy ....');
      if (Key='31') and (kk=150) and (NumDat>500) then
          MainForm.WaitMemo.Lines.Add(' Please wait .....');

    END; {For kk:=1 to 330 do}


    Power:=0.2+NN*0.01;
    AA1B:=Power;
    BE1B:=Beta[MM];
    Beta[MM]:=exp(Power*ln(Beta[MM]));
    Inter31 := Beta[MM];                           {beta}
    for ii:=1 to Numdat do
    begin
      Inter:=exp(Power*ln(TmpMag[ii]));
      Mag[ii]:=ln(Beta[MM]/(Inter+Beta[MM])); {transforming data values}
    end;
    Regres1;
    Bur        := Inter;
    Slope31    := Slope;                             {K exp}
    ResiduAb   := 0;
    SumResSq31 := 0;
    for ii:=1 to NumDat do
    begin
      FrqRg      := 1-exp(Slope31*Mag[ii]+Bur);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq31 := SumResSq31 + ResiduSq;
    end;
    MainForm.WaitMemo.Lines.Add(' 31 done');
    SumResSq31:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Burr distribution generalized');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
        Mag[ii] := TmpMag[ii];         {resetting original data values}
        Frq[ii] := TmpFrq[ii];
    end;
    if Key='31' then exit;

60: Method := 34;                                 { Gompertz gen.}
    kk:=0;
    Setlength (AuxMag,NumDat+1);
    for ii:=1 to NumDat do
    begin
      AuxMag[ii]:= Mag[ii];
      TmpMag[ii]:= Mag[ii];                        {saving data values}
      TmpFrq[ii]:=Frq[ii];
      Frq[ii]:=ln(1-TmpFrq[ii]);
    end;
    for ii:=1 to NumDat do if Mag[ii]<1 then Small:=true;
    if Small then for ii:=1 to NumDat do TmpMag[ii]:=TmpMag[ii]+1;

    MinResidu:=1000000;

    FOR kk:=1 to 33 do
    BEGIN

    Power:=0.2+kk*0.1;
    for jj:=1 to 33 do
    begin
      Step := 0.2 + jj*0.1;
      SumResSq34:=0;
      for ii:=1 to Numdat do                        {transforming data values}
      begin
        Mag[ii]:=Power*ln(TmpMag[ii]);
        Mag[ii]:=exp(Step*Mag[ii])-1;
      end;
      Ratio1;
      for ii:=1 to NumDat do
      begin
        FrqRg      := 1 - exp(Slope*(Mag[ii]));
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq34 := SumResSq34+ResiduSq;
      end;
    if SumResSq34<MinResidu then
    begin
      MinResidu:=SumResSq34;
      MM:=jj;
      NN:=kk;
    end;

    END; {For kk:=1 to 33 do}
    END; {for jj:=1 to 53 do}

    Power:=0.2+NN*0.1;
    AA1G := Power;
    Step:=0.2+MM*0.1;
    BE1G:=Step;
    for ii:=1 to Numdat do                        {transforming data values}
    begin
       Mag[ii]:=Power*ln(TmpMag[ii]);
       Mag[ii]:=exp(Step*Mag[ii])-1;
    end;
    Ratio1;
    Slope34    := Slope;                             {K exp}
    ResiduAb   := 0;
    SumResSq34 := 0;
    for ii:=1 to NumDat do
    begin
      FrqRg      := 1 - exp(Slope34*(Mag[ii]));
      if FrqRg<0.001 then FrqRg:=0.5*Frq[ii];
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq34 := SumResSq34 + ResiduSq;
    end;
    SumResSq34:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Gompertz distribution generalized');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
        Mag[ii] := AuxMag[ii];         {resetting original data values}
        Frq[ii] := TmpFrq[ii];
    end;
   if Key='34' then exit;

    MainForm.WaitMemo.Lines.Add(' 34 done');

40: Method := 36;                            { KumaraSwamy with ratio method}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                  {saving data values}
      TmpFrq[ii] := Frq[ii];                  {saving frequency values}
      Frq[ii] := ln(1-(Frq[ii]));             {transforming frequencies}
    end;
    for kk:=1 to 200 do
      begin
      MaxVal:=TmpMag[NumDat]*(1+0.1*kk);
      for ii:=1 to NumDat do
          AuxMag[ii]:=TmpMag[ii]/MaxVal;
      Step:=0.19;
      for mm:=1 to 280 do
      begin
        Step:=Step+0.01;
        for ii:=1 to NumDat do
        begin
          Power:= 1-exp(Step*ln(AuxMag[ii]));
          if Power>0 then
             Mag[ii]:=ln(1-exp(Step*ln(AuxMag[ii])))
          else Mag[ii]:=0.00001;
        end;
        Ratio1;                   {Gives MagAv and StErr of transferred data}
        Slope36    := Slope;
        SumResSq36 := 0;
        for ii:=1 to NumDat do
        begin
          Power      := 1-exp(Step*ln(AuxMag[ii]));
          FrqRg      := 1 - exp(Slope36*ln(Power));
          Residu     := TmpFrq[ii] - FrqRg;
          if abs(Residu)>1 then Residu:=1;
          ResiduSq   := Residu*Residu;
          SumResSq36 := SumResSq36 + ResiduSq;
        end;
        Sums[kk,mm] := SumResSq36;
      end; {for mm:=1 to 280 do}
    end; {for kk:=1 to 300 do}
    MinResidu:=1000000;
    for kk:=1 to 200 do for jj:=2 to 280 do
      if Sums[kk,jj]<MinResidu then
      begin
        MinResidu:=Sums[kk,jj];
        KM:=jj;
        NN:=kk;
      end;
    MaxVal:=TmpMag[NumDat]*(1+0.1*NN);
    Expon36:=0.01*KM+0.19;
    if (Expon36<0.21) or (Expon36>2.98) then Expon36:=1;
    if (Expon36>0.95) and (Expon36<1.05) then Expon36:=1;
    for ii:=1 to NumDat do
    begin
      AuxMag[ii]:=TmpMag[ii]/MaxVal;
      Mag[ii]:=ln(1-exp(Expon36*ln(AuxMag[ii])));
    end;
    Ratio1;
    SumResSq36 := 0;
    Slope36    := Slope;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := 1-exp(Expon36*ln(AuxMag[ii]));
      FrqRg      := 1 - exp(Slope36*ln(Power));
      FrqCalc[ii]:=FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq36 := SumResSq36 + ResiduSq;
    end;
    SumResSq36:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Kumaraswamy distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];            {resetting original data values}
      Frq[ii] := TmpFrq[ii];            {resetting original freq values}
    end;
    StDev := 1.28/Slope36;
    if Key='39' then                    {Kumaraswamy preferred}
    begin
      Slope:=Slope36;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 36 done');

42: Method := 32;                                 { Dagum}
    MaxX:=0;
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                        {saving data values}
      if TmpMag[ii]>MaxX then MaxX:=TmpMag[ii];
      TmpFrq[ii]:=Frq[ii];
      Frq[ii]:=ln(TmpFrq[ii]);
    end;
    Step:=0.001;
    if (MaxX>0.5) and (MaxX<1) then Step:=0.002;
    if (MaxX>1) and (MaxX<=5) then Step:=0.01;
    if (MaxX>5) and (MaxX<=10) then Step:=0.02;
    if (MaxX>10) and (MaxX<=50) then Step:=0.1;
    if (MaxX>50) and (MaxX<=100) then Step:=0.2;
    if (MaxX>100) and (MaxX<=500) then Step:=1;
    if (MaxX>500) and (MaxX<=1000) then Step:=2;
    if (MaxX>1000) and (MaxX<=5000) then Step:=10;
    if (MaxX>5000) then Step:=20;
    MinResidu:=1000000;
    kk:=0;
    for ii:=1 to 2000 do
    begin
      if ii=1 then Beta[ii]:=Step else Beta[ii]:=Beta[ii-1]+Step;
      if Beta[ii]<MaxX then kk:=kk+1;
    end;
    IJ := kk;

    FOR kk:=1 to 330 do
    BEGIN

    Power:=-0.2-kk*0.01;

    for ii:=1 to IJ do
    begin
      if ii=1 then Beta[ii]:=Step else Beta[ii]:=Beta[ii-1]+Step;
      AAA[ii]:=exp(Power*ln(Beta[ii]));
    end;
    for jj:=1 to IJ do
    begin
      SumResSq32:=0;
      for ii:=1 to Numdat do                        {transforming data values}
          Mag[ii]:=ln(AAA[jj]/(exp(Power*ln(TmpMag[ii]))+AAA[jj]));
      Regres1;
      Dag:=Inter;
      for ii:=1 to NumDat do
      begin
        FrqRg      := exp(Slope*Mag[ii]+Dag);
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq32 := SumResSq32+ResiduSq;
        SumSq[jj] := SumResSq32;
      end;
    end;
    for jj:=1 to IJ do
      if SumSq[jj]<MinResidu then
      begin
        MinResidu:=SumSq[jj];
        MM:=jj;
        NN:=kk;
      end;

    END; {For kk:=1 to 330 do}

    Power:=-0.2-NN*0.01;
    AA1D:=Power;
    BE1D:=Beta[MM];
    Beta[MM]:=exp(Power*ln(Beta[MM]));
    Inter32 := Beta[MM];                           {beta}
    for ii:=1 to Numdat do
    begin
      Inter:=exp(Power*ln(TmpMag[ii]));
      Mag[ii]:=ln(Beta[MM]/(Inter+Beta[MM])); {transforming data values}
    end;
    Regres1;
    Dag        := Inter;
    Slope32    := Slope;                             {K exp}
    ResiduAb   := 0;
    SumResSq32 := 0;
    for ii:=1 to NumDat do
    begin
      FrqRg      := exp(Slope32*Mag[ii]+Dag);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq32 := SumResSq32 + ResiduSq;
    end;
    SumResSq32:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Dagum distribution generalized');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    MainForm.WaitMemo.Lines.Add(' 32 done');
    for ii:=1 to NumDat do
    begin
        Mag[ii] := TmpMag[ii];         {resetting original data values}
        Frq[ii] := TmpFrq[ii];
    end;
    if Key='32' then exit;

51: Method := 51;                           {Gumbel generalized}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(-ln(Frq[ii]));         {transforming frequencies}
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      Step:=Step+0.01;
      SumResSq51 := 0;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      Slope51    := Slope;
      Inter51    := FrqAv-Slope*MagAv;
      for ii:=1 to NumDat do
      begin
        Power      := Slope51*Mag[ii]+Inter51;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq51 := SumResSq51 + ResiduSq;
      end;
      Summation[mm] := SumResSq51;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon51:=0.01*KM+0.19;
    if (Expon51<0.21) or (Expon51>2.98) then Expon51:=1;
    if (Expon51>0.95) and (Expon51<1.05) then Expon51:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon51*ln(TmpMag[ii]));
    Regres1;
    SumResSq51 := 0;
    Slope51    := Slope;
    Inter51    := FrqAv-Slope*MagAv;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope51*Mag[ii]+Inter51;
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := exp(-exp(-Power));
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq51 := SumResSq51 + ResiduSq;
    end;
    SumResSq51:=ResiduAb;
    if (Key='1') and (Expon51<>1) then
    begin
      writeln(ListFile,' Gumbel distribution generalized');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if (Key='1') and (Expon51=1) then
       SumResSq51:=1000;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];            {resetting original data values}
      Frq[ii] := TmpFrq[ii];            {resetting original freq values}
    end;
    StDev := 1.28/Slope51;
    if Key='51' then                    {Gumbel generalized preferred}
    begin
      Slope:=Slope51;
      Inter:=Inter51;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 51 done');

52: Method := 52;                           {Gumbel Mirror generalized}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(-ln(1-Frq[ii]));       {transforming frequencies}
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      Step:=Step+0.01;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      SumResSq52 := 0;
      Slope52    := Slope;
      Inter52    := FrqAv-Slope*MagAv;
      for ii:=1 to NumDat do
      begin
        Power      := Slope52*Mag[ii]+Inter52;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg      := 1-exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq52  := SumResSq52 + ResiduSq;
      end;
      Summation[mm] := SumResSq52;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon52:=0.01*KM+0.19;
    if (Expon52<0.21) or (Expon52>2.98) then Expon52:=1;
    if (Expon52>0.95) and (Expon52<1.05) then Expon52:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon52*ln(TmpMag[ii]));
    Regres1;
    SumResSq52 := 0;
    Slope52    := Slope;
    Inter52    := FrqAv-Slope*MagAv;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope52*Mag[ii]+Inter52;
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := 1-exp(-exp(-Power));
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq52  := SumResSq52 + ResiduSq;
    end;
    SumResSq52:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 52 done');
    if (Key='1') and (Expon52<>1) then
    begin
      writeln(ListFile,' Generalized Mirrored Gumbel distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if (Key='1') and (Expon52=1) then
       SumResSq52:=1000;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];            {resetting original data values}
      Frq[ii] := TmpFrq[ii];            {resetting original freq values}
    end;
    Slope:=Slope52;
    Inter:=Inter52;
    if Key='52' then exit;

53: Method := 53;                           {Logistic}
    for ii:=1 to NumDat do
    begin
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := ln(1/Frq[ii]-1);           {transforming frequencies}
    end;
    Regres1;
    SumResSq53 := 0;
    Slope53    := Slope;
    Inter53    := FrqAv-Slope*MagAv;
    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power      := 1+exp(Slope53*Mag[ii]+Inter53);
      FrqRg      := 1/Power;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq53 := SumResSq53 + ResiduSq;
    end;
    SumResSq53:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 53 done');
    if Key='1' then
    begin
      writeln(ListFile,' Logistic distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
        Frq[ii] := TmpFrq[ii];              {resetting original freq values}
      Slope:=Slope53;
      Inter:=Inter53;
      if Key='53' then exit;

54: Method := 54;                           {Log Logistic}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      Mag[ii]:=ln(Mag[ii]);                 {transforming data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := ln(1/Frq[ii]-1);           {transforming frequencies}
    end;
    Regres1;
    SumResSq54 := 0;
    Slope54    := Slope;
    Inter54    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Power      := 1+exp(Slope54*Mag[ii]+Inter54);
      FrqRg      := 1/Power;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq54 := SumResSq54 + ResiduSq;
    end;
    SumResSq54:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 54 done');
    if Key='1' then
    begin
      writeln(ListFile,' Log-logistic distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
    end;
    Slope:=Slope54;
    Inter:=Inter54;
    if Key='54' then exit;

69: Method := 69;                           {Rayleigh generalized}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := ln(1-Frq[ii]);            {transforming frequencies}
    end;

    MinResidu:=1000000;
    for kk:=1 to 290 do
    begin
      Step:=0.1+0.01*kk;
      for ii:=1 to Numdat do Mag[ii]:=exp(Step*ln(TmpMag[ii]));
      Regres1;

    for jj:=1 to 200 do
    begin
      Slope:=exp(Step*ln(0.01*jj*MagAv));
      ResiduAb:=0;
      SumResSq69:=0;
      for ii:=1 to Numdat do
      begin
        FrqRg      := 1 - exp(-Mag[ii]/Slope);
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduAb   := ResiduAb + abs(Residu);
        ResiduSq   := Residu*Residu;
        SumResSq69 := SumResSq69 + ResiduSq;
      end;
      if SumResSq69<MinResidu then
      begin
        MinResidu:=SumResSq69;
        KM:=kk;
        NN:=jj;
      end;
    end;
    end; {for kk:=1 to 300 do}
    Expon69:=0.1+0.01*KM;
    for ii:=1 to Numdat do Mag[ii]:=exp(Expon69*ln(TmpMag[ii]));
    Regres1;
    Slope69:=exp(Expon69*ln(0.01*NN*MagAv));
    ResiduAb:=0;
    SumResSq69:=0;
    for ii:=1 to Numdat do
    begin
      FrqRg      := 1 - exp(-Mag[ii]/Slope69);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq69 := SumResSq69 + ResiduSq;
    end;
    SumResSq69:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Generalized Rayleigh distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
    end;
    if Key='69' then exit;                        {Gen. Rayleigh preferred}
    MainForm.WaitMemo.Lines.Add(' 69 done ...');

55: Method := 55;                           {generalized Logistic}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := ln(1/Frq[ii]-1);           {transforming frequencies}
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      Step:=Step+0.01;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      Slope55    := Slope;
      Inter55    := FrqAv-Slope*MagAv;
      SumResSq55 := 0;
      for ii:=1 to Numdat do
      begin
        Power      := 1+exp(Slope55*Mag[ii]+Inter55);
        FrqRg      := 1/Power;
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq55 := SumResSq55 + ResiduSq;
      end;
      Summation[mm] := SumResSq55;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon55:=0.01*KM+0.19;
    if (Expon55<0.21) or (Expon55>2.98) then Expon55:=1;
    if (Expon55>0.95) and (Expon55<1.05) then Expon55:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon55*ln(TmpMag[ii]));
    Regres1;
    Slope55    := Slope;
    Inter55    := FrqAv-Slope*MagAv;
    SumResSq55 := 0;
    ResiduAb   := 0;
    for ii:=1 to Numdat do
    begin
      Power      := 1+exp(Slope55*Mag[ii]+Inter55);
      FrqRg      := 1/Power;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq55 := SumResSq55 + ResiduSq;
    end;
    SumResSq55:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 50% completed ..');
    if (Key='1') and (Expon55<>1) then
    begin
      writeln(ListFile,' Generalized logistic distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end else
    if (Key='1') and (Expon55=1) then
       SumResSq55:=1000;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];
    end;
    Slope:=Slope55;
    Inter:=Inter55;
    if Key='55' then exit;

68: Method:=68;                                  {Laplace distribution}
    for ii:=1 to NumDat do
    begin
      TmpFrq[ii] := Frq[ii];
      TmpMag[ii] := Mag[ii];
    end;
    MinResidu:=1000000;
    MM:=trunc(NumDat/3);
    Power:=Mag[MM];
    MM:=trunc(2*NumDat/3);
    BB:=Mag[MM];
    For jj:=1 to NumDat do
    BEGIN
      InFlex:=Power+jj*(BB-Power)/Numdat;
      Slope:=0;
      for ii:=1 to NumDat do if (Mag[ii]>Inflex) and (Slope=0) then
      begin
        TmpNum:=ii;
        Slope:=1;
      end;
      for ii:=1 to NumDat do
          if ii<=TmpNum then Frq[ii] := ln(2*TmpFrq[ii])
             else Frq[ii]:=ln(0.5)-ln(1-TmpFrq[ii]);
      Regres2;
      Slope1:=Slope;
      Ratio2;
      Slope2:=Slope;
      Inter1:=1/Slope1;
      Inter2:=1/Slope2;
      SumResSqA:=0;
      SumResSqB:=0;
      for kk:=1 to TmpNum do
      begin
        FrqRg:= (Mag[kk]-Inflex)/Inter1;
        if FrqRg>100 then
           FrqRg:=100;
        FrqRg     :=0.5*exp(FrqRg);
        FrqCalc[kk]:=FrqRg;
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSqA := SumResSqA + ResiduSq;
      end;
      for kk:=TmpNum+1 to NumDat do
      begin
        FrqRg:=   1 - 0.5*exp(-(Mag[kk]-InFlex)/Inter2);
        FrqCalc[kk]:=FrqRg;
        Residu    := TmpFrq[kk] - FrqRg;
        ResiduSq  := Residu*Residu;
        SumResSqB := SumResSqB + ResiduSq;
      end;
      SumResSq68 := SumResSqA + SumResSqB;
      if SumResSq68<MinResidu then
      begin
        MinResidu:=SumResSq68;
        BoundL1:=InFlex;
        BB1:=Inter1;
        BB2:=Inter2;
      end;
      SumResSq68:=MinResidu;
    END; {For jj:=1 to NumDat do}

    NumDat:=DMCumFreq.NrOfData;

    for kk:=1 to NumDat do
    begin
      if Mag[kk]<=BoundL1 then
        FrqCalc[kk] :=0.5*exp((Mag[kk]-BoundL1)/BB1)
      else
        FrqCalc[kk]:=1-0.5*exp(-(Mag[kk]-BoundL1)/BB2);
    end;
    ResiduAb := 0;
    for kk:=1 to NumDat do
    begin
      Residu := TmpFrq[kk] - FrqCalc[kk];
      ResiduAb := ResiduAb + abs(Residu);
    end;
    SumResSq68:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Laplace distribution (standard)');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;

    for ii:=1 to NumDat do                     {resetting original values}
        Frq[ii] := TmpFrq[ii];
    if Key='68' then exit;                              {Laplace preferred}
    MainForm.WaitMemo.Lines.Add(' 68 done');

73: Method:=73;                                         {Laplace gen.}
    for ii:=1 to NumDat do
    begin
      TmpFrq[ii] := Frq[ii];
      TmpMag[ii] := Mag[ii];
    end;
    MinResidu:=1000000;
    MM:=trunc(NumDat div 3);
    Power:=Mag[MM];
    MM:=trunc(2*NumDat div 3);
    BB:=Mag[MM];
    Step:=0;
    Factor:=0;
    for nn:=1 to 80 do delta[nn]:=step+nn*0.025;
    for ij:=1 to 80 do gamma[ij]:=factor+ij*0.025;

    for nn:=1 to 80 do
    begin
    for ij:=1 to 80 do
    begin
    For jj:=1 to NumDat do
    BEGIN
      InFlex:=Power+jj*(BB-Power)/20;
      Slope:=0;
      for ii:=1 to NumDat do if (TmpMag[ii]>Inflex) and (Slope=0) then
      begin
        TmpNum:=ii;
        Slope:=1;
      end;
      for ii:=1 to NumDat do
          if ii<=TmpNum then Frq[ii] := ln(2*TmpFrq[ii])
             else Frq[ii]:=ln(0.5)-ln(1-TmpFrq[ii]);
      for ii:=1 to NumDat do
      begin
          if ii<=TmpNum then Mag[ii] := exp(delta[nn]*ln(TmpMag[ii]))
             else Mag[ii] := exp(gamma[ij]*ln(TmpMag[ii]));
      end;
      InFlex:=exp(delta[nn]*ln(InFlex));
      Regres2;
      Slope1:=Slope;
      Ratio2;
      Slope2:=Slope;
      Inter1:=1/Slope1;
      Inter2:=1/Slope2;
      if Inter2<0 then Inter2:=1;
      SumResSqA:=0;
      for kk:=1 to TmpNum do
      begin
        FrqRg:= (Mag[kk]-Inflex)/Inter1;
        if FrqRg>100 then FrqRg:=100;
        FrqRg     :=0.5*exp(FrqRg);
        if abs(Residu)>1000 then Residu:=1000;
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSqA := SumResSqA + ResiduSq;
      end;
      SumResSqB:=0;
      for kk:=TmpNum+1 to NumDat do
      begin
        Factor:=(-(Mag[kk]-InFlex)/Inter2);
        if factor>0 then
        begin
           slope:=2;
           Factor:=0;
        end;
        if Factor>100 then Factor:=100;
        FrqRg:=   1 - 0.5*exp(Factor);
        FrqCalc[kk]:=FrqRg;
        Residu    := TmpFrq[kk] - FrqRg;
        ResiduSq  := Residu*Residu;
        SumResSqB := SumResSqB + ResiduSq;
      end;
      SumResSq73 := SumResSqA + SumResSqB;
      if SumResSq73<MinResidu then
      begin
        MinResidu:=SumResSq73;
        BB1G:=Inter1;
        BB2G:=Inter2;
        Number:=TmpNum;
        KM:=nn;
        MM:=ij;
        Inter := ResiduAb;
        BoundLG:=Inflex;
      end;
    END; {For jj:=1 to Numdat do}
    end;
    end;

    NumDat:=DMCumFreq.NrOfData;

    Expon73A:=KM*0.025;
    Expon73B:=MM*0.025;
    TmpNum:=Number;
      for ii:=1 to NumDat do
          if ii<TmpNum then Mag[ii] := exp(Expon73A*ln(TmpMag[ii]))
             else Mag[ii] := exp(Expon73B*ln(TmpMag[ii]));

    for kk:=1 to NumDat do
    begin
      if Mag[kk]<=BoundLG then
        FrqCalc[kk] :=0.5*exp((Mag[kk]-BoundLG)/BB1G)
      else
        FrqCalc[kk]:=1-0.5*exp(-(Mag[kk]-BoundLG)/BB2G);
    end;
    ResiduAb := 0;
    for kk:=1 to NumDat do
    begin
      Residu := TmpFrq[kk] - FrqCalc[kk];
      ResiduAb := ResiduAb + abs(Residu);
    end;
    SumResSq73:=ResiduAb;
    if (Key='1') and (SumResSq73<0.99*SumResSq68) then
    begin
      writeln(ListFile,' Generalized Laplace distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    SlopeA:=Slope1;
    SlopeB:=Slope2;
    InterA:=Inter1;
    InterB:=Inter2;
    ExponA:=Expon73A;
    ExponB:=Expon73B;

    for ii:=1 to NumDat do                     {resetting original values}
    begin
        Frq[ii] := TmpFrq[ii];
        Mag[ii] := TmpMag[ii];
    end;
    if Key='73' then exit;                        {Laplace gen. preferred}
    MainForm.WaitMemo.Lines.Add(' 73 done');


IF DISCON THEN
BEGIN
//Method=70;                               {twice generalized Logistic}
70:    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := ln(1/Frq[ii]-1);           {transforming frequencies}
    end;
  FOR ij:=1 to 11 do
  BEGIN
    if ij=1 then TmpNum:= 5*NumDat div 20;
    if ij=2 then TmpNum:= 3*NumDat div 10;
    if ij=3 then TmpNum:= 7*NumDat div 20;
    if ij=4 then TmpNum:= 4*NumDat div 10;
    if ij=5 then TmpNum:= 9*NumDat div 20;
    if ij=6 then TmpNum:= 5*NumDat div 10;
    if ij=7 then TmpNum:= 11*NumDat div 20;
    if ij=8 then TmpNum:= 6*NumDat div 10;
    if ij=9 then TmpNum:= 13*NumDat div 20;
    if ij=10 then TmpNum:= 7*NumDat div 10;
    if ij=11 then TmpNum:= 15*NumDat div 20;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=1 to TmpNum do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      RegRes2;                   {Gives MagAv and StErr of transferred data}
      Slope70A    := Slope;
      Inter70A    := FrqAv-Slope*MagAv;
      SumResSq70A := 0;
      for kk:=1 to TmpNum do
      begin
        Power      := 1+exp(Slope70A*Mag[kk]+Inter70A);
        FrqRg      := 1/Power;
        Residu     := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq70A := SumResSq70A + ResiduSq;
      end;
      Summation[mm]:=SumResSq70A;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon70A:=0.01*KM;
    ExponAA[ij]:=Expon70A;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon70A*ln(TmpMag[ii]));
    Regres2;
    Slope70A    := Slope;
    Inter70A    := FrqAv-Slope*MagAv;
    SumResSq70A := 0;
    for ii:=1 to TmpNum do
    begin
      Power      := 1+exp(Slope70A*Mag[ii]+Inter70A);
      FrqRg      := 1/Power;
      FrqCalc[ii]:= FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduSq   := Residu*Residu;
      SumResSq70A := SumResSq70A + ResiduSq;
    end;
    SlopAA[ij]:=Slope70A;
    InteAA[ij]:=Inter70A;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=TmpNum+1 to NumDat do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      Ratio2;                {Gives MagAv and StErr of transferred data}
      Slope70B    := Slope;
      Inter70B    := Inter;
      SumResSq70B := 0;
      for kk:=TmpNum+1 to NumDat do
      begin
        Power      := Slope70B*Mag[kk]+Inter70B;
        if Power>8 then Power:=8;
        if Power<-8 then Power:=-8;
        Power      := 1+exp(Power);
        FrqRg      := 1/Power;
        Residu     := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq70B := SumResSq70B + ResiduSq;
      end;
      Summation[mm]:=SumResSq70B;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon70B:=0.01*KM;
    ExponBB[ij]:=Expon70B;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon70B*ln(TmpMag[ii]));
   Ratio2;
    Slope70B    := Slope;
    Inter70B    := Inter;
    SumResSq70B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
      Power      := 1+exp(Slope70B*Mag[ii]+Inter70B);
      FrqRg      := 1/Power;
      FrqCalc[ii]:= FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduSq   := Residu*Residu;
      SumResSq70B := SumResSq70B + ResiduSq;
    end;
    Summing[ij]:=SumResSq70A+SumResSq70B;
    SlopBB[ij] :=Slope70B;
    InteBB[ij]:=Inter70B;

  END; {for ij=1 to 5 do}

    Summing[12]:=100000;
    for ij:=1 to 11 do
    begin
      if Summing[ij]<=Summing[12] then
      begin
        Summing[12]:=Summing[ij];
        SumResSq70:=Summing[ij];
        KK:=ij;
      end;
    end;

    if KK=1 then
    begin
      TmpNum:= 5*NumDat div 20;
      Expon70A:=ExponAA[1];
      Expon70B:=ExponBB[1];
      Slope70A:=SlopAA[1];
      Slope70B:=SlopBB[1];
      Inter70A:=inteAA[1];
      Inter70B:=InteBB[1];
    end;
    if KK=2 then
    begin
      TmpNum:= 3*NumDat div 10;
      Expon70A:=ExponAA[2];
      Expon70B:=ExponBB[2];
      Slope70A:=SlopAA[2];
      Slope70B:=SlopBB[2];
      Inter70A:=inteAA[2];
      Inter70B:=InteBB[2];
    end;
    if KK=3 then
    begin
      TmpNum:= 7*NumDat div 20;
      Expon70A:=ExponAA[3];
      Expon70B:=ExponBB[3];
      Slope70A:=SlopAA[3];
      Slope70B:=SlopBB[3];
      Inter70A:=inteAA[3];
      Inter70B:=InteBB[3];
    end;
    if KK=4 then
    begin
      TmpNum:= 4*NumDat div 10;
      Expon70A:=ExponAA[4];
      Expon70B:=ExponBB[4];
      Slope70A:=SlopAA[4];
      Slope70B:=SlopBB[4];
      Inter70A:=inteAA[4];
      Inter70B:=InteBB[4];
    end;
    if KK=5 then
    begin
      TmpNum:= 9*NumDat div 20;
      Expon70A:=ExponAA[5];
      Expon70B:=ExponBB[5];
      Slope70A:=SlopAA[5];
      Slope70B:=SlopBB[5];
      Inter70A:=inteAA[5];
      Inter70B:=InteBB[5];
    end;
    if KK=6 then
    begin
      TmpNum:= 5*NumDat div 10;
      Expon70A:=ExponAA[6];
      Expon70B:=ExponBB[6];
      Slope70A:=SlopAA[6];
      Slope70B:=SlopBB[6];
      Inter70A:=inteAA[6];
      Inter70B:=InteBB[6];
    end;
    if KK=7 then
    begin
      TmpNum:= 11*NumDat div 20;
      Expon70A:=ExponAA[7];
      Expon70B:=ExponBB[7];
      Slope70A:=SlopAA[7];
      Slope70B:=SlopBB[7];
      Inter70A:=inteAA[7];
      Inter70B:=InteBB[7];
    end;
    if KK=8 then
    begin
      TmpNum:= 6*NumDat div 10;
      Expon70A:=ExponAA[8];
      Expon70B:=ExponBB[8];
      Slope70A:=SlopAA[8];
      Slope70B:=SlopBB[8];
      Inter70A:=inteAA[8];
      Inter70B:=InteBB[8];
    end;
    if KK=9 then
    begin
      TmpNum:= 13*NumDat div 20;
      Expon70A:=ExponAA[9];
      Expon70B:=ExponBB[9];
      Slope70A:=SlopAA[9];
      Slope70B:=SlopBB[9];
      Inter70A:=inteAA[9];
      Inter70B:=InteBB[9];
    end;
    if KK=10 then
    begin
      TmpNum:= 7*NumDat div 10;
      Expon70A:=ExponAA[10];
      Expon70B:=ExponBB[10];
      Slope70A:=SlopAA[10];
      Slope70B:=SlopBB[10];
      Inter70A:=inteAA[10];
      Inter70B:=InteBB[10];
    end;
    if KK=11 then
    begin
      TmpNum:= 15*NumDat div 20;
      Expon70A:=ExponAA[11];
      Expon70B:=ExponBB[11];
      Slope70A:=SlopAA[11];
      Slope70B:=SlopBB[11];
      Inter70A:=inteAA[11];
      Inter70B:=InteBB[11];
    end;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon70A*ln(TmpMag[ii]));
    SumResSq70A := 0;
    ResiduAb    := 0;
    for ii:=1 to TmpNum do
    begin
      Power      := 1+exp(Slope70A*Mag[ii]+Inter70A);
      FrqRg      := 1/Power;
      FrqCalc[ii]:= FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq70A := SumResSq70A + ResiduSq;
    end;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon70B*ln(TmpMag[ii]));
    SumResSq70B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
      Power      := 1+exp(Slope70B*Mag[ii]+Inter70B);
      FrqRg      := 1/Power;
      FrqCalc[ii]:= FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq70B := SumResSq70B + ResiduSq;
    end;
    SumResSq70:=SumResSq70A+SumResSq70B;
    SumResSq70:=ResiduAb;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];                 {saving data values}
      Frq[ii] := TmpFrq[ii];                {saving frequency values}
    end;
    Bpoint70:=Mag[TmpNum];
    Number70:=TmpNum;
    if Key='1' then
    begin
      writeln(ListFile,' Composite generalizd logistic distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    MainForm.WaitMemo.Lines.Add(' 70 done');
    InterA:=Inter70A;                        {Composite generalized logistic}
    InterB:=Inter70B;
    SlopeA:=Slope70A;
    SlopeB:=Slope70B;
    ExponA:=Expon70A;
    ExponB:=Expon70B;
    Number:=Number70;
    Bpoint:=Bpoint70;
    Method := 70;
    if Key='70' then exit;
//end method=70

// Method=71;                            {Twice Gumbel generalized}
71:    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(-ln(Frq[ii]));         {transforming frequencies}
    end;
  FOR ij:=1 to 11 do
  BEGIN
    if ij=1 then TmpNum:= 5*NumDat div 20;
    if ij=2 then TmpNum:= 3*NumDat div 10;
    if ij=3 then TmpNum:= 7*NumDat div 20;
    if ij=4 then TmpNum:= 4*NumDat div 10;
    if ij=5 then TmpNum:= 9*NumDat div 20;
    if ij=6 then TmpNum:= 5*NumDat div 10;
    if ij=7 then TmpNum:= 11*NumDat div 20;
    if ij=8 then TmpNum:= 6*NumDat div 10;
    if ij=9 then TmpNum:= 13*NumDat div 20;
    if ij=10 then TmpNum:= 7*NumDat div 10;
    if ij=11 then TmpNum:= 15*NumDat div 20;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=1 to TmpNum do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      RegRes2;                   {Gives MagAv and StErr of transferred data}
      Slope71A    := Slope;
      Inter71A    := FrqAv-Slope*MagAv;
      SumResSq71A := 0;
      for kk:=1 to TmpNum do
      begin
        Power      := Slope71A*Mag[kk]+Inter71A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq71A := SumResSq71A + ResiduSq;
      end;
      Summation[mm]:=SumResSq71A;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon71A:=0.01*KM;
    ExponAA[ij]:=Expon71A;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon71A*ln(TmpMag[ii]));
    Regres2;
    Slope71A    := Slope;
    Inter71A    := FrqAv-Slope*MagAv;
    SumResSq71A := 0;
    for ii:=1 to TmpNum do
    begin
        Power      := Slope71A*Mag[ii]+Inter71A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq71A := SumResSq71A + ResiduSq;
    end;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=TmpNum+1 to NumDat do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      Ratio2;                {Gives MagAv and StErr of transferred data}
      Slope71B    := Slope;
      Inter71B    := Inter;
      SumResSq71B := 0;
      for kk:=TmpNum+1 to NumDat do
      begin
        Power      := Slope71B*Mag[kk]+Inter71B;
        if Power>8 then Power:=8;
        if Power<-8 then Power:=-8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq71B := SumResSq71B + ResiduSq;
      end;
      Summation[mm]:=SumResSq71B;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon71B:=0.01*KM;
    ExponBB[ij]:=Expon71B;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon71B*ln(TmpMag[ii]));
    Ratio2;
    Slope71B    := Slope;
    Inter71B    := Inter;
    SumResSq71B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
        Power      := Slope71B*Mag[ii]+Inter71B;
        if Power>8 then Power:=8;
        if Power<-8 then Power:=-8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq71B := SumResSq71B + ResiduSq;
    end;
    Summing[ij]:=SumResSq71A+SumResSq71B;

  END; {FOR ij:=1 to 5 do}

    Summing[12]:=100000;
    for ij:=1 to 11 do
    begin
      if Summing[ij]<=Summing[12] then
      begin
        Summing[12]:=Summing[ij];
        SumResSq71:=Summing[ij];
        KK:=ij;
      end;
    end;

    if KK=1 then
    begin
      TmpNum:= 5*NumDat div 20;
      Expon71A:=ExponAA[1];
      Expon71B:=ExponBB[1];
    end;
    if KK=2 then
    begin
      TmpNum:= 3*NumDat div 10;
      Expon71A:=ExponAA[2];
      Expon71B:=ExponBB[2];
    end;
    if KK=3 then
    begin
      TmpNum:= 7*NumDat div 20;
      Expon71A:=ExponAA[3];
      Expon71B:=ExponBB[3];
    end;
    if KK=4 then
    begin
      TmpNum:= 4*NumDat div 10;
      Expon71A:=ExponAA[4];
      Expon71B:=ExponBB[4];
    end;
    if KK=5 then
    begin
      TmpNum:= 9*NumDat div 20;
      Expon71A:=ExponAA[5];
      Expon71B:=ExponBB[5];
    end;
    if KK=6 then
    begin
      TmpNum:= 5*NumDat div 10;
      Expon71A:=ExponAA[6];
      Expon71B:=ExponBB[6];
    end;
    if KK=7 then
    begin
      TmpNum:= 11*NumDat div 20;
      Expon71A:=ExponAA[7];
      Expon71B:=ExponBB[7];
    end;
    if KK=8 then
    begin
      TmpNum:= 6*NumDat div 10;
      Expon71A:=ExponAA[8];
      Expon71B:=ExponBB[8];
    end;
    if KK=9 then
    begin
      TmpNum:= 13*NumDat div 20;
      Expon71A:=ExponAA[9];
      Expon71B:=ExponBB[9];
    end;
    if KK=10 then
    begin
      TmpNum:= 7*NumDat div 10;
      Expon71A:=ExponAA[10];
      Expon71B:=ExponBB[10];
    end;
    if KK=11 then
    begin
      TmpNum:= 15*NumDat div 20;
      Expon71A:=ExponAA[11];
      Expon71B:=ExponBB[11];
    end;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon71A*ln(TmpMag[ii]));
    Regres2;
    Slope71A    := Slope;
    Inter71A    := FrqAv-Slope*MagAv;
    SumResSq71A := 0;
    ResiduAb    := 0;
    for ii:=1 to TmpNum do
    begin
        Power      := Slope71A*Mag[ii]+Inter71A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduAb   := ResiduAb + abs(Residu);
        ResiduSq   := Residu*Residu;
        SumResSq71A := SumResSq71A + ResiduSq;
    end;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon71B*ln(TmpMag[ii]));
    Ratio2;
    Slope71B    := Slope;
    Inter71B    := Inter;
    SumResSq71B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
        Power      := Slope71B*Mag[ii]+Inter71B;
        if Power>8 then Power:=8;
        if Power<-8 then Power:=-8;
        FrqRg      := exp(-exp(-Power));
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduAb   := ResiduAb + abs(Residu);
        ResiduSq   := Residu*Residu;
        SumResSq71B := SumResSq71B + ResiduSq;
    end;
    SumResSq71:=ResiduAb;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];                 {saving data values}
      Frq[ii] := TmpFrq[ii];                {saving frequency values}
    end;
    Bpoint71:=Mag[TmpNum];
    Number71:=TmpNum;
    if Key='1' then
    begin
      writeln(ListFile,' Composite generalized Gumbel distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    InterA:=Inter71A;                           {Composite generalized Gumbel}
    InterB:=Inter71B;
    SlopeA:=Slope71A;
    SlopeB:=Slope71B;
    ExponA:=Expon71A;
    ExponB:=Expon71B;
    Number:=Number71;
    Bpoint:=Bpoint71;
    Method:=71;
    MainForm.WaitMemo.Lines.Add(' 71 done');
    if Key='71' then exit;
//end method=71;

// Method=72;                            {Twice Poisson generalized}
72:    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := -ln(1-Frq[ii]);
    end;
  FOR ij:=1 to 11 do
  BEGIN
    if ij=1 then TmpNum:= 5*NumDat div 20;
    if ij=2 then TmpNum:= 3*NumDat div 10;
    if ij=3 then TmpNum:= 7*NumDat div 20;
    if ij=4 then TmpNum:= 4*NumDat div 10;
    if ij=5 then TmpNum:= 9*NumDat div 20;
    if ij=6 then TmpNum:= 5*NumDat div 10;
    if ij=7 then TmpNum:= 11*NumDat div 20;
    if ij=8 then TmpNum:= 6*NumDat div 10;
    if ij=9 then TmpNum:= 13*NumDat div 20;
    if ij=10 then TmpNum:= 7*NumDat div 10;
    if ij=11 then TmpNum:= 15*NumDat div 20;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=1 to TmpNum do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      RegRes2;                   {Gives MagAv and StErr of transferred data}
      Slope72A    := Slope;
      Inter72A    := FrqAv-Slope*MagAv;
      SumResSq72A := 0;
      for kk:=1 to TmpNum do
      begin
        Power     := -Slope72A*Mag[kk] - Inter72A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSq72A := SumResSq72A + ResiduSq;
      end;
      Summation[mm]:=SumResSq72A;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon72A:=0.01*KM;
    ExponAA[ij]:=Expon72A;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon72A*ln(TmpMag[ii]));
    Regres2;
    Slope72A    := Slope;
    Inter72A    := FrqAv-Slope*MagAv;
    SumResSq72A := 0;
    for ii:=1 to TmpNum do
    begin
        Power     := -Slope72A*Mag[ii] - Inter72A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[ii] - FrqRg;
        ResiduSq  := Residu*Residu;
        SumResSq72A := SumResSq72A + ResiduSq;
    end;

    Step:=0;
    for mm:=1 to 300 do
    begin
      Step:=Step+0.01;
      for kk:=TmpNum+1 to NumDat do Mag[kk] := exp(Step*ln(TmpMag[kk]));
      Ratio2;
      Slope72B    := Slope;
      Inter72B    := 0;
      SumResSq72B := 0;
      for kk:=TmpNum+1 to NumDat do
      begin
        Power     := -Slope72B*Mag[kk] - Inter72B;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSq72B := SumResSq72B + ResiduSq;
      end;
      Summation[mm]:=SumResSq72B;
    end; {for mm:=1 to 2000 do}

    MinResidu:=1000000;
    for jj:=1 to 300 do
      if Summation[jj]>0 then if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon72B:=0.01*KM;
    ExponBB[ij]:=Expon72B;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon72B*ln(TmpMag[ii]));
    Ratio2;
    Slope72B    := Slope;
    Inter72B    := 0;
    SumResSq72B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
        Power     := -Slope72B*Mag[ii] - Inter72B;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[ii] - FrqRg;
        ResiduSq  := Residu*Residu;
        SumResSq72B := SumResSq72B + ResiduSq;
    end;
    Summing[ij]:=SumResSq72A+SumResSq72B;

  END; {FOR ij:=1 to 5 do}

    Summing[12]:=100000;
    for ij:=1 to 11 do
    begin
      if Summing[ij]<=Summing[12] then
      begin
        Summing[12]:=Summing[ij];
        SumResSq72:=Summing[ij];
        KK:=ij;
      end;
    end;

    if KK=1 then
    begin
      TmpNum:= 5*NumDat div 20;
      Expon72A:=ExponAA[1];
      Expon72B:=ExponBB[1];
      Slope72A:=SlopAA[1];
      Slope72B:=SlopBB[1];
      Inter72A:=inteAA[1];
      Inter72B:=InteBB[1];
    end;
    if KK=2 then
    begin
      TmpNum:= 3*NumDat div 10;
      Expon72A:=ExponAA[2];
      Expon72B:=ExponBB[2];
      Slope72A:=SlopAA[2];
      Slope72B:=SlopBB[2];
      Inter72A:=inteAA[2];
      Inter72B:=InteBB[2];
    end;
    if KK=3 then
    begin
      TmpNum:= 7*NumDat div 20;
      Expon72A:=ExponAA[3];
      Expon72B:=ExponBB[3];
      Slope72A:=SlopAA[3];
      Slope72B:=SlopBB[3];
      Inter72A:=inteAA[3];
      Inter72B:=InteBB[3];
    end;
    if KK=4 then
    begin
      TmpNum:= 4*NumDat div 10;
      Expon72A:=ExponAA[4];
      Expon72B:=ExponBB[4];
      Slope72A:=SlopAA[4];
      Slope72B:=SlopBB[4];
      Inter72A:=inteAA[4];
      Inter72B:=InteBB[4];
    end;
    if KK=5 then
    begin
      TmpNum:= 9*NumDat div 20;
      Expon72A:=ExponAA[5];
      Expon72B:=ExponBB[5];
      Slope72A:=SlopAA[5];
      Slope72B:=SlopBB[5];
      Inter72A:=inteAA[5];
      Inter72B:=InteBB[5];
    end;
    if KK=6 then
    begin
      TmpNum:= 5*NumDat div 10;
      Expon72A:=ExponAA[6];
      Expon72B:=ExponBB[6];
      Slope72A:=SlopAA[6];
      Slope72B:=SlopBB[6];
      Inter72A:=inteAA[6];
      Inter72B:=InteBB[6];
    end;
    if KK=7 then
    begin
      TmpNum:= 11*NumDat div 20;
      Expon72A:=ExponAA[7];
      Expon72B:=ExponBB[7];
      Slope72A:=SlopAA[7];
      Slope72B:=SlopBB[7];
      Inter72A:=inteAA[7];
      Inter72B:=InteBB[7];
    end;
    if KK=8 then
    begin
      TmpNum:= 6*NumDat div 10;
      Expon72A:=ExponAA[8];
      Expon72B:=ExponBB[8];
      Slope72A:=SlopAA[8];
      Slope72B:=SlopBB[8];
      Inter72A:=inteAA[8];
      Inter73B:=InteBB[8];
    end;
    if KK=9 then
    begin
      TmpNum:= 13*NumDat div 20;
      Expon72A:=ExponAA[9];
      Expon72B:=ExponBB[9];
      Slope72A:=SlopAA[9];
      Slope72B:=SlopBB[9];
      Inter72A:=inteAA[9];
      Inter72B:=InteBB[9];
    end;
    if KK=10 then
    begin
      TmpNum:= 7*NumDat div 10;
      Expon72A:=ExponAA[10];
      Expon72B:=ExponBB[10];
      Slope72A:=SlopAA[10];
      Slope72B:=SlopBB[10];
      Inter72A:=inteAA[10];
      Inter72B:=InteBB[10];
    end;
    if KK=11 then
    begin
      TmpNum:= 15*NumDat div 20;
      Expon72A:=ExponAA[11];
      Expon72B:=ExponBB[11];
      Slope72A:=SlopAA[11];
      Slope72B:=SlopBB[11];
      Inter72A:=inteAA[11];
      Inter72B:=InteBB[11];
    end;

    for ii:=1 to TmpNum do Mag[ii] := exp(Expon72A*ln(TmpMag[ii]));
    Regres2;
    Slope72A    := Slope;
    Inter72A    := FrqAv-Slope*MagAv;
    SumResSq72A := 0;
    ResiduAb    := 0;
    for ii:=1 to TmpNum do
    begin
        Power     := -Slope72A*Mag[ii] - Inter72A;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[ii] - FrqRg;
        ResiduAb  := ResiduAb + abs(Residu);
        ResiduSq  := Residu*Residu;
        SumResSq72A := SumResSq72A + ResiduSq;
     end;

    for ii:=TmpNum+1 to NumDat do Mag[ii] := exp(Expon72B*ln(TmpMag[ii]));
    Ratio2;
    Slope72B    := Slope;
    Inter72B    := 0;
    SumResSq72B := 0;
    for ii:=TmpNum+1 to Numdat do
    begin
        Power     := -Slope72B*Mag[ii] - Inter72B;
        if Power>8  then Power :=  8;
        if Power<-8 then Power := -8;
        FrqRg := 1 - exp(Power);
        Residu    := TmpFrq[ii] - FrqRg;
        ResiduAb  := ResiduAb + abs(Residu);
        ResiduSq  := Residu*Residu;
        SumResSq72B := SumResSq72B + ResiduSq;
    end;

    SumResSq72:=ResiduAb;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];                 {saving data values}
      Frq[ii] := TmpFrq[ii];                {saving frequency values}
    end;
    Bpoint72:=Mag[TmpNum];
    Number72:=TmpNum;
    if Key='1' then
    begin
      writeln(ListFile,' Composite generalized exponential distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    InterA:=Inter72A;                         {Composite generalized Poisson}
    InterB:=Inter72B;
    SlopeA:=Slope72A;
    SlopeB:=Slope72B;
    ExponA:=Expon72A;
    ExponB:=Expon72B;
    Number:=Number72;
    Bpoint:=Bpoint72;
    Method := 72;
    if Key='72' then exit;
    MainForm.WaitMemo.Lines.Add(' 72 done');

END; {IF DISCON THEN}

56:Method:=56;                             {Fisk}
    Regres1;                               {to find MagAv}
    LowSq:=1000000;
      for jj:=1 to 100 do
      begin
        Power:=0.1+jj*0.2;
        for kk:=1 to 50 do
        begin
          AuxR:= 0.3*MagAv+kk*0.01*MagAv;
          SumResSq56:=0;
          for ii:=1 to Numdat do
          begin
            FrqRg      := 1-1/(1+exp(Power*(ln(Mag[ii]/AuxR))));
            Residu     := Frq[ii] - FrqRg;
            ResiduSq   := Residu*Residu;
            SumResSq56 := SumResSq56 + ResiduSq;
          end;
          if SumResSq56<LowSq then
          begin
            LowSq:=SumResSq56;
            NN:=jj;
            KM:=kk;
          end;
        end;
      end;

    Slope:=0.1+NN*0.2;
    Slope56:=Slope;
    Inter:= 0.3*MagAv+KM*0.01*MagAv;
    SumResSq56:=0;
    ResiduAb:=0;
    for ii:=1 to Numdat do
    begin
      FrqRg      := 1-1/(1+exp(Slope*(ln(Mag[ii]/Inter))));
      Residu     := Frq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq56 := SumResSq56 + ResiduSq;
    end;
    SumResSq56 := SumResSq56 + 10;
    if Key='56' then exit;
    if Key='1' then
    begin
      writeln(ListFile,' Fisk distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;


57: Method := 57;                           {Weibull}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      Mag[ii]:=ln(Mag[ii]);                 {transforming data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(1-Frq[ii]));        {transforming frequencies}
    end;
    Regres1;
    SumResSq57 := 0;
    Slope57    := Slope;
    Inter57    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Power      := exp(-Inter57/Slope);          {labda}
      Power      := Slope*ln(TmpMag[ii]/Power);   {k ln(x/labda) = ln(-ln(1-F)}
      Power      := exp(Power);                   {-ln(1-F)}
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := 1-exp(-Power);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq57 := SumResSq57 + ResiduSq;
    end;
    SumResSq57:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 57 done');
    if Key='1' then
    begin
      writeln(ListFile,' Weibull distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
    end;
    Slope:=Slope57;
    Inter:=Inter57;
    if Key='57' then exit;

58: Method := 58;                           {Frechet, Fisher-Tippett type II}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(Frq[ii]));          {transforming frequencies}
    end;
    LowSq:=1000000;
    KM:=10000;
    for jj:=1 to 10000 do
    begin
      SumResSq58 := 0;
      Bound58:=TmpMag[1]-0.01*(TmpMag[NumDat]-TmpMag[1])*jj;
      for ii:=1 to Numdat do
      begin
        if (TmpMag[ii]-Bound58)<=0 then Bound58:=TmpMag[ii]-0.001;
        Mag[ii] := ln(TmpMag[ii]-Bound58)
      end;
      Regres1;
      Slope58    := Slope;
      Inter58    := FrqAv-Slope*MagAv;
      for ii:=1 to Numdat do
      begin
        Power      := (TmpMag[ii]-Bound58)/Exp(-Inter58/Slope58);
        Power      := exp(Slope58*ln(Power));
        FrqRg      := exp(-Power);
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq58 := SumResSq58 + ResiduSq;
      end;
      if SumResSq58<LowSq then
      begin
         LowSq:=SumResSq58;
         KM:=jj;
      end else goto 86;
    end;
86: Bound58:=TmpMag[1]-0.01*(TmpMag[NumDat]-TmpMag[1])*KM;
    SumResSq58 := 0;
    for ii:=1 to Numdat do
    begin
      if (TmpMag[ii]-Bound58)<=0 then Bound58:=TmpMag[ii]-0.001;
      Mag[ii] := ln(TmpMag[ii]-Bound58);
    end;
    Regres1;
    Slope58    := Slope;
    Inter58    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to Numdat do
    begin
      Power      := (TmpMag[ii]-Bound58)/Exp(-Inter58/Slope58);
      Power      := exp(Slope58*ln(Power));
      FrqRg      := exp(-Power);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq58 := SumResSq58 + ResiduSq;
    end;
    SumResSq58:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Frechet (Fisher-Tippet Type 2) distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];              {resetting original data values}
      Frq[ii] := TmpFrq[ii];
    end;
    if Key='58' then                 {Fisher-Tippet Type 2, Frechet, preferred}
    begin
      Slope:=Slope58;
      Inter:=Inter58;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 58 done');

95: Method := 35;                       {Frechet, Fisher-Tippett type II mirr.}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(1-Frq[ii]));          {transforming frequencies}
    end;
    LowSq:=1000000;
    KM:=10000;
    for jj:=1 to 10000 do
    begin
      Bound35:=TmpMag[1]-0.01*(TmpMag[NumDat]-TmpMag[1])*jj;
      for ii:=1 to Numdat do
      begin
        if (TmpMag[ii]-Bound35)<=0 then Bound35:=TmpMag[ii]-0.001;
        Mag[ii] := ln(TmpMag[ii]-Bound35)
      end;
      Regres1;
      Slope35    := Slope;
      Inter35    := FrqAv-Slope*MagAv;
      SumResSq35 := 0;
      for ii:=1 to Numdat do
      begin
        Power      := (TmpMag[ii]-Bound35)/Exp(-Inter35/Slope35);
        Power      := exp(Slope35*ln(Power));
        FrqRg      := 1-exp(-Power);
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq35 := SumResSq35 + ResiduSq;
      end;
      if SumResSq35<LowSq then
      begin
         LowSq:=SumResSq35;
         KM:=jj;
      end else goto 75;
    end;
75: Bound35:=TmpMag[1]-0.01*(TmpMag[NumDat]-TmpMag[1])*KM;
    for ii:=1 to Numdat do
    begin
      if (TmpMag[ii]-Bound35)<=0 then Bound35:=TmpMag[ii]-0.001;
      Mag[ii] := ln(TmpMag[ii]-Bound35);
    end;
    Regres1;
    Slope35    := Slope;
    Inter35    := FrqAv-Slope*MagAv;
    SumResSq35 := 0;
    ResiduAb   := 0;
    for ii:=1 to Numdat do
    begin
      Power      := (TmpMag[ii]-Bound35)/Exp(-Inter35/Slope35);
      Power      := exp(Slope35*ln(Power));
      FrqRg      := 1-exp(-Power);
      Frq[ii]    := FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq35 := SumResSq35 + ResiduSq;
    end;
    SumResSq35:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Frechet (Fisher-Tippet Type 2) mirrored');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];              {resetting original data values}
      Frq[ii] := TmpFrq[ii];
    end;
    if Key='35' then                 {Fisher-Tippet Type 2, Frechet, preferred}
    begin
      Slope:=Slope35;
      Inter:=Inter35;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 59 done');

93: Method := 33;                           {Fisher-Tippett type 3 mirr.}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(1-Frq[ii]));          {transforming frequencies}
    end;
    LowSq:=1000000;
    KM:=100;
    for jj:=1 to 100000 do
    begin
      Bound33:=TmpMag[NumDat]+0.01*(TmpMag[NumDat]-TmpMag[1])*jj;
      for ii:=1 to Numdat do
      begin
        if (Bound33-TmpMag[ii])<=0 then Bound33:=TmpMag[ii]+0.001;
        Mag[ii] := ln(Bound33-TmpMag[ii]);
      end;
      Regres1;
      Slope33    := Slope;
      Inter33    := FrqAv-Slope*MagAv;
      SumResSq33 := 0;
      for ii:=1 to Numdat do
      begin
        Power      := (Bound33-TmpMag[ii])/Exp(-Inter33/Slope33);
        Power      := exp(Slope33*ln(Power));
        FrqRg      := 1-exp(-Power);
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq33 := SumResSq33 + ResiduSq;
      end;
      if SumResSq33<LowSq then
      begin
         LowSq:=SumResSq33;
         KM:=jj;
      end else goto 94;
    end;
94: Bound33:=TmpMag[NumDat]+0.01*(TmpMag[NumDat]-TmpMag[1])*KM;
    for ii:=1 to Numdat do
    begin
      if (Bound33-TmpMag[ii])<=0 then Bound33:=TmpMag[ii]+0.001;
      Mag[ii] := ln(Bound33-TmpMag[ii]);
    end;
    Regres1;
    Slope33    := Slope;
    Inter33    := FrqAv-Slope*MagAv;
    SumResSq33 := 0;
    ResiduAb   := 0;
    for ii:=1 to Numdat do
    begin
      Power      := (Bound33-TmpMag[ii])/Exp(-Inter33/Slope33);
      Power      := exp(Slope33*ln(Power));
      FrqRg      := 1-exp(-Power);
      Frq[ii]    := FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq33 := SumResSq33 + ResiduSq;
    end;
    SumResSq33:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Fisher-Tippett type 3 mirrorered');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];
    end;
    if Key='33' then                 {Fisher-Tippett type 3 mirr. preferred}
    begin
      Slope:=Slope33;
      Inter:=Inter33;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 33 done');

59: Method := 59;                           {Fisher-Tippett type 3}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(Frq[ii]));          {transforming frequencies}
    end;
    LowSq:=1000000;
    KM:=100;
    for jj:=1 to 100000 do
    begin
      Bound59:=TmpMag[NumDat]+0.01*(TmpMag[NumDat]-TmpMag[1])*jj;
      for ii:=1 to Numdat do
      begin
        if (Bound59-TmpMag[ii])<=0 then Bound59:=TmpMag[ii]+0.001;
        Mag[ii] := ln(Bound59-TmpMag[ii]);
      end;
      Regres1;
      Slope59    := Slope;
      Inter59    := FrqAv-Slope*MagAv;
      SumResSq59 := 0;
      for ii:=1 to Numdat do
      begin
        Power      := (Bound59-TmpMag[ii])/Exp(-Inter59/Slope59);
        Power      := exp(Slope59*ln(Power));
        FrqRg      := exp(-Power);
        Residu     := TmpFrq[ii] - FrqRg;
        ResiduSq   := Residu*Residu;
        SumResSq59 := SumResSq59 + ResiduSq;
      end;
      if SumResSq59<LowSq then
      begin
         LowSq:=SumResSq59;
         KM:=jj;
      end else goto 87;
    end;
87: Bound59:=TmpMag[NumDat]+0.01*(TmpMag[NumDat]-TmpMag[1])*KM;
    for ii:=1 to Numdat do
    begin
      if (Bound59-TmpMag[ii])<=0 then Bound59:=TmpMag[ii]+0.001;
      Mag[ii] := ln(Bound59-TmpMag[ii]);
    end;
    Regres1;
    Slope59    := Slope;
    Inter59    := FrqAv-Slope*MagAv;
    SumResSq59 := 0;
    ResiduAb   := 0;
    for ii:=1 to Numdat do
    begin
      Power      := (Bound59-TmpMag[ii])/Exp(-Inter59/Slope59);
      Power      := exp(Slope59*ln(Power));
      FrqRg      := exp(-Power);
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq59 := SumResSq59 + ResiduSq;
    end;
    SumResSq59:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' progressing ...');
    if Key='1' then
    begin
      writeln(ListFile,' Fisher-Tippett type 3 distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];
    end;
      Slope:=Slope59;
      Inter:=Inter59;
      if Key='59' then exit;

96: Method := 60;                           {Weibull mirrorred}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii]:= Mag[ii];                 {saving data values}
      if Mag[ii]<=0 then Mag[ii]:=0.001;
      Mag[ii]:=ln(Mag[ii]);                 {transforming data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      if Frq[ii]>=1 then frq[ii]:=0.999;
      if Frq[ii]<=0 then Frq[ii]:=0.001;
      Frq[ii] := ln(-ln(Frq[ii]));          {transforming frequencies}
    end;
    Regres1;
    SumResSq60 := 0;
    Slope60    := Slope;
    Inter60    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Power      := exp(-Inter60/Slope);          {labda}
      Power      := Slope*ln(TmpMag[ii]/Power);   {k ln(x/labda) = ln(-ln(1-F)}
      Power      := exp(Power);                   {-ln(F)}
      if Power>8  then Power :=  8;
      if Power<-8 then Power := -8;
      FrqRg      := exp(-Power);
      Frq[ii]    := FrqRg;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq60 := SumResSq60 + ResiduSq;
    end;
    SumResSq60:=ResiduAb;
    if Key='1' then
    begin
      writeln(ListFile,' Mirrorred Weibull distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
    end;
    if Key='60' then                       {Weibull mirr. preferred}
    begin
      Slope:=Slope60;
      Inter:=Inter60;
      exit;
    end;
    MainForm.WaitMemo.Lines.Add(' 60 done');

61: Method := 61;                           {Erlang}
    begin
    setlength (ValAv, NumDat+1);
      MinResidu:=100000;
      for kk:=1 to 20 do
      begin
        for jj:=1 to 500  do
        begin
          Slope:=0.1*jj;
          SumResSq61:=0;
          for ii:=1 to Numdat do
          begin
            Power:=0;
            for mm:=0 to kk-1 do
            begin
              if mm=0 then Nfact:=1
              else Nfact:= Nfact * mm;
              if Mag[ii]<=0 then Mag[ii]:=0.001;
              Power:=Power +
                   (1/Nfact)*(exp(-Mag[ii]/Slope)*exp(mm*(ln(Mag[ii]/Slope))));
            end;
            FrqRg      := 1-Power;
            Residu     := Frq[ii] - FrqRg;
            ResiduSq   := Residu*Residu;
            SumResSq61 := SumResSq61 + ResiduSq;
          end;
          if SumResSq61<MinResidu then
          begin
            MinResidu:=SumResSq61;
            Slope61:=0.1*jj;
            Inter61:=kk;
          end;
        end; {for jj=1 to 500}
     end;{for kk:=1 to 20 do}

     SumResSq61:=0;
     ResiduAb:=0;
     for ii:=1 to Numdat do
     begin
       km:=round(Inter61);
       Power:=0;
       for mm:=0 to Km-1 do
       begin
         if mm=0 then Nfact:=1
         else Nfact:= Nfact * mm;
         Power:=Power +
             (1/Nfact)*(exp(-Mag[ii]/Slope61)*exp(mm*(ln(Mag[ii]/Slope61))));
       end;
       FrqRg      := 1-Power;
       ValAv[ii]  := FrqRg;
       Residu     := Frq[ii] - FrqRg;
       ResiduAb   := ResiduAb + abs(Residu);
       ResiduSq   := Residu*Residu;
       SumResSq61 := SumResSq61 + ResiduSq;
     end;
     SumResSq61:=ResiduAb;

     MainForm.WaitMemo.Lines.Add(' Advancing ...');
     if Key='1' then
     begin
       writeln(ListFile,' Gamma (Erlang) distribution');
       writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
       writeln (ListFile);
      end;

     if Key='61' then exit;                     {Erlang preferred}

    end; {Method := 61;}

//Method := 62;                             {Student's t-distr with 1 d.f.}
62: Regres1;
    StErrS:=StErr;
    MagAvS:=MagAv;
    for ii:=1 to NumDat do
        TmpFrq[ii] := Frq[ii];                        {saving frequency values}
    SumResSq62 := 0;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Frq[ii] := 0.5+arctan((Mag[ii]-MagAv)/StErr)/pi;
      Residu  := TmpFrq[ii] - Frq[ii];
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq62 := SumResSq62 + ResiduSq;
    end;

//    Method := 63;                             {Student's t-distr with 2 d.f.}
    SumResSq63 := 0;
    SumResSq64 := 0;
    for ii:=1 to NumDat do
    begin
      Power:= sqrt(2+sqr((Mag[ii]-MagAv)/StErr));
      Power:= ((Mag[ii]-MagAv)/StErr)/Power;
      Frq[ii]:=0.5*(1+Power);
      Residu  := TmpFrq[ii] - Frq[ii];
      SumResSq64 := SumResSq64 + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq63 := SumResSq63 + ResiduSq;
    end;
    Method:=62;
    if SumResSq63<SumResSq62 then Method:=63;
    SumResSq62:=ResiduAb;
    if Method=63 then ResiduAb:=SumResSq64;
    if SumResSq63<SumResSq62 then Method:=63;
    if Method=63 then SumResSq63:=ResiduAb;
    if (Key='1') and (Method=62) then
    begin
      writeln(ListFile,' Student distribution with 1 d.f.');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if (Key='1') and (Method=63) then
    begin
      writeln(ListFile,' Student distribution with 2 d.f.');
      writeln(ListFile,' Average = ',100*SumResSq64/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
        Frq[ii] := TmpFrq[ii];         {resetting original freq values}

    if Key='62' then exit;                     {Student preferred}
    MainForm.WaitMemo.Lines.Add(' 62 done');

64: Method := 64;                           {Cauchy}
    for ii:=1 to NumDat do
    begin
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := tan(pi*(Frq[ii]-0.5));        {transforming frequencies}
    end;
    Regres1;
    SumResSq64 := 0;
    Slope64    := Slope;
    Inter64    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope64*Mag[ii]+Inter64;
      FrqRg      := (1/pi)*arctan(Power)+0.5;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq64 := SumResSq64 + ResiduSq;
    end;
    SumResSq64:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 64 done');
    if Key='1' then
    begin
      writeln(ListFile,' Cauchy distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    for ii:=1 to NumDat do
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
      Slope:=Slope64;
      Inter:=Inter64;
      if Key='64' then exit;

65: Method := 65;                           {Cauchy generalized}
    for ii:=1 to NumDat do
    begin
      TmpMag[ii] := Mag[ii];                {saving data values}
      TmpFrq[ii] := Frq[ii];                {saving frequency values}
      Frq[ii] := tan(pi*(Frq[ii]-0.5));        {transforming frequencies}
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      Step:=Step+0.01;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));   {X^Step}
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      Slope65    := Slope;
      Inter65    := FrqAv-Slope*MagAv;
      SumResSq65 := 0;
      for ii:=1 to Numdat do
      begin
        Power      := Slope65*Mag[ii]+Inter65;
        FrqRg      := (1/pi)*arctan(Power)+0.5;
        Residu     := TmpFrq[ii] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq   := Residu*Residu;
        SumResSq65 := SumResSq65 + ResiduSq;
      end;
      Summation[mm] := SumResSq65;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    Expon65:=0.01*KM+0.19;
    if (Expon65<0.21) or (Expon65>2.98) then Expon65:=1;
    if (Expon65>0.95) and (Expon65<1.05) then Expon65:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon65*ln(TmpMag[ii]));
    Regres1;
    SumResSq65 := 0;
    Slope65    := Slope;
    Inter65    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for ii:=1 to NumDat do
    begin
      Power      := Slope65*Mag[ii]+Inter65;
      FrqRg      := (1/pi)*arctan(Power)+0.5;
      Residu     := TmpFrq[ii] - FrqRg;
      ResiduAb   := ResiduAb + abs(Residu);
      ResiduSq   := Residu*Residu;
      SumResSq65 := SumResSq65 + ResiduSq;
    end;
    SumResSq65:=ResiduAb;
    if (Key='1') and (Expon65<>1) then
    begin
      writeln(ListFile,' Generalized Cauchy distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if (Key='1') and (Expon65=1) then
       SumResSq65:=1000;
    for ii:=1 to NumDat do
    begin
      Mag[ii] := TmpMag[ii];         {resetting original data values}
      Frq[ii] := TmpFrq[ii];         {resetting original freq values}
    end;
    Slope:=Slope65;
    Inter:=Inter65;
    if Key='65' then exit;
    MainForm.WaitMemo.Lines.Add(' 65 done');

66: Method := 66;             {a-symptotic exponential, Poisson type, mirrored}
    for kk:=1 to NumDat do
    begin
      TmpMag[kk] := Mag[kk];
      TmpFrq[kk] := Frq[kk];
      if Frq[kk]<=0 then Frq[kk]:=0.001;
      Frq[kk] := -ln(Frq[kk]);
    end;
    Step:=0.19;
    for mm:=1 to 280 do
    begin
      SumResSq66 := 0;
      Step:=Step+0.01;
      for ii:=1 to NumDat do Mag[ii] := exp(Step*ln(TmpMag[ii]));
      RegRes1;                   {Gives MagAv and StErr of transferred data}
      Slope66    := Slope;
      Inter66    := FrqAv-Slope*MagAv;
      for kk:=1 to NumDat do
      begin
        Power     := -Slope66*Mag[kk] - Inter66;
        if Power<8 then FrqRg := exp(Power) else  FrqRg   := 8;
        Residu    := TmpFrq[kk] - FrqRg;
        if abs(Residu)>1 then Residu:=1;
        ResiduSq  := Residu*Residu;
        SumResSq66 := SumResSq66 + ResiduSq;
      end;
      Summation[mm] := SumResSq66;
    end;
    MinResidu:=1000000;
    for jj:=2 to 280 do
      if Summation[jj]<MinResidu then
      begin
        MinResidu:=Summation[jj];
        KM:=jj;
      end;
    SumResSq66 := 0;
    Expon66:=0.01*KM+0.19;
    if (Expon66<0.21) or (Expon66>2.98) then Expon66:=1;
    if (Expon66>0.95) and (Expon66<1.05) then Expon66:=1;
    for ii:=1 to NumDat do Mag[ii] := exp(Expon66*ln(TmpMag[ii]));
    Regres1;
    Slope66    := Slope;
    Inter66    := FrqAv-Slope*MagAv;
    ResiduAb   := 0;
    for kk:=1 to NumDat do
    begin
      Frq[kk]   := TmpFrq[kk];                   {reset original frequency}
      Power     := -Slope66*Mag[kk] - Inter66;
      Mag[kk]   := TmpMag[kk];                   {reset original magnitude}
      if Power<8 then FrqRg := exp(Power) else  FrqRg   := 8;
      if FrqRg<0 then FrqRg:=0.001;
      if FrqRg>0.999 then FrqRg:=0.999;
      Residu    := Frq[kk] - FrqRg;
      ResiduAb  := ResiduAb + abs(Residu);
      ResiduSq  := Residu*Residu;
      SumResSq66 := SumResSq66 + ResiduSq;
    end;
    SumResSq66:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 66 done');
    if (Key='1') and (Expon66<>1) then
    begin
      writeln(ListFile,' Mirrored exponential (Poisson) distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    Slope:=Slope66;
    Inter:=Inter66;
    if Key='66' then exit;

67: Method := 67;                                      {GEV}
    mm:=0;
    for ii:=1 to NumDat do
        if (mm=0) and (Frq[ii]>0.37) then mm:=ii;
    MagAv67:=Mag[mm-1]+(Mag[mm]-Mag[mm-1])*(0.37-Frq[mm-1])/(Frq[mm]-Frq[mm-1]);
    MinResidu:=1000000;
    Regres1;                            {for StErr of X}
    for mm:=1 to 200 do
    BEGIN
      Step:=-1 + mm*0.01;
        For kk:=1 to 140 do
        BEGIN
          BB:=0.3*StErr+kk*0.01*StErr;
          SumResSq67 := 0;
          for ii:=1 to NumDat do if Step<>0 then
          begin
            Power := Step*(Mag[ii]-MagAv67)/BB;
            if (1+Power)>0 then
               Power:=(-1/Step)*ln(1+Power)
            else
            begin
              Power:=0;
              SumResSq67:=1000;
            end;
            Power      := exp(Power);
            FrqRg      := exp(-Power);
           if abs(Residu)>1 then Residu:=1;
            Residu     := Frq[ii] - FrqRg;
            ResiduSq   := Residu*Residu;
            SumResSq67 := SumResSq67 + ResiduSq;
          end; {for ii:=1 to NumDat do if Step<>0 then}
          if SumResSq67=0 then SumResSq67:=1000;
          if SumResSq67<MinResidu then
          begin
            MinResidu:=SumResSq67;
            IJ:=mm;
            KM:=kk;
          end;
        END; {For kk:=1 to 99 do}
      if mm=100 then MainForm.WaitMemo.Lines.Add (' This takes time ..');
      if NumDat>500 then if mm=160 then
         MainForm.WaitMemo.Lines.Add (' Please wait ......');
    END; {for mm:=1 to 199 do}

    Expon67:=-1+IJ*0.01;
    StErr67:=0.3*StErr+KM*0.01*StErr;
    Bound67:=MagAv67-StErr67/Expon67;
    Bounded:=false;

    for ii:=1 to NumDat do
    begin
      if (Expon67<0) and (Mag[ii]>=0.999*Bound67) then  Bounded:=true;
      if (Expon67>0) and (Mag[ii]<=1.001*Bound67) then  Bounded:=true;
    end;

    if Bounded then
    begin
      if Expon67<0 then Expon67:=-StErr67/(0.999*Bound67-MagAv67);
      if Expon67>0 then Expon67:=-StErr67/(1.001*Bound67-MagAv67);
    end;

    ResiduAb  := 0;
    for ii:=1 to NumDat do
    begin
      Power := Expon67*(Mag[ii]-MagAv67)/StErr67;
      if (1+Power)>0 then
         Power:=(-1/Expon67)*ln(1+Power)
      else
         Power:=0;
      Power:=exp(Power);
      FrqRg := exp(-(Power));
      Residu := Frq[ii] - FrqRg;
      ResiduAb := ResiduAb + abs(Residu);
    end;
    SumResSq67:=ResiduAb;
    MainForm.WaitMemo.Lines.Add(' 67 done');
    if Key='1' then
    begin
      writeln(ListFile,' GEV distribution');
      writeln(ListFile,' Average = ',100*ResiduAb/NumDat:6:4);
      writeln (ListFile);
    end;
    if Key='67' then exit;                              {GEV preferred}

    Method:=20;                              {Normal distribution usual}
    NormDistr;
    Method:=21;                              {Normal distribution optimized}
    NormDistr;
    Method:=22;                              {Log-Normal distribution simple}
    NormDistr;
    MainForm.WaitMemo.Lines.Add(' Still working ......');
    Method:=23;                              {Log-Normal distribution optimized}
    NormDistr;
    if NumDat>500 then MainForm.WaitMemo.Lines.Add(' Progressing ......');
    Method:=24;                              {Root Normal distribution}
    NormDistr;
    Method:=25;                              {Square Normal distribution}
    NormDistr;
    MainForm.WaitMemo.Lines.Add(' Iterations ....');
    Method:=26;                              {Gen. Normal distribution}
    NormDistr;

    if (NumDat>200) and (Key='1') then
    begin
      if Progress then
      begin
        MainForm.WaitMemo.Lines.Add(' Continuing .....');
        Progress:=false;
      end;
    end;

//Start of method selection, best of all

    LowSq  := SumResSq20;                         {Normal usual}
    Method := 20;
    StDev  := StDev0;

    if SumResSq21<Lowsq then
    begin                                         {Normal optimized}
      LowSq  := SumResSq21;
      Method := 21;
    end;

    if SumResSq22<LowSq then
    begin                                         {Log-normal simple}
      LowSq  := SumResSq22;
      Method := 22;
    end;

    if SumResSq23<LowSq then
    begin                                         {Log-normal optimized}
      LowSq  := SumResSq23;
      Method := 23;
    end;

    if SumResSq24<LowSq then
    begin                                          {Root-normal}
      LowSq  := SumResSq24;
      Method := 24;
    end;

    if SumResSq25<LowSq then
    begin                                          {Square-normal}
      LowSq  := SumResSq25;
      Method := 22;
    end;

    if SumResSq26<LowSq then
    begin                                          {Generalized normal}
      LowSq  := SumResSq26;
      Method := 26;
    end;

    if SumResSq3<LowSq then
    begin                                   { generalized exponential, Poisson}
      LowSq  := SumResSq3;
      Slope  := Slope3;
      Inter  := Inter3;
      Method := 3;
    end;

    if SumResSq4<LowSq then
    begin                                                 {Gumbel}
      LowSq  := SumResSq4;
      Slope  := Slope4;
      Inter  := Inter4;
      Method := 4;
    end;

    if SumResSq5<LowSq then                                  {Gumbel mirrorred}
    begin
      LowSq  := SumResSq5;
      Slope  := Slope5;
      Inter  := Inter5;
      Method := 5;
    end;

    if SumResSq6<LowSq then                                  {exponential}
    begin
      LowSq  := SumResSq6;
      Slope  := Slope6;
      Method := 6;
    end;

    if SumResSq31<LowSq then                               {Burr}
    begin
      LowSq  := SumResSq31;
      Slope  := Slope31;
      Inter  := Inter31;
      Method := 31;
    end;

    if SumResSq32<LowSq then                               {Dagum}
    begin
      LowSq  := SumResSq32;
      Slope  := Slope32;
      Inter  := Inter32;
      Method := 32;
    end;

    if SumResSq34<LowSq then                               {Gompertz}
    begin
      LowSq  := SumResSq34;
      Method := 34;
    end;

    if SumResSq36<LowSq then                               {Kumaraswamy}
    begin
      LowSq  := SumResSq36;
      Method := 36;
    end;

    if SumResSq51<LowSq then                               {generalized Gumbel}
    begin
      LowSq  := SumResSq51;
      Slope  := Slope51;
      Inter  := Inter51;
      Method := 51;
    end;

    if SumResSq52<LowSq then                      {generalized Gumbel mirrored}
    begin
      LowSq  := SumResSq52;
      Slope  := Slope52;
      Inter  := Inter52;
      Method := 52;
    end;

    if SumResSq53<LowSq then                                         {logistic}
    begin
      LowSq  := SumResSq53;
      Slope  := Slope53;
      Inter  := Inter53;
      Method := 53;
    end;

    if SumResSq54<LowSq then                                     {log-logistic}
    begin
      LowSq  := SumResSq54;
      Slope  := Slope54;
      Inter  := Inter54;
      Method := 54;
    end;

    if SumResSq55<LowSq then                             {generalized logistic}
    begin
      LowSq  := SumResSq55;
      Slope  := Slope55;
      Inter  := Inter55;
      Method := 55;
    end;

    if SumResSq56<LowSq then                                    {Fisk}
    begin
      LowSq  := SumResSq56;
      Slope  := Slope56;
      Inter  := Inter56;
      Method := 56;
    end;

    if SumResSq57<LowSq then                                     {Weibull}
    begin
      LowSq  := SumResSq57;
      Slope  := Slope57;
      Inter  := Inter57;
      Method := 57;
    end;

    if SumResSq58<LowSq then                              {Frechet, F-T type 2}
    begin
      LowSq  := SumResSq58;
      Slope  := Slope58;
      Inter  := Inter58;
      Method := 58;
    end;

    if SumResSq33<LowSq then                       {Fisher-Tippett type 3 mirr.}
    begin
      LowSq  := SumResSq33;
      Slope  := Slope33;
      Inter  := Inter33;
      Method := 33;
    end;

    if SumResSq35<LowSq then                        {Frechet, F-T type 2 mirr.}
    begin
      LowSq  := SumResSq35;
      Slope  := Slope35;
      Inter  := Inter35;
      Method := 35;
    end;

    if SumResSq59<LowSq then                            {Fisher-Tippett type 3}
    begin
      LowSq  := SumResSq59;
      Slope  := Slope59;
      Inter  := Inter59;
      Method := 59;
    end;

    if SumResSq60<LowSq then                               {Weibull mirr.}
    begin
      LowSq  := SumResSq60;
      Slope  := Slope60;
      Inter  := Inter60;
      Method := 60;
    end;

    if SumResSq62<LowSq then                            {Student's with 1 d.f.}
    begin
      LowSq  := SumResSq62;
      StErr  := StErrS;
      MagAv  := MagAvS;
      Method := 62;
    end;

    if SumResSq63<LowSq then                            {Student's with 2 d.f.}
    begin
      LowSq  := SumResSq63;
      StErr  := StErrS;
      MagAv  := MagAvS;
      Method := 63;
    end;

    if SumResSq64<LowSq then                            {Cauchy}
    begin
      LowSq  := SumResSq64;
      Slope  := Slope64;
      Inter  := Inter64;
      Method := 64;
    end;

    if SumResSq65<LowSq then                            {Cauchy general}
    begin
      LowSq  := SumResSq65;
      Slope  := Slope65;
      Inter  := Inter65;
      Method := 65;
    end;

    if SumResSq66<LowSq then                     {Generalized expon. mirrored}
    begin
      LowSq  := SumResSq66;
      Slope  := Slope66;
      Inter  := Inter66;
      Method := 66;
    end;

    if SumResSq67<LowSq then                     {GEV}
    begin
      LowSq  := SumResSq67;
      Method := 67;
    end;

    if SumResSq68<LowSq then                     {Laplace}
    begin
      LowSq  := SumResSq68;
      Method := 68;
    end;

    if SumResSq69<LowSq then                      {Rayleigh}
    begin
      LowSq  := SumResSq69;
      Method := 69;
    end;

    if SumResSq73<LowSq then                     {Laplace gen}
    begin
      LowSq  := SumResSq73;
      Method := 73;
    end;

IF DISCON THEN
BEGIN

    LowSqCont:={0.9*}LowSq;
{Discontinuous distributions must have less than 80% of the SumOfDevSq of the
 continuous distributions to be eleligible}
    MethCont := Method;               {Method for the continuous distributions}
                                            {Disontinuous distribtions 7 to 18}
    if (SumResSq7<LowSq) and (SumResSq7<LowSqCont) then
    if (Number7>5) and (Number7<NumDat-5) then
    begin
      LowSq   := SumResSq7;
      SlopeA  := Slope7A;
      SlopeB  := Slope7B;
      InterA  := Inter7A;
      InterB  := Inter7B;
      Number  := Number7;
      Bpoint  := Bpoint7;
      Method  := 7;
    end;

    if (SumResSq8<LowSq) and (SumResSq8<LowSqCont) then
    if (Number8>5) and (Number8<NumDat-5) then
    begin
      LowSq   := SumResSq8;
      SlopeA  := Slope8A;
      SlopeB  := Slope8B;
      InterA  := Inter8A;
      InterB  := Inter8B;
      Number  := Number8;
      Bpoint  := Bpoint8;
      Method  := 8;
    end;

    if (SumResSq9<LowSq) and (SumResSq9<LowSqCont) then
    if (Number9>5) and (Number9<NumDat-5) then
    begin
      LowSq   := SumResSq9;
      SlopeA  := Slope9A;
      SlopeB  := Slope9B;
      InterA  := Inter9A;
      InterB  := Inter9B;
      Number  := Number9;
      Bpoint  := Bpoint9;
      Method  := 9;
    end;

    if (SumResSq10<LowSq) and (SumResSq10<LowSqCont) then
    if (Number10>5) and (Number10<NumDat-5) then
    begin
      LowSq   := SumResSq10;
      SlopeA  := Slope10A;
      SlopeB  := Slope10B;
      InterA  := Inter10A;
      InterB  := Inter10B;
      Number  := Number10;
      Bpoint  := Bpoint10;
      Method  := 10;
    end;

    if (SumResSq11<LowSq) and (SumResSq11<LowSqCont) then
    if (Number11>5) and (Number11<NumDat-5) then
    begin
      LowSq   := SumResSq11;
      SlopeA  := Slope11A;
      SlopeB  := Slope11B;
      InterA  := Inter11A;
      InterB  := Inter11B;
      Number  := Number11;
      Bpoint  := Bpoint11;
      Method  := 11;
    end;

    if (SumResSq12<LowSq) and (SumResSq12<LowSqCont) then
    if (Number12>5) and (Number12<NumDat-5) then
    begin
      LowSq   := SumResSq12;
      SlopeA  := Slope12A;
      SlopeB  := Slope12B;
      InterA  := Inter12A;
      InterB  := Inter12B;
      Number  := Number12;
      Bpoint  := Bpoint12;
      Method  := 12;
    end;

    if (SumResSq13<LowSq) and (SumResSq13<LowSqCont) then
    if (Number13>5) and (Number13<NumDat-5) then
    begin
      LowSq   := SumResSq13;
      SlopeA  := Slope13A;
      SlopeB  := Slope13B;
      InterA  := Inter13A;
      InterB  := Inter13B;
      Number  := Number13;
      Bpoint  := Bpoint13;
      Method  := 13;
    end;

    if (SumResSq14<LowSq) and (SumResSq14<LowSqCont) then
    if (Number14>5) and (Number14<NumDat-5) then
    begin
      LowSq   := SumResSq14;
      SlopeA  := Slope14A;
      SlopeB  := Slope14B;
      InterA  := Inter14A;
      InterB  := Inter14B;
      Number  := Number14;
      Bpoint  := Bpoint14;
      Method  := 15;
    end;

    if (SumResSq15<LowSq) and (SumResSq15<LowSqCont) then
    if (Number15>5) and (Number15<NumDat-5) then
    begin
      LowSq   := SumResSq15;
      SlopeA  := Slope15A;
      SlopeB  := Slope15B;
      InterA  := Inter15A;
      InterB  := Inter15B;
      Number  := Number15;
      Bpoint  := Bpoint15;
      Method  := 15;
    end;

    if (SumResSq16<LowSq) and (SumResSq16<LowSqCont) then
    if (Number16>5) and (Number16<NumDat-5) then
    begin
      LowSq   := SumResSq16;
      SlopeA  := Slope16A;
      SlopeB  := Slope16B;
      InterA  := Inter16A;
      InterB  := Inter16B;
      Number  := Number16;
      Bpoint  := Bpoint16;
      Method  := 16;
    end;

    if (SumResSq17<LowSq) and (SumResSq17<LowSqCont) then
    if (Number17>5) and (Number17<NumDat-5) then
    begin
      LowSq   := SumResSq17;
      SlopeA  := Slope17A;
      SlopeB  := Slope17B;
      InterA  := Inter17A;
      InterB  := Inter17B;
      Number  := Number17;
      Bpoint  := Bpoint17;
      Method  := 17;
    end;

    if (SumResSq18<LowSq) and (SumResSq18<LowSqCont) then
    if (Number18>5) and (Number18<NumDat-5) then
    begin
      SlopeA  := Slope18A;
      SlopeB  := Slope18B;
      InterA  := Inter18A;
      InterB  := Inter18B;
      Number  := Number18;
      Bpoint  := Bpoint18;
      Method  := 18;
    end;

    if (SumResSq70<LowSq) and (SumResSq70<LowSqCont) then
    if (Number70>4) and (Number70<NumDat-5) then
    begin
      InterA:=Inter70A;                        {Composite generalized logistic}
      InterB:=Inter70B;
      SlopeA:=Slope70A;
      SlopeB:=Slope70B;
      ExponA:=Expon70A;
      ExponB:=Expon70B;
      Number:=Number70;
      Bpoint:=Bpoint70;
      LowSq:=SumResSq70;
      Method := 70;
    end;

    if (SumResSq71<LowSq) and (SumResSq71<LowSqCont) then
    if (Number71>5) and (Number71<NumDat-5) then
    begin
      InterA:=Inter71A;                           {Composite generalized Gumbel}
      InterB:=Inter71B;
      SlopeA:=Slope71A;
      SlopeB:=Slope71B;
      ExponA:=Expon71A;
      ExponB:=Expon71B;
      Number:=Number71;
      Bpoint:=Bpoint71;
      LowSq:=SumResSq71;
      Method := 71;
    end;

    if (SumResSq72<LowSq) and (SumResSq72<LowSqCont) then
    if (Number72>5) and (Number72<NumDat-5) then
    begin
      InterA:=Inter72A;                         {Composite generalized Poisson}
      InterB:=Inter72B;
      SlopeA:=Slope72A;
      SlopeB:=Slope72B;
      ExponA:=Expon72A;
      ExponB:=Expon72B;
      Number:=Number72;
      Bpoint:=Bpoint72;
      Method := 72;
    end;

END; {IF DISCON THEN}

  end                                   {end of condition Key='1', best of all}
  else
  begin

//if Key<>1 then a preference is expessed and the calculations begin here

    if Key='3' then goto 43;                  {exponential (Poisson) preferred}

    if Key='4' then goto 44;                                 {Gumbel preferred}

    if Key='5' then goto 45;                        {Gumbel mirrored preferred}

    if Key='6' then goto 46;           {simple exponential (Poisson) preferred}

    if Key='31' then goto 41;                    {Burr preferred}

    if Key='32' then goto 42;                    {Dagum preferred}

    if Key='34' then goto 60;                    {Gompertz preferred}

    if Key='39' then goto 40;                    {KumaraSwamy preferred}

    if Key='51' then goto 51;                    {Gumbel generalized preferred}

    if Key='52' then goto 52;             {generalized Gumbel Mirror preferred}

    if Key='53' then goto 53;                              {Logistic preferred}

    if Key='54' then goto 54;                  {Logarithmic Logistic preferred}

    if Key='55' then goto 55;                  {Exponential Logistic preferred}

    if Key='56' then goto 56;                                {Fisk preferred}

    if Key='57' then goto 57;                               {Weibull preferred}

    if Key='58' then goto 58;        {Fisher-Tippet Type 2, Frechet, preferred}

    if Key='35' then goto 95;        {Fisher-Tippet Type 2 mirrored preferred}

    if Key='33' then goto 93;          {Fisher-Tippet Type 3 mirr. preferred}

    if Key='59' then goto 59;                  {Fisher-Tippet Type 3 preferred}

    if Key='60' then goto 96;                          {Weibull mirr. preferred}

    if Key='61' then goto 61;                          {Erlang preferred}

    if Key='62' then goto 62;                      {Student's distr. preferred}

    if Key='64' then goto 64;                         {Cauchy distr. preferred}

    if Key='65' then goto 65;                         {Cauchy general preferred}

    if Key='66' then goto 66;                 {gen. Poisson mirrored preferred}

    if Key='67' then goto 67;                 {gen. extr. values GEV}

    if Key='68' then goto 68;                       {Laplace}

    if Key='73' then goto 73;                       {Laplace generalized}

    if Key='69' then goto 69;                       {Rayleigh}

    if Key='20' then                                {Normal distribution usual}
    begin
      Method:=20;
      NormDistr;
      MagAv:=MagAv0;
      Stdev:=StDev0;
    end;
    if Key='21' then                            {Normal distribution optimized}
    begin
      Method:=21;
      NormDistr;
      MagAv:=MagAv1;
      Stdev:=StDev1;
      StErr:=StErr1;
    end;
    MainForm.WaitMemo.Lines.Add(' Iterations ....');
    if Key='22' then                                  {Log-Normal distribution}
    begin
      Method:=22;
      NormDistr;
    end;
    if Key='23' then                       {Log- Normal distribution optimized}
    begin
      Method:=23;
      NormDistr;
      MagAv:=MagAv3;
      Stdev:=StDev3;
      StErr:=StErr3;
    end;
    if Key='24' then                                 {Root Normal distribution}
    begin
      Method:=24;
      NormDistr;
      MagAv:=MagAv4;
      Stdev:=StDev4;
      StErr:=StErr4;
    end;
    if Key='25' then                          {Square  Normal distribution}
    begin
      Method:=25;
      NormDistr;
      MagAv:=MagAv5;
      Stdev:=StDev5;
      StErr:=StErr5;
    end;
    if Key='26' then                          {Square  Normal distribution}
    begin
      Method:=26;
      NormDistr;
      MagAv:=MagAv6;
      Stdev:=StDev6;
      StErr:=StErr6;
    end;

  end; {if Key<>1, preference indicated}

  if Key='1' then closefile (ListFile);

end;
{end of procedure Functions}
{--------------------------}


Procedure Calculations;
{---------------------}
begin
  Key := DMCumFreq.Preference;
  Rank;
  NotFit:=false;
  if DMCUmFreq.NrOfData<1 then
  begin
    NotFit:=true;
    exit;
  end;
  Progress:=true;
  Functions;
  if NotFit then exit;
  CalcFreq;
  WriteTmp;
  Table:=true;
  Intervals;
  Table:=false;
  WriteOut;
end; {Calculations}
{-----------------}


{ReadAllData is part of CalcValues}
{---------------------------------}
procedure ReadAllData;

var i : integer;

begin

    assignfile (InFile,'TmpFile.tmp');
    reset (InFile);
    Serial := '   ';
    while not (Serial=' Obs') do
          readln (InFile,Serial);
    for i:=1 to 4 do
        readln (InFile,Serial);

    setlength (VaLow, NumDat+1);
    setlength (ValAv, NumDat+1);
    setlength (ValUp, NumDat+1);

    for i:=1 to NumDat do
    readln (InFile,Xdat1,ValAv[i], ValAv[i],ValAv[i],VaLow[i],ValUp[i]);
                {Xdat=X,ValAv=FrqCalc,ValLow=lower,ValUp=upper}

    for i:=1 to NumDat do
    begin
      VaLow[i]:=VaLow[i]/100;
      if VaLow[i]<=0 then
      begin
        VaLow[i]:=0.2*i/NumDat;
        ValAv[i]:=0.4*i/NumDat;
        ValUp[i]:=1.0*i/NumDat;
      end else
      begin
        ValAv[i]:=ValAv[i]/100;
        ValUp[i]:=ValUp[i]/100;
      end;
    end;

    closefile (InFile);

end;
{end of ReadAllData
{------------------}


{ReadOutputDataFirst is part of MaxMinum}
{---------------------------------------}
procedure ReadOutputDataFirst;

var i : integer;

begin
    assignFile (InFile,'TmpFile.Tmp');
    reset (InFile);
    Serial := '    ';
    while not (Serial=' Obs') do
          readln (InFile,Serial);
    for i:=1 to Start+3 do readln (InFile);
    readln (InFile,Xdat1,SerNr,Ydat1,YrDat1,Notreq,Zdat1,YcDat1);
                {Xdat=X,Ydat=Rank,YrDat=Calc,Zdat=lower,YcDat=upper}
    close (InFile);
end;
{end of ReadOutputDataFirst
{-------------------------}


{MaxMinum is part of CalcValues}
{------------------------------}
procedure MaxMinum;

var ii: integer;

begin

  Xmaxi  := 0;
  Xmini  := 10000000;
  Start := 0;
  for ii:=1 to NumDat do
  begin
    Start:=Start+1;
    ReadOutputDataFirst;
    if Xdat1>Xmaxi  then Xmaxi := Xdat1;
    if Xdat1<Xmini  then Xmini := Xdat1;
  end;
  Xmaxi:=Xmaxi+0.05*(Xmaxi-Xmini);

end;
{end of MaxMinum}
{---------------}


{Normal is part of CalcValues}
{----------------------------}
procedure Normal (YY : real; var XX : real);

var AuxVar,NewFreq,Term1,Term2,Term3,Term4,Term5,TermSum : real;
    MagRed, MagTrf, MagTrSq : real; ii:integer;

begin

  for ii:=1 to 10000 do
  begin

    XX        := 0.001*Xmaxi*ii;
    MagRed    := (XX-Average)/Standard;
    MagTrf    := 1/(1+0.23165*MagRed);
    MagTrSq   := MagTrf*MagTrf;
    Term1     := 0.31938*MagTrf;
    Term2     :=-0.35656*MagTrSq;
    Term3     := 1.78148*MagTrf*MagTrSq;
    Term4     :=-1.82126*MagTrSq*MagTrSq;
    Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
    TermSum   := Term1+Term2+Term3+Term4+Term5;
    AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
    if TermSum<0 then NewFreq:=0
       else NewFreq   := 1-AuxVar*TermSum;
    if NewFreq>YY then
       exit;
  end;

end;
{end of Normal}
{-------------}


{-------------------}
procedure CalcValues;

var kk : integer;
    TmpFile : textfile;
    TmpR, CC : real;

begin

  MaxMinum;

  assignfile(TmpFile,'Temp.tmp');
  {$I-}
  reset(TmpFile);
  {$I+}
  readln (TmpFile,NumDat);
  readln (TmpFile,Method);
  readln (TmpFile,Minim);
  if (Method<6) or (Method>50) then if (Method<>67)
  and (Method<>68) and (Method<>73) then
  begin
    readln (TmpFile,Slope);
    readln (TmpFile,Inter);
  end;
  if (Method=6) then
    readln (TmpFile,Slope);
  if (Method>19) and (Method<50) then
  begin
    readln(TmpFile,Average);
    readln(TmpFile,Standard);
  end;

  close (TmpFile);

  if Method=22 then                              {lognormal simple}
  begin
    if Xmini>0 then
    Xmini:=ln(Xmini)
    else Xmini:=0;
    Xmaxi:=ln(Xmaxi);
  end;
  if Method=23 then                              {lognormal optimized}
  begin
    if Xmini>0 then
    Xmini:=ln(Xmini)
    else Xmini:=0;
    Xmaxi:=ln(Xmaxi);
  end;
  if Method=24 then                              {root normal}
  begin
    Xmini:=sqrt(Xmini);
    Xmaxi:=sqrt(Xmaxi);
  end;
  if Method=25 then                              {square normal}
  begin
    Xmini:=sqr(Xmini);
    Xmaxi:=sqr(Xmaxi);
  end;
  if Method=26 then                              {gen. normal}
  begin
    if Xmini>0 then
    Xmini:=exp(Expon26*ln(Xmini))
    else Xmini:=0;
    Xmaxi:=exp(Expon26*ln(Xmaxi));
  end;

  Start:=0;
  for kk:=1 to NumDat do
  begin

    Start:=Start+1;
    ReadOutputDataFirst;
    YrDat:=YrDat1/100;
    Zdat :=Zdat1/100;
    YcDat:=YcDat1/100;
    if YrDat>=1 then YrDat:=0.9998;
    if ZDat>=1 then ZDat:=0.9997;
    if YcDat>=1 then YcDat:=0.9999;
    if YrDat<=0 then YrDat:=0.0002;
    if ZDat<=0 then ZDat:=0.0003;
    if YcDat<=0 then YcDat:=0.0001;
    if abs(Slope)<0.0000000000001 then Slope:=0.0000000000001;
    CC:=1.1;
    if Minim>=0 then CC:=0;
    
    if Method=3 then
    begin
      ValAv[kk]  := -(Inter+ln(1-YrDat))/Slope + Minim;
      if ValAv[kk]>0 then
         VaLAv[kk] := exp(ln(VaLAv[kk])/Expon3)
      else
         ValAv[kk]:=Mag[kk];
      VaLow[kk]  := -(Inter+ln(1-Zdat))/Slope + Minim;
      if Valow[kk]>0 then
         VaLow[kk] := exp(ln(VaLow[kk])/Expon3)
      else
         Valow[kk]:=CC*Minim;
      ValUp[kk]  := -(Inter+ln(1-Ycdat))/Slope + Minim;
      if ValUp[kk]>0 then
         VaLUp[kk] := exp(ln(VaLUp[kk])/Expon3)
      else
         ValUp[kk]:=Mag[kk];
    end;
    if Method=4 then                                 {Gumbel}
    begin
      ValAv[kk]  := -(ln(-ln(Yrdat))+Inter)/Slope + Minim;
      VaLow[kk]  := -(ln(-ln(Zdat))+Inter)/Slope + Minim;
      ValUp[kk]  := -(ln(-ln(YcDat))+Inter)/Slope + Minim;
    end;
    if Method=5 then                                {Gumbel mirrored}
    begin
      ValAv[kk]  := (-ln(-ln(1-Yrdat))-Inter)/Slope + Minim;
      VaLow[kk]  := (-ln(-ln(1-Zdat))-Inter)/Slope + Minim;
      ValUp[kk]  := (-ln(-ln(1-YcDat))-Inter)/Slope + Minim;
    end;
    if Method=6 then
    begin
      ValAv[kk]  := -ln(1-YrDat)/Slope + Minim;
      if ValAv[kk]>0 then
         VaLAv[kk] := exp(ln(VaLAv[kk]))
      else
         ValAv[kk]:=Mag[kk];
      VaLow[kk]  := -ln(1-Zdat)/Slope + Minim;
      if Valow[kk]>0 then
         VaLow[kk] := exp(ln(VaLow[kk]))
      else
         Valow[kk]:=CC*Minim;
      ValUp[kk]  := -ln(1-Ycdat)/Slope + Minim;
      if ValUp[kk]>0 then
         VaLUp[kk] := exp(ln(VaLUp[kk]))
      else
         ValUp[kk]:=Mag[kk];
    end;
    if Method=7 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterB)/SlopeB + Minim;
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterB)/SlopeB + Minim;
        ValUp[kk]  := (-ln(-ln(1-YcDat))-InterB)/SlopeB + Minim;
      end else
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterA)/SlopeA + Minim;
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterA)/SlopeA + Minim;
        ValUp[kk]  := (-ln(-ln(1-YcDat))-InterA)/SlopeA + Minim;
      end;
    end;
    if Method=8 then
    begin
      if kk>Number then
      begin
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB) + Minim;
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB) + Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB) + Minim;
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA) + Minim;
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA) + Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA) + Minim;
      end;
    end;
    if Method=9 then
    begin
      if kk>Number then
      begin
        if YrDat>0 then
           ValAv[kk]  := -(ln(-ln(Yrdat))+InterB)/SlopeB + Minim
        else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
           VaLow[kk]  := -(ln(-ln(Zdat))+InterB)/SlopeB + Minim
        else
           VaLow[kk]:=Mag[kk];
        if YcDat>0 then
           ValUp[kk]  := -(ln(-ln(Ycdat))+InterB)/SlopeB + Minim
        else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        if YrDat>0 then
           ValAv[kk]  := -(ln(-ln(Yrdat))+InterA)/SlopeA + Minim
        else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
           VaLow[kk]  := -(ln(-ln(Zdat))+InterA)/SlopeA + Minim
        else
           VaLow[kk]:=Mag[kk];
        if YcDat>0 then
           ValUp[kk]  := -(ln(-ln(Ycdat))+InterA)/SlopeA + Minim
        else
           ValUp[kk]:=Mag[kk];
      end;
    end;

    if Method=10 then
    begin
      if kk>Number then
      begin
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB) + Minim;   {Logistic}
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB) + Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB) + Minim;
      end else
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterA)/SlopeA + Minim;  {Gumbel Mirr}
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterA)/SlopeA + Minim;
        ValUp[kk]  := (-ln(-ln(1-Ycdat))-InterA)/SlopeA + Minim;
      end;
    end;

    if Method=11 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := -(ln(-ln(Yrdat))+InterB)/SlopeB + Minim;      {Gumbel}
        VaLow[kk]  := -(ln(-ln(Zdat))+InterB)/SlopeB + Minim;
        ValUp[kk]  := -(ln(-ln(YcDat))+InterB)/SlopeB + Minim;
      end else
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterA)/SlopeA + Minim;  {Gumbel Mirr}
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterA)/SlopeA + Minim;
        ValUp[kk]  := (-ln(-ln(1-Ycdat))-InterA)/SlopeA + Minim;
      end;
    end;

    if Method=12 then
    begin
      if kk>Number then
      begin
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB)+Minim;   {Logistic}
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB)+Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB)+Minim;
      end else
      begin
        ValAv[kk] := -(ln(-ln(Yrdat))+InterA)/SlopeA+Minim;       {Gumbel}
        VaLow[kk] := -(ln(-ln(Zdat))+InterA)/SlopeA+Minim;
        ValUp[kk] := -(ln(-ln(YcDat))+InterA)/SlopeA+Minim;
      end;
    end;

    if Method=13 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterB)/SlopeB + Minim;  {Gumbel Mirr}
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterB)/SlopeB + Minim;
        ValUp[kk]  := (-ln(-ln(1-Ycdat))-InterB)/SlopeB + Minim;
      end else
      begin
        ValAv[kk]  := -(ln(-ln(Yrdat))+InterA)/SlopeA + Minim;      {Gumbel}
        VaLow[kk]  := -(ln(-ln(Zdat))+InterA)/SlopeA + Minim;
        ValUp[kk]  := -(ln(-ln(YcDat))+InterA)/SlopeA + Minim;
      end;
    end;

    if Method=14 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterB)/SlopeB + Minim;  {Gumbel Mirr}
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterB)/SlopeB + Minim;
        ValUp[kk]  := (-ln(-ln(1-Ycdat))-InterB)/SlopeB + Minim;
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA) + Minim;   {Logistic}
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA) + Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA) + Minim;
      end;
    end;

    if Method=15 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := -(ln(-ln(Yrdat))+InterB)/SlopeB + Minim;     {Gumbel}
        VaLow[kk]  := -(ln(-ln(Zdat))+InterB)/SlopeB + Minim;
        ValUp[kk]  := -(ln(-ln(YcDat))+InterB)/SlopeB + Minim;
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA) + Minim;   {Logistic}
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA) + Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA) + Minim;
      end;
    end;

    if Method=16 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-1/SlopeB)*(ln(1-YrDat)+InterB) + Minim;    {Poisson}
        VaLow[kk]  := (-1/SlopeB)*(ln(1-ZDat)+InterB) + Minim;
        ValUp[kk]  := (-1/SlopeB)*(ln(1-YcDat)+InterB) + Minim;
      end else
      begin
        ValAv[kk]  := -(ln(-ln(Yrdat))+InterA)/SlopeA + Minim;      {Gumbel}
        VaLow[kk]  := -(ln(-ln(Zdat))+InterA)/SlopeA + Minim;
        ValUp[kk]  := -(ln(-ln(YcDat))+InterA)/SlopeA + Minim;
      end;
    end;

    if Method=17 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-1/SlopeB)*(ln(1-YrDat)+InterB) + Minim;       {Poisson}
        VaLow[kk]  := (-1/SlopeB)*(ln(1-ZDat)+InterB) + Minim;
        ValUp[kk]  := (-1/SlopeB)*(ln(1-YcDat)+InterB) + Minim;
      end else
      begin
        ValAv[kk]  := (-ln(-ln(1-Yrdat))-InterA)/SlopeA + Minim;  {Gumbel Mirr}
        VaLow[kk]  := (-ln(-ln(1-Zdat))-InterA)/SlopeA + Minim;
        ValUp[kk]  := (-ln(-ln(1-Ycdat))-InterA)/SlopeA + Minim;
      end;
    end;

    if Method=18 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := (-1/SlopeB)*(ln(1-YrDat)+InterB) + Minim;     {Poisson}
        VaLow[kk]  := (-1/SlopeB)*(ln(1-ZDat)+InterB) + Minim;
        ValUp[kk]  := (-1/SlopeB)*(ln(1-YcDat)+InterB) + Minim;
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA) + Minim;   {Logistic}
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA) + Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA) + Minim;
      end;
    end;

    if (Method>19) and (Method<30) then       {Cum. Frq. in st. norm. distr.}
    begin
      Normal (YrDat,ValAv[kk]);
      Normal (Zdat,VaLow[kk]);
      Normal (YcDat,ValUp[kk]);
    end;

    if (Method=20) or (Method=21) then                 {Normal}
    begin
      ValAv[kk]:=ValAv[kk] + Minim;
      VaLow[kk]:=VaLow[kk] + Minim;
      ValUp[kk]:=ValUp[kk] + Minim;
    end;

    if Method=22 then                 {log Normal usual}
    begin
      ValAv[kk]:=exp(ValAv[kk]) + Minim;
      VaLow[kk]:=exp(VaLow[kk]) + Minim;
      ValUp[kk]:=exp(ValUp[kk]) + Minim;
    end;

    if Method=23 then                 {log Normal optimized}
    begin
      ValAv[kk]:=exp(ValAv[kk]) + Minim;
      VaLow[kk]:=exp(VaLow[kk]) + Minim;
      ValUp[kk]:=exp(ValUp[kk]) + Minim;
    end;

    if Method=24 then                {root Normal}
    begin
      ValAv[kk]:=ValAv[kk]*ValAv[kk] + Minim;
      VaLow[kk]:=VaLow[kk]*VaLow[kk] + Minim;
      ValUp[kk]:=ValUp[kk]*ValUp[kk] + Minim;
    end;

    if Method=25 then                 {square normal}
    begin
      if ValAv[kk]>0 then
         ValAv[kk]:=sqrt(ValAv[kk]) + Minim
      else ValAv[kk]:=Minim;
      if VaLow[kk]>0 then
         VaLow[kk]:=sqrt(VaLow[kk]) + Minim
      else VaLow[kk]:=CC*Minim;
      if ValUp[kk]>0 then
         ValUp[kk]:=sqrt(ValUp[kk]) + Minim
      else ValUp[kk]:=Minim;
    end;

    if Method=26 then                 {exp. normal}
    begin
      if ValAv[kk]>0 then
         ValAv[kk]:=exp(ln(ValAv[kk])/Expon26) + Minim
      else
         ValAv[kk]:=Mag[kk];
      if VaLow[kk]>0 then
         VaLow[kk]:=exp(ln(VaLow[kk])/Expon26) + Minim
      else
         VaLow[kk]:=CC*Minim;
      if ValUp[kk]>0 then
         ValUp[kk]:=exp(ln(ValUp[kk])/Expon26) + Minim
      else
         ValUp[kk]:=Mag[kk];
    end;

    if Method=31 then                             {Burr}
    begin
      TmpR := -ln(1-YrDat)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      ValAv[kk]:=BE1B*TmpR+Minim;
      TmpR := -ln(1-ZDat)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      VaLow[kk]:=BE1B*TmpR+Minim;
      TmpR := -ln(1-YcDat)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      ValUp[kk]:=BE1B*TmpR+Minim;
    end;

    if Method=32 then                             {Dagum}
    begin
      TmpR := (ln(YrDat)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      ValAv[kk] := exp(ln(TmpR)/AA1D)+Minim;
      TmpR := (ln(ZDat)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      VaLow[kk] := exp(ln(TmpR)/AA1D)+Minim;
      TmpR := (ln(YcDat)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      ValUp[kk] := exp(ln(TmpR)/AA1D)+Minim;
    end;

    if Method=34 then                            {Gompertz}
    begin
      TmpR :=ln(1-YrDat)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      ValAv[kk]:=exp(TmpR/AA1G)+Minim;
      if Small then ValAv[kk]:=ValAv[kk]-1;
      TmpR :=ln(1-ZDat)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      VaLow[kk]:=exp(TmpR/AA1G)+Minim;
      if Small then VaLow[kk]:=VaLow[kk]-1;
      TmpR :=ln(1-YcDat)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      ValUp[kk]:=Exp(TmpR/AA1G)+Minim;
      if Small then ValUP[kk]:=ValUP[kk]-1;
    end;

    if Method=36 then                            {Kumaraswamy}
    begin
      TmpR:=(ln(1-YrDat))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      ValAv[kk]:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
      TmpR:=(ln(1-ZDat))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      Valow[kk]:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
      TmpR:=(ln(1-YcDat))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      ValUP[kk]:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
    end;

    if Method=51 then                                  {Gumbel generalized}
    begin
      if Slope=0 then Slope:=0.0001;
      if YrDat>0 then
      begin
         ValAv[kk] := -(ln(-ln(Yrdat))+Inter)/Slope;
         if ValAv[kk]>0 then
            ValAv[kk] := exp(ln(ValAv[kk])/Expon51) + Minim
         else ValAv[kk]:=Mag[kk];
      end
      else ValAv[kk]:=Mag[kk];
      if Zdat>0 then
      begin
         VaLow[kk]  := -(ln(-ln(Zdat))+Inter)/Slope;
         if VaLow[kk]>0 then
            VaLow[kk] := exp(ln(VaLow[kk])/Expon51) + Minim
         else VaLow[kk]:=CC*Minim;
      end
      else VaLow[kk]:=CC*Minim;
      if YcDat>0 then
      begin
         ValUp[kk]  := -(ln(-ln(YcDat))+Inter)/Slope;
         if ValUp[kk]>0 then
            ValUp[kk] := exp(ln(ValUp[kk])/Expon51) + Minim
         else ValUp[kk]:=Mag[kk];
      end
      else ValUp[kk]:=Mag[kk];
    end;

    if Method=52 then                              {Gumbel Mirror generalized}
    begin
      ValAv[kk]  := (-ln(-ln(1-Yrdat))-Inter)/Slope ;
      if ValAv[kk]>0 then
         ValAv[kk] := exp(ln(ValAv[kk])/Expon52)+ Minim
      else
         ValAv[kk]:=Mag[kk];
      VaLow[kk]  := (-ln(-ln(1-Zdat))-Inter)/Slope;
      if VaLow[kk]>0 then
         VaLow[kk] := exp(ln(VaLow[kk])/Expon52)+ Minim
      else
         VaLow[kk]:=CC*Minim;
      ValUp[kk]  := (-ln(-ln(1-YcDat))-Inter)/Slope;
      if ValUp[kk]>0 then
         ValUp[kk] := exp(ln(ValUp[kk])/Expon52)+ Minim
      else
         ValUp[kk]:=Mag[kk];
    end;

    if Method=53 then                                                {Logistic}
    begin
      ValAv[kk] := (1/Slope)*(ln(1/YrDat-1)-Inter) + Minim;
      VaLow[kk] := (1/Slope)*(ln(1/ZDat-1)-Inter) + Minim;
      ValUp[kk] := (1/Slope)*(ln(1/YcDat-1)-Inter) + Minim;
    end;

    if Method=54 then
    begin
      ValAv[kk] := (1/Slope)*(ln(1/YrDat-1)-Inter);
      if ValAv[kk]>0 then
         ValAv[kk]:=exp(ValAv[kk]) + Minim
      else ValAv[kk]:=Mag[kk];
      VaLow[kk] := (1/Slope)*(ln(1/ZDat-1)-Inter);
      if VaLow[kk]>0 then
         VaLow[kk]:=exp(VaLow[kk]) + Minim
      else VaLow[kk]:=CC*Minim;
      ValUp[kk] := (1/Slope)*(ln(1/YcDat-1)-Inter);
      if ValUp[kk]>0 then
         ValUp[kk]:=exp(ValUp[kk]) + Minim
      else ValUp[kk]:=Mag[kk];
    end;

    if Method=55 then                                    {generalized logistic}
    begin
      ValAv[kk] := (1/Slope)*(ln(1/YrDat-1)-Inter);
      if ValAv[kk]>0 then
         ValAv[kk] := exp(ln(ValAv[kk])/Expon55) + Minim
      else
         ValAv[kk] := Mag[kk];
      VaLow[kk] := (1/Slope)*(ln(1/ZDat-1)-Inter);
      if Valow[kk]>0 then
         VaLow[kk]:=exp(ln(VaLow[kk])/Expon55) + Minim
      else
         Valow[kk]:=CC*Minim;
      ValUp[kk] := (1/Slope)*(ln(1/YcDat-1)-Inter);
      if ValUp[kk]>0 then
         ValUp[kk]:=exp(ln(ValUp[kk])/Expon55) + Minim
      else
         ValUp[kk]:=Mag[kk];
    end;

    if Method=70 then
    begin
      if kk>Number then
      begin
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
        else
           ValUp[kk] := Mag[kk];
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        else
           ValUp[kk] := Mag[kk];
      end;
    end;
    
    if Method=71 then
    begin
      if kk>Number then
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterB)/SlopeB;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
        end else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterB)/SlopeB;
          if VaLow[kk]>0 then
             VaLow[kk] := exp(ln(Valow[kk])/ExponB) + Minim
        end else
           VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterB)/SlopeB;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
        end else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterA)/SlopeA;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        end else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterA)/SlopeA;
          if VaLow[kk]>0 then
             VaLow[kk] := exp(ln(Valow[kk])/ExponA) + Minim
        end else
           VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterA)/SlopeA;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        end else
           ValUp[kk]:=Mag[kk];
      end;
    end;

    if Method=72 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := -(InterB+ln(1-YrDat))/SlopeB + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponB)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterB+ln(1-ZDat))/SlopeB + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterB+ln(1-YcDat))/SlopeB + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(VaLUp[kk])/ExponB)
        else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        ValAv[kk]  := -(InterA+ln(1-YrDat))/SlopeA + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponA)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterA+ln(1-ZDat))/SlopeA + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterA+ln(1-YcDat))/SlopeA + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(ValUp[kk])/ExponA)
        else
           ValUP[kk]:=Mag[kk];
      end;
    end;

    if Method=80 then
    begin
      if kk>Number then
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterB)/SlopeB;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
          else
            ValAv[kk]:=Mag[kk];
        end else
            ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterB)/SlopeB;
          if VaLow[kk]>0 then
             VaLow[kk] := exp(ln(Valow[kk])/ExponB) + Minim
          else
            VaLow[kk]:=CC*Minim;
        end else
            VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterB)/SlopeB;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
          else
            ValUp[kk]:=Mag[kk];
        end else
            ValUp[kk]:=Mag[kk];
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        else
           ValUp[kk] := Mag[kk];
      end;
    end;

    if Method=81 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := -(InterB+ln(1-YrDat))/SlopeB + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponB)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterB+ln(1-ZDat))/SlopeB + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterB+ln(1-YcDat))/SlopeB + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(VaLUp[kk])/ExponB)
        else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        ValAv[kk] := (1/SlopeA)*(ln(1/YrDat-1)-InterA);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeA)*(ln(1/ZDat-1)-InterA);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeA)*(ln(1/YcDat-1)-InterA);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        else
           ValUp[kk] := Mag[kk];
      end;
    end;

    if Method=82 then
    begin
      if kk>Number then
      begin
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
        else
           ValUp[kk] := Mag[kk];
      end else
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterA)/SlopeA;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        end else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterA)/SlopeA;
          if VaLow[kk]>0 then
             VaLow[kk] := exp(ln(Valow[kk])/ExponA) + Minim
        end else
           VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterA)/SlopeA;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        end else
           ValUp[kk]:=Mag[kk];
      end;
    end;

    if Method=83 then
    begin
      if kk>Number then
      begin
        ValAv[kk]  := -(InterB+ln(1-YrDat))/SlopeB + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponB)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterB+ln(1-ZDat))/SlopeB + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterB+ln(1-YcDat))/SlopeB + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(VaLUp[kk])/ExponB)
        else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterA)/SlopeA;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponA) + Minim
        end else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterA)/SlopeA;
          if VaLow[kk]>0 then
             VaLow[kk] := exp(ln(Valow[kk])/ExponA) + Minim
        end else
           VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterA)/SlopeA;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponA) + Minim
        end else
           ValUp[kk]:=Mag[kk];
      end;
    end;

    if Method=84 then
    begin
      if kk>Number then
      begin
        if ExponB<0.1 then ExponB:=0.1;
        ValAv[kk] := (1/SlopeB)*(ln(1/YrDat-1)-InterB);
        if ValAv[kk]>0 then
           ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
        else
           ValAv[kk] := Mag[kk];
        VaLow[kk] := (1/SlopeB)*(ln(1/ZDat-1)-InterB);
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponB) + Minim
        else
           VaLow[kk] := CC*Minim;
        ValUp[kk] := (1/SlopeB)*(ln(1/YcDat-1)-InterB);
        if ValUp[kk]>0 then
           ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
        else
           ValUp[kk] := Mag[kk];
      end else
      begin
        ValAv[kk]  := -(InterA+ln(1-YrDat))/SlopeA + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponA)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterA+ln(1-ZDat))/SlopeA + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterA+ln(1-YcDat))/SlopeA + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(VaLUp[kk])/ExponA)
        else
           ValUp[kk]:=Mag[kk];
      end;

    end;

    if Method=85 then
    begin
      if kk>Number then
      begin
        if YrDat>0 then
        begin
          ValAv[kk] := -(ln(-ln(Yrdat))+InterB)/SlopeB;
          if ValAv[kk]>0 then
             ValAv[kk] := exp(ln(ValAv[kk])/ExponB) + Minim
        end else
           ValAv[kk]:=Mag[kk];
        if ZDat>0 then
        begin
          Valow[kk] := -(ln(-ln(Zdat))+InterB)/SlopeB;
          if VaLow[kk]>0   then
             VaLow[kk] := exp(ln(Valow[kk])/ExponB) + Minim
        end else
           VaLow[kk]:=CC*Minim;
        if YcDat>0 then
        begin
          ValUp[kk] := -(ln(-ln(Ycdat))+InterB)/SlopeB;
          if ValUp[kk]>0 then
             ValUp[kk] := exp(ln(ValUp[kk])/ExponB) + Minim
        end else
           ValUp[kk]:=Mag[kk];
      end else
      begin
        ValAv[kk]  := -(InterA+ln(1-YrDat))/SlopeA + Minim;
        if ValAv[kk]>0 then
           VaLAv[kk] := exp(ln(VaLAv[kk])/ExponA)
        else
           ValAv[kk]:=Mag[kk];
        VaLow[kk]  := -(InterA+ln(1-ZDat))/SlopeA + Minim;
        if VaLow[kk]>0 then
           VaLow[kk] := exp(ln(VaLow[kk])/ExponA)
        else
           VaLow[kk]:=CC*Minim;
        ValUp[kk]  := -(InterA+ln(1-YcDat))/SlopeA + Minim;
        if ValUp[kk]>0 then
           VaLUp[kk] := exp(ln(ValUp[kk])/ExponA)
        else
           ValUP[kk]:=Mag[kk];
      end;
    end;

    if Method=56 then                               {Fisk}
    begin
      TmpR:=ln(1/(1-Yrdat) -1);
      ValAv[kk] := exp ( TmpR/Slope +ln (Inter));
      TmpR:=ln(1/(1-Zdat) -1);
      VaLow[kk] := exp ( TmpR/Slope +ln (Inter));
      TmpR:=ln(1/(1-Ycdat) -1);
      ValUp[kk] := exp ( TmpR/Slope +ln (Inter));
    end;

    if Method=57 then                               {Weibull}
    begin
      ValAv[kk]  := exp((ln(-ln(1-Yrdat))-Inter)/Slope) + Minim;
      VaLow[kk]  := exp((ln(-ln(1-Zdat))-Inter)/Slope) + Minim;
      ValUp[kk]  := exp((ln(-ln(1-YcDat))-Inter)/Slope) + Minim;
    end;

    if Method=58 then                               {Frechet}
    begin
      if YrDat>0 then
         ValAv[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(YrDat)))
                      + Bound58 + Minim
      else ValAv[kk]:=Mag[kk];
      if Zdat>0 then
         VaLow[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(ZDat)))
                      + Bound58 + Minim
      else Valow[kk]:=Mag[kk];
      if YcDat>0 then
         ValUp[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(YcDat)))
                       + Bound58 + Minim
      else ValUp[kk]:=Mag[kk];
    end;

    if Method=33 then                               {F-T type 3}
    begin
      if YrDat>0 then
         ValAv[kk] := Bound33-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-YrDat)))
                      + Minim
      else ValAv[kk]:= Mag[kk];
      if Zdat>0 then
         VaLow[kk] := Bound33-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-ZDat)))
                      + Minim
      else Valow[kk]:= Mag[kk];
      if YcDat>0 then
         ValUp[kk] := Bound33-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-YcDat)))
                      + Minim
      else ValUp[kk]:= Mag[kk];
    end;

    if Method=35 then                               {Frechet mirr.}
    begin
      if YrDat>0 then
         ValAv[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-YrDat)))
                      + Bound35 + Minim
      else ValAv[kk]:=Mag[kk];
      if Zdat>0 then
         VaLow[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-ZDat)))
                      + Bound35 + Minim
      else Valow[kk]:=Mag[kk];
      if YcDat>0 then
         ValUp[kk] := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-YcDat)))
                       + Bound35 + Minim
      else ValUp[kk]:=Mag[kk];
    end;

    if Method=59 then                               {F-T type 3}
    begin
      if YrDat>0 then
         ValAv[kk] := Bound59-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(YrDat)))
                      + Minim
      else ValAv[kk]:= Mag[kk];
      if Zdat>0 then
         VaLow[kk] := Bound59-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(ZDat)))
                      + Minim
      else Valow[kk]:= Mag[kk];
      if YcDat>0 then
         ValUp[kk] := Bound59-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(YcDat)))
                      + Minim
      else ValUp[kk]:= Mag[kk];
    end;
    if Method=60 then                               {Mirr. Weibull}
    begin
      ValAv[kk]  := exp((ln(-ln(Yrdat))-Inter)/Slope) + Minim;
      VaLow[kk]  := exp((ln(-ln(Zdat))-Inter)/Slope) + Minim;
      ValUp[kk]  := exp((ln(-ln(YcDat))-Inter)/Slope) + Minim;
    end;
    if Method=61 then                               
    begin
      ValAv[kk]  := Mag[kk];
      VaLow[kk]  := 0.9*Mag[kk];
      ValUp[kk]  := 1.1*Mag[kk];
    end;
    if Method=62 then                               {Student's with d.f.=1}
    begin
      ValAv[kk]  := tan(pi*(YrDat-0.5));
         ValAv[kk]:= StErr*ValAv[kk] + MagAv + Minim;
      VaLow[kk]  := tan(pi*(Zdat-0.5));
         VaLow[kk]:=StErr*VaLow[kk] + MagAv + Minim;
      ValUp[kk]  := tan(pi*(YcDat-0.5));
         ValUp[kk]:=StErr*ValUp[kk] + MagAv + Minim;
    end;

    if Method=63 then                               {Student's with d.f.=2}
    begin
      TmpR := sqrt(2)*(2*YrDat-1);
      TmpR := TmpR/sqrt(1-sqr(2*YrDat-1));
      ValAv[kk]:=StErrS*TmpR + MagAvS + Minim;
      TmpR := sqrt(2)*(2*Zdat-1);
      TmpR := TmpR/sqrt(1-sqr(2*Zdat-1));
      VaLow[kk]:=StErrS*TmpR + MagAvS + Minim;
      TmpR := sqrt(2)*(2*YcDat-1);
      TmpR := TmpR/sqrt(1-sqr(2*YcDat-1));
      ValUp[kk]:=StErrS*TmpR + MagAvS + Minim;
    end;

    if Method=64 then                               {Cauchy}
    begin
      ValAv[kk] := (tan(pi*(YrDat-0.5))-Inter)/Slope + Minim;
      VaLow[kk] := (tan(pi*(ZDat-0.5))-Inter)/Slope + Minim;
      ValUp[kk] := (tan(pi*(YcDat-0.5))-Inter)/Slope + Minim;
    end;

    if Method=65 then                               {Cauchy generalized}
    begin
      ValAv[kk] := (tan(pi*(YrDat-0.5))-Inter)/Slope;
      if ValAv[kk]>0 then
         ValAv[kk] := exp(ln(ValAv[kk])/Expon65) + Minim
      else
         ValAv[kk] := Mag[kk];
      VaLow[kk] := (tan(pi*(ZDat-0.5))-Inter)/Slope;
      if VaLow[kk]>0 then
         VaLow[kk] := exp(ln(VaLow[kk])/Expon65) + Minim
      else
         VaLow[kk] := CC*Minim;
      ValUp[kk] := (tan(pi*(YcDat-0.5))-Inter)/Slope;
      if ValUp[kk]>0 then
         ValUp[kk] := exp(ln(ValUp[kk])/Expon65) + Minim
      else
         ValUp[kk] := Mag[kk];
    end;

    if Method=66 then
    begin
      ValAv[kk]  := -(Inter+ln(YrDat))/Slope;
      if ValAv[kk]>0 then
         VaLAv[kk] := exp(ln(VaLAv[kk])/Expon66) + Minim
      else
         ValAv[kk]:=Mag[kk];
      VaLow[kk]  := -(Inter+ln(Zdat))/Slope;
      if Valow[kk]>0 then
         VaLow[kk] := exp(ln(VaLow[kk])/Expon66) + Minim
      else
         Valow[kk]:=CC*Minim;
      ValUp[kk]  := -(Inter+ln(Ycdat))/Slope;
      if ValUp[kk]>0 then
         VaLUp[kk] := exp(ln(VaLUp[kk])/Expon66) + Minim
      else
         ValUp[kk]:=Mag[kk];
    end;

    if Method=67 then                                         {GEV}
    begin
      TmpR:=-Expon67*ln(-ln(YrDat));
      ValAv[kk]:=StErr67*(exp(TmpR)-1)/Expon67+MagAv67 + Minim;
      TmpR:=-Expon67*ln(-ln(ZDat));
      VaLow[kk]:=StErr67*(exp(TmpR)-1)/Expon67+MagAv67 + Minim;
      TmpR:=-Expon67*ln(-ln(YcDat));
      ValUp[kk]:=StErr67*(exp(TmpR)-1)/Expon67+MagAv67 + Minim;
    end;

    if Method=68 then                                         {Laplace}
    begin
      if YrDat<0.5 then
         ValAv[kk]:=BB1*ln(2*YrDat)+BoundL1 + Minim
      else ValAv[kk]:=-BB2*Ln(2-2*YrDat)+BoundL1 + Minim;
      if ZDat<0.5 then
         VaLow[kk]:=BB1*ln(2*ZDat)+BoundL1 + Minim
      else VaLow[kk]:=-BB2*Ln(2-2*ZDat)+BoundL1 + Minim;
      if YcDat<0.5 then
         ValUp[kk]:=BB1*ln(2*YcDat)+BoundL1 + Minim
      else ValUp[kk]:=-BB2*Ln(2-2*YcDat)+BoundL1 + Minim;
    end;

    if Method=69 then                                    {Rayleigh}
    begin
      TmpR      := -ln(1-YrDat)*Slope69;
      ValAv[kk] := exp(ln(TmpR)/Expon69) + Minim;
      TmpR      := -ln(1-ZDat)*Slope69;
      VaLow[kk] := exp(ln(TmpR)/Expon69) + Minim;
      TmpR      := -ln(1-YcDat)*Slope69;
      ValUp[kk] := exp(ln(TmpR)/Expon69) + Minim;
    end;

    if Method=73 then                                     {Laplace generalized}
    begin
      if YrDat<0.5 then
      begin
         ValAv[kk]:=BB1G*ln(2*YrDat)+BoundLG;
         if ValAv[kk]>0 then
            ValAv[kk] := exp(ln(ValAv[kk])/Expon73A) + Minim
         else
            ValAv[kk] := Mag[kk];
      end else
      begin
         ValAv[kk]:=-BB2G*Ln(2-2*YrDat)+BoundLG;
         if ValAv[kk]>0 then
            ValAv[kk] := exp(ln(ValAv[kk])/Expon73B) + Minim
         else
            ValAv[kk] := Mag[kk];
      end;
      if ZDat<0.5 then
      begin
         VaLow[kk]:=BB1G*ln(2*ZDat)+BoundLG;
         if VaLow[kk]>0 then
            VaLow[kk] := exp(ln(VaLow[kk])/Expon73A) + Minim
         else
            VaLow[kk] := Mag[kk];
      end else
      begin
         VaLow[kk]:=-BB2G*Ln(2-2*ZDat)+BoundLG;
         if VaLow[kk]>0 then
            VaLow[kk] := exp(ln(VaLow[kk])/Expon73B) + Minim
         else
            VaLow[kk] := Mag[kk];
      end;
      if YcDat<0.5 then
      begin
         ValUp[kk]:=BB1G*ln(2*YcDat)+BoundLG;
         if ValUp[kk]>0 then
            ValUp[kk] := exp(ln(ValUp[kk])/Expon73A) + Minim
         else
            ValUp[kk] := Mag[kk];
      end else
      begin
         ValUp[kk]:=-BB2G*Ln(2-2*YcDat)+BoundLG;
         if ValUp[kk]>0 then
            ValUp[kk] := exp(ln(ValUp[kk])/Expon73B) + Minim
         else
            ValUp[kk] := Mag[kk];
      end;
    end;

  end; {end of kk loop}

  for kk:=2 to NumDat do
  begin
    if ValUp[kk]<ValUp[kk-1] then ValUp[kk]:=ValUp[kk-1];
    if VaLow[kk]<VaLow[kk-1] then VaLow[kk]:=VaLow[kk-1];
  end;

end;
{end of CalcValues}
{-----------------}



{WriteOutValues is part of CalcValues}
{------------------------------------}
procedure WriteOutValues;

var
ii     : integer;

begin
  assignfile (OutFile,'Values.tmp');
  {$I-} rewrite (OutFile); {$I+}

  writeln (OutFile);
  writeln (OutFile);
  writeln (OutFile,' Confidence limits of calculated X-values');
  writeln (OutFile,' ----------------------------------------------------------');
  writeln (OutFile,'   Observed            Calculated      90% confidence limit  ');
  writeln (OutFile,'   X-value   Serial    X-Value         of calulated X-Value  ');
  writeln (OutFile,'   Ranked     No.                      Lower        Upper    ');
  writeln (OutFile,' ----------------------------------------------------------');

  Start := 0;
  for ii:=1 to NumDat do
  begin
    Start:=Start+1;
    ReadOutputDataFirst;
    if (Mag[1]>=0) and (VaLow[ii]<0) then VaLow[ii]:=0;
    if ValUp[ii]<=ValAv[ii] then ValUp[ii]:=ValAv[ii]*1.01;
    writeln (OutFile,
            Xdat1:8:Decim,SerNr:8,ValAv[ii]:13:Decim,
            VaLow[ii]:15:Decim,ValUp[ii]:15:Decim);
  end;
  writeln (OutFile,' ----------------------------------------------------------');
  Result2:=0;
  Result3:=0;
  for ii:=1 to NumDat do
  begin
    Result2:=Result2+Mag[ii];
    Result3:=Result3+sqr(Mag[ii]-ValAv[ii]);
  end;
  Result2:=Result2/NumDat;
  for ii:=1  to Numdat do Result1:=Result1+sqr(Mag[ii]-Result2);
  if (Result1>0) and (Result3<Result1) then Result2:=sqrt(1-Result3/Result1)
  else Result2:=-0;
  if Result2>0.99999 then Result2:=0.99999;
  writeln (OutFile,' Efficiency coefficient (R) of calculated and observed ');
  writeln (OutFile,' data values :',sqrt(Result2):10:5);
  writeln (OutFile);
  close (OutFile);

  DMCumFreq.FileName := ChangeFileExt (DMCumFreq.FileName,'.aux');
  if FileExists (DMCumFreq.FileName) then
     deletefile (DMCumFreq.FileName)
  else
     Result3:=0;
  assignfile (OutFile,DMCumFreq.FileName);
  {$I-} rewrite (OutFile); {$I+}
  writeln (OutFile,' Parameters for internal use, do not remove.');
  writeln (OutFile,Method);
  if ((Method<6) or (Method>50)) or (Method=33) or (Method=35)
  then if Method<70 then if (Method<>36) and (Method<>62) and (Method<>63) then
  begin
    writeln (OutFile,Slope);
    writeln (OutFile,Inter);
    if Method=3 then writeln (OutFile,Expon3);
    if Method=51 then writeln (OutFile,Expon51);
    if Method=52 then writeln (OutFile,Expon52);
    if Method=55 then writeln (OutFile,Expon55);
    if Method=58 then writeln (OutFile,Bound58);
    if Method=33 then writeln (OutFile,Bound33);
    if Method=35 then writeln (OutFile,Bound35);
    if Method=59 then writeln (OutFile,Bound59);
    if Method=65 then writeln (OutFile,Expon65);
    if Method=66 then writeln (OutFile,Expon66);
    if Method=67 then
    begin
      Writeln (OutFile,Expon67);
      writeln (OutFile,MagAv67);
      writeln (OutFile,StErr67);
    end;
    if Method=68 then
    begin
      writeln (OutFile,BoundL1);
      Writeln (OutFile,BB1);
      writeln (OutFile,BB2);
    end;
    if Method=69 then
    begin
      writeln (OutFile,Expon69);
      Writeln (OutFile,Slope69);
    end;
  end;

  if Method=6 then writeln (OutFile,Slope);

  if (Method>6) and (Method<20) then
  begin
    writeln (OutFile,SlopeA);
    writeln (OutFile,InterA);
    writeln (OutFile,SlopeB);
    writeln (OutFile,InterB);
    writeln (OutFile,Bpoint+Minim);
  end;

  if Method=20 then
  begin
    writeln (OutFile,MagAv0);
    writeln (OutFile,StDev0);
  end;
  if Method=21 then
  begin
    writeln (OutFile,MagAv1);
    writeln (OutFile,StDev1);
  end;
  if Method=22 then
  begin
    writeln (OutFile,MagAv2);
    writeln (OutFile,StDev2);
  end;
  if Method=23 then
  begin
    writeln (OutFile,MagAv3);
    writeln (OutFile,StDev3);
  end;
  if Method=24 then
  begin
    writeln (OutFile,MagAv4);
    writeln (OutFile,StDev4);
  end;
  if Method=25 then
  begin
    writeln (OutFile,MagAv5);
    writeln (OutFile,StDev5);
  end;
  if Method=26 then
  begin
    writeln (OutFile,Average6);
    writeln (OutFile,StDev6);
    writeln (OutFile,Expon26);
  end;

  if Method=31 then                               {Burr}
  begin
    writeln (OutFile,Inter31);
    writeln (OutFile,AA1B);
    writeln (OutFile,Slope31);
    writeln (OutFile,BE1B);
    writeln (OutFile,Bur)
  end;

  if Method=32 then                               {Dagum}
  begin
    writeln (OutFile,Inter32);
    writeln (OutFile,AA1D);
    writeln (OutFile,Slope32);
    writeln (OutFile,BE1D);
    writeln (OutFile,Dag);
  end;

  if Method=34 then                               {Gompertz}
  begin
    if Small then writeln (OutFile,1)
    else writeln (OutFile,1);
    writeln (OutFile,BE1G);
    writeln (OutFile,AA1G);
    writeln (OutFile,Slope34);
  end;

  if Method=36 then                               {Kumaraswamy}
  begin
    writeln (OutFile,MaxVal);
    writeln (OutFile,Expon36);
    writeln (OutFile,Slope36);
  end;

  if Method=73 then                      {Laplace generalized}
  begin
    BoundL2:=exp(ln(BoundLG)/Expon73A);
    writeln (OutFile,BoundL2);
    Writeln (OutFile,BB1G);
    writeln (OutFile,BB2G);
    Writeln (OutFile,Expon73A);
    writeln (OutFile,Expon73B);
  end;

  if (Method=62) or (Method=63) then
  begin
    writeln (OutFile,MagAvS);
    writeln (OutFile,StErrS);
  end;

  if (Method>69) and (Method<>73) then
  begin
    writeln (OutFile,ExponA);
    writeln (OutFile,ExponB);
    writeln (OutFile,SlopeA);
    writeln (OutFile,InterA);
    writeln (OutFile,SlopeB);
    writeln (OutFile,InterB);
    writeln (OutFile,Bpoint+Minim);
  end;

  writeln (OutFile, Minim);

  close (OutFile);
  DMCumFreq.FileName := ChangeFileExt (DMCumFreq.FileName,'.out');

end;
{end of WriteOutValues}
{---------------------}


{------------------}
Procedure CumValues;

label 1;
begin
  ReadAllData;
  CalcValues;                                {conf. belt of calculated values}
  if DMCumFreq.NrOfData>250 then
     MainForm.WaitMemo.Lines.Add(' Almost done ...');
  WriteOutValues;
  assignfile (Tmp1File,'TmpFile.Tmp');
  {$I-} reset (Tmp1File); {$I+}
  assignfile (Tmp2File,'Values.Tmp');
  {$I-} reset (Tmp2File); {$I+}
  FileToOpen := ChangeFileExt (DMCumFreq.FileName,'.out');
  assignfile (OutFile, FileToOpen);
  {$I-} rewrite (OutFile); {$I+}
  while not eof(Tmp1File) do
  begin
    readln(Tmp1File,Line);
    writeln(OutFile,Line);
  end;
  if Method<>61 then
  begin
    while not eof(Tmp2File) do
    begin
      readln(Tmp2File,Line);
      writeln(OutFile,Line);
    end;
    close (Tmp2File);
    deletefile('Values.Tmp');
  end;
  close (OutFile);
  close (Tmp1File);
  deletefile('TmpFile.Tmp');
  if Method=61 then
  begin
    close (Tmp2File);
    deletefile('Values.Tmp');
  end;
  deletefile (DMCUmFreq.FileName+'.Tmp');
  deletefile ('Temp.Tmp');
  CalcDone:=true;
end;
{end of CumValues}
{****************}


{--------------------}
procedure DefineDistr;
begin
  with DMCumFreq do
  begin
    if DistrType=0 then Distrib:='';
    if DistrType=1 then Distrib:='Generalized linear';
    if DistrType=2 then Distrib:='Generalized linear exponential';
    if DistrType=3 then Distrib:='Generalized exponential distribution';
    if DistrType=4 then Distrib:='Gumbel distribution';
    if DistrType=5 then Distrib:='Mirrored Gumbel distribution';
    if DistrType=6 then Distrib:='Simple exponential distribution';
    if DistrType=31 then Distrib:='Burr (generalized Pareto-Lomax) distribution';
    if DistrType=32 then Distrib:='Dagum (mirrorred Burr) distribution';
    if DistrType=34 then Distrib:='Generalized Gompertz distribution';
    if DistrType=51 then Distrib:='Generalized Gumbel distribution';
    if DistrType=52 then Distrib:='Generalized mirrored Gumbel distribution';
    if DistrType=53 then Distrib:='Logistic distribution';
    if DistrType=54 then Distrib:='Log-logistic distribution';
    if DistrType=55 then Distrib:='Generalized logistic distribution';
    if DistrType=56 then Distrib:='Fisk distribution adjusted';
    if DistrType=57 then Distrib:='Weibull distribution';
    if DistrType=58 then Distrib:='Frechet distribution';
    if DistrType=33 then Distrib:='Fisher-Tippett type 3 mirrored';
    if DistrType=35 then Distrib:='Mirrored Frechet distribution';
    if DistrType=36 then Distrib:='Kumaraswamy distribution';
    if DistrType=59 then Distrib:='Fisher-Tippett type 3 distribution';
    if DistrType=60 then Distrib:='Mirrored Weibull distribution';
    if DistrType=61 then Distrib:='Gamma (Erlang) distribution';
    if DistrType=62 then Distrib:='Student t-distribution with 1 d.f.';
    if DistrType=63 then Distrib:='Student t-distribution with 2 d.f.';
    if DistrType=64 then Distrib:='Cauchy distribution';
    if DistrType=65 then Distrib:='Generalized Cauchy distribution';
    if DistrType=66 then Distrib:='Mirrored Poisson distribution';
    if DistrType=67 then Distrib:='Generalized extreme value (GEV) distribution';
    if DistrType=68 then Distrib:='Laplace distribution';
    if DistrType=69 then Distrib:='Generalized Rayleigh distribution';
    if DistrType=7 then Distrib:='Composite Gumbel mirrored distribution';
    if DistrType=8 then Distrib:='Composite logistic distribution';
    if DistrType=9 then Distrib:='Composite Gumbel distribution';
    if DistrType=10 then Distrib:='Composite Gumbel mirrored + logistic'+
                                  ' distribution';
    if DistrType=11 then Distrib:=
                    'Composite mirrored Gumbel + standard Gumbel distribution';
    if DistrType=12 then Distrib:=
                    'Composite Gumbel + logistic distribution';
    if DistrType=13 then Distrib:=
                    'Composite standard Gumbel + mirrored Gumbel  distribution';
    if DistrType=14 then Distrib:='Composite logistic + mirrored Gumbel'+
                                  ' distribution';
    if DistrType=15 then Distrib:='Composite logistic + Gumbel distribution';
    if DistrType=16 then Distrib:='Composite Gumbel + Poisson distribution';
    if DistrType=17 then Distrib:='Composite Gumbel mirrored + Poisson'+
                                  ' distribution';
    if DistrType=18 then Distrib:='Composite lLogistic + Poisson distribution';
    if DistrType=20 then Distrib:='Normal distribution usual';
    if DistrType=21 then Distrib:='Normal distribution optimized';
    if DistrType=22 then Distrib:='Log-normal distribution usual';
    if DistrType=23 then Distrib:='Log-normal distribution optimized';
    if DistrType=24 then Distrib:='Root-normal distribution';
    if DistrType=25 then Distrib:='Square-normal distribution';
    if DistrType=26 then Distrib:='Generalized normal distribution';
    if DistrType=70 then Distrib:='Composite generalized logistic distribution';
    if DistrType=71 then Distrib:='Composite generalized Gumbel distribution';
    if DistrType=72 then Distrib:='Composite generalized Poisson distribution';
    if DistrType=73 then Distrib:='Generalized Laplace distribution';
    if DistrType=80 then Distrib:='Composite logistic and Gumbel distribution';
    if DistrType=81 then Distrib:='Composite logistic and Poisson distribution';
    if DistrType=82 then Distrib:='Composite Gumbel and logistic distribution';
    if DistrType=83 then Distrib:='Composite Gumbel and Poisson distribution';
    if DistrType=84 then Distrib:='Composite Poisson and logistic distribution';
    if DistrType=85 then Distrib:='Composite Poisson and Gumbel distribution';
  end;
end;
{end of DefineDistr}

end.
